// SSM_Auxiliary.h: interface for the SSM_Auxiliary class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SSM_AUXILIARY_H__9B84C4F6_FB2C_473A_BD6D_E768B40FA0C3__INCLUDED_)
#define AFX_SSM_AUXILIARY_H__9B84C4F6_FB2C_473A_BD6D_E768B40FA0C3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class SSM_Auxiliary  
{
public:
	SSM_Auxiliary();
	virtual ~SSM_Auxiliary();

	
	static unsigned char* key_operation(int operation_code);


	/**
	 * This function performs all necessary checks, that are possible at this
	 * layer. Calls subsequent check-functions for each part that may be checked.
	 * @param buffer pointer to the start of the received datagram (SCTP PDU)
	 * @param length size of the buffer
	 * @return 0 if validation failed, 1 if successful, -1 if any error ocurred
	 */
	static int validate_datagram(unsigned char *buffer, int length);

	static int aux_insert_checksum(unsigned char *buffer, int length);

	static int set_checksum_algorithm(int algorithm);

	static int insert_adler32(unsigned char *buffer, int length);
	static int insert_crc32(unsigned char *buffer, int length);
	static int validate_adler32(unsigned char *header_start, int length);
	static int validate_crc32(unsigned char *buffer, int length);

	static unsigned long generate_crc32c(unsigned char *buffer, int length);

	static int validate_size(unsigned char *header_start, int length);

	static unsigned int adler32(unsigned int adler, const unsigned char *buf, unsigned int len);
};

#endif // !defined(AFX_SSM_AUXILIARY_H__9B84C4F6_FB2C_473A_BD6D_E768B40FA0C3__INCLUDED_)
