// SSM_Md5.h: interface for the SSM_Md5 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SSM_MD5_H__DF6D0B0A_AA49_4065_9C95_F4B16A2C2375__INCLUDED_)
#define AFX_SSM_MD5_H__DF6D0B0A_AA49_4065_9C95_F4B16A2C2375__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



#include <string.h>

/* POINTER defines a generic pointer type */
typedef unsigned char *POINTER;

/* UINT2 defines a two byte word */
typedef unsigned short int UINT2;

/* UINT4 defines a four byte word */
typedef unsigned long int UINT4;

/* PROTO_LIST is defined depending on how PROTOTYPES is defined above.
If using PROTOTYPES, then PROTO_LIST returns the list, otherwise it
  returns an empty list.
 */

/* MD5 context. */
typedef struct
{
    UINT4 state[4];             /* state (ABCD) */
    UINT4 count[2];             /* number of bits, modulo 2^64 (lsb first) */
    unsigned char buffer[64];   /* input buffer */
} MD5_CTX;




#define MD5_memcpy(output,input,len) 	memcpy(output,input,len)
#define MD5_memset(output,input,len) 	memset(output,input,len)


class SSM_Md5  
{
public:
	SSM_Md5();
	virtual ~SSM_Md5();

	static void MD5Init (MD5_CTX *);
	static void MD5Update (MD5_CTX *, unsigned char *, unsigned int);
	static void MD5Final (unsigned char[16], MD5_CTX *);


	static void MD5Transform(UINT4 state[4], unsigned char block[64]);

	static void Encode(unsigned char *output, UINT4 *input, unsigned int len);

	static void Decode(UINT4 *output, unsigned char *input, unsigned int len);



};

#endif // !defined(AFX_SSM_MD5_H__DF6D0B0A_AA49_4065_9C95_F4B16A2C2375__INCLUDED_)
