// SSM_Recvctrl.h: interface for the SSM_Recvctrl class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SSM_RECVCTRL_H__05982B51_216A_4391_894F_00417F162F41__INCLUDED_)
#define AFX_SSM_RECVCTRL_H__05982B51_216A_4391_894F_00417F162F41__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "globals.h"



#define MAX_SACK_SIZE	1200
#define MAX_SACK_ARRAY_SIZE	1000

class SSM_Recvctrl  
{
public:
	SSM_Recvctrl();
	virtual ~SSM_Recvctrl();



	static void *rxc_new_recvctrl(unsigned int remote_initial_TSN,
											 unsigned int number_of_destination_addresses,
											 void* sctpInstance);

	static void rxc_delete_recvctrl(void *rxc_instance);

	/**
	 * For now this function treats only one incoming data chunk
	 * recvcontrol eventually passes chunk on to stream_engine !
	 */
	static int rxc_data_chunk_rx(SCTP_data_chunk * se_chk, unsigned int ad_idx);

	/**
	 * Function triggered by flowcontrol, tells recvcontrol to create a SACK struct
	 * and send it to bundling using bu_put_SACK_Chunk() function.
	 * @param  destination_address pointer to address to send sack to  (or null for default)
	 * @param  send_at_once, set by timer to send it at once....
	 * @return boolean to indicate, whether a SACK was generated, and should be sent !
	 */
	static boolean rxc_create_sack(unsigned int *destination_address, boolean force_sack);

	/**
	 * Function triggered by bundling (methinks), in order to signal to
	 * rx control that all data chunks coming from an address have been processed,
	 * and a new SACK may be generated
	 */
	static void rxc_all_chunks_processed(boolean new_data_received);

	/**
	 * Function returns the current cumulative TSN, that this association has RECEIVED
	 */
	static unsigned int rxc_read_cummulativeTSNacked(void);

	/**
	 * function to send SACK after ULP has read some data
	 * this is to send ARWND updates...                   
	 */
	static int rxc_start_sack_timer(unsigned int oldQueueLen);

	/**
	 * function called by bundling when a SACK is actually sent, to stop
	 * a possibly running  timer
	 */
	static void rxc_stop_sack_timer(void);

	static boolean rxc_sack_timer_is_running(void);

	static void rxc_send_sack_everytime(void);
	static void rxc_send_sack_every_second_time(void);


	/**
	 * returns my actual buffer size (for now a constant)
	 */
	static unsigned int rxc_get_local_receiver_window(void);

	static int rxc_get_sack_delay(void);
	static int rxc_set_sack_delay(unsigned int new_delay);


	/**
	 * sets my actual buffer size
	 */
	static int rxc_set_local_receiver_window(unsigned int new_window);

	static void rxc_restart_receivecontrol(unsigned int my_rwnd, unsigned int new_remote_TSN);

	static int rxc_process_forward_tsn(void* chunk);

};

#endif // !defined(AFX_SSM_RECVCTRL_H__05982B51_216A_4391_894F_00417F162F41__INCLUDED_)
