// SSM_Reltransfer.h: interface for the SSM_Reltransfer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SSM_RELTRANSFER_H__EE9B46B2_3E6D_481E_A65A_9072EF1A4C00__INCLUDED_)
#define AFX_SSM_RELTRANSFER_H__EE9B46B2_3E6D_481E_A65A_9072EF1A4C00__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "globals.h"

class SSM_Reltransfer  
{
public:
	SSM_Reltransfer();
	virtual ~SSM_Reltransfer();

	
	static void *rtx_new_reltransfer(unsigned int number_of_destination_addresses, unsigned int iTSN);

	static void rtx_delete_reltransfer(void *rtx_instance);


	/**
	 * this is called by bundling, when a SACK needs to be processed
	 */
	static int rtx_process_sack(unsigned int adr_index, void *sack_chunk, unsigned int totalLen);

	/**
	 * TODO : does nothing right now
	 * a callback function for initiating retransmission after T3 has elapsed
	 */
	static int rtx_timer_cb(TimerID tid, void *data1, void *data2);

	/**
	 * a function called by WinFlowCtrl, when chunks have been given to the bundling
	 * instance, but need to be kept in the buffer until acknowledged
	 * In SDL digram signal is called (RetransChunks)
	 *
	 * TODO : - add possibility for more than one data_chunk ????
	 *
	 */
	static int rtx_save_retrans_chunks(void *data_chunk);

	/**
	 * a function called by FlowCtrl, when chunk has been given to the bundling
	 * instance, but is already contained in the reliable transfer list.
	 * some data in that chunks must be updated.
	 */
	static int rtx_update_retrans_chunks(void *data_chunk, unsigned int dest);

	/**
	 * called from flow-control to trigger retransmission of chunks that have previously
	 * been sent to the address that timed out
	 */
	static int rtx_t3_timeout(void *rtx_instance, unsigned int address,
					   unsigned int mtu, chunk_data ** rtx_chunks);



	static void chunk_list_debug(short event_log_level, GList * chunk_list);

	/**
	 * function to return the last a_rwnd value we got from our peer
	 */
	static unsigned int rtx_read_remote_receiver_window(void);

	/**
	 * Function returns the number of chunks that are waiting in the queue to be acked
	 */
	static unsigned int rtx_readNumberOfUnackedChunks(void);

	/**b
	 * function to set the a_rwnd value we got from our peer (from INIT/INIT ACK)
	 */
	static int rtx_set_remote_receiver_window(unsigned int new_arwnd);


	/**
	 * this function returns what we have got as ctsna from the peer
	 */
	static unsigned int rtx_readLocalTSNacked(void);

	static gboolean rtx_is_lowest_tsn(unsigned int atsn);

	static int rtx_enter_fast_recovery(void);

	static gboolean rtx_is_in_fast_recovery(void);

	/**
	 * returns the current number of outstanding bytes queued in the retransmission
	 * queue
	 */
	static int rtx_get_obpa(unsigned int adIndex, unsigned int *totalInFlight);

	/**
	 * is called, in case we receive a Cookie in the ESTABLISHED state,
	 * that indicates the peers restart -> we need to restart too
	 */
	static void* rtx_restart_reliable_transfer(void* rtx_instance, unsigned int numOfPaths, unsigned int iTSN);

	/**
	 * function that is called by SCTP-Control, when ULP requests
	 * shutdown in an established association
	 */
	static int rtx_shutdown(void);


	/**
	 * function that is called by SCTP-Control, when peer indicates
	 * shutdown and sends us his last ctsna...this function dequeues
	 * all chunks, and returns the number of chunks left in the queue
	 */
	static unsigned int rtx_rcv_shutdown_ctsna(unsigned int ctsna);

	static int rtx_dequeueOldestUnackedChunk(unsigned char *buf, unsigned int *len, unsigned int *tsn,
									  unsigned short *sID, unsigned short *sSN,unsigned int* pID,
									  unsigned char* flags, gpointer* ctx);




};

#endif // !defined(AFX_SSM_RELTRANSFER_H__EE9B46B2_3E6D_481E_A65A_9072EF1A4C00__INCLUDED_)
