//---------------------------------------------------------------------------

#ifndef _AUDIOCONTROL_H_
#define _AUDIOCONTROL_H_

/////////////////////////////////////////////////////////////////////////////
// CAudioIO window
#include <mmsystem.h>

#include "AudioCodec.h"

#define DATABLOCK_SIZE          8160L
#define MAX_BUFFERS                 3
#define	LINE_COUNT		   17
#define	LINE_LENG      LINE_COUNT * 24



//---------------------------------------------------------------------------
class CAudioIO
{
public:
	CAudioIO(CWnd *parent);
	virtual  ~CAudioIO();
	
	void  StartRecording();
	void  Playing();
	void  StopRecoding();
	void  Recoding(LPARAM lParam);
	void  Transmission();
	void  InitialAudio(int parm_sample);
	void  DecodingPlay();
private:
	void  RecordUnprepare();
	void  AllocBuffers();
	void  FreeBuffers();
	
public:
	
	short*    pRecBuffer;
	short*    pPlayBuffer;
	
	
	char* m_line;
	char* rm_line;
	
	HANDLE m_pMain;
	// Attributes
	
private:
	
	bool bRecoding;
	
	HWAVEIN  hwi;
	HWAVEOUT hwo;
	
	WAVEHDR* whr[MAX_BUFFERS];
	WAVEHDR* whp[MAX_BUFFERS];
	

};
//---------------------------------------------------------------------------
extern CAudioIO *AudioIO;
//---------------------------------------------------------------------------
#endif
