// SCTPClientDlg.h : header file
//

#if !defined(AFX_SCTPCLIENTDLG_H__1618C5A8_D184_4398_B10D_B6BD85E0CD54__INCLUDED_)
#define AFX_SCTPCLIENTDLG_H__1618C5A8_D184_4398_B10D_B6BD85E0CD54__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CSCTPClientDlg dialog

#include "SCTPWrapper.h"


#include "H263Dec.h"
#include "resource.h"

#include "H263Cont.h"

#include "H263Enc.h"
#include "Vidcap.h"
#include "Buffer.h"

#include "AudioControl.h"

#include <string.h>
#include <stdio.h>
#include <stdlib.h>         /* for atoi() under Linux */

#define ECHO_PORT                              7
#define MAXIMUM_NUMBER_OF_LOCAL_ADDRESSES     10
#define MAXIMUM_NUMBER_OF_IN_STREAMS          10
#define MAXIMUM_NUMBER_OF_OUT_STREAMS         10
/*#define min(x,y)                              (x)<(y)?(x):(y)*/

#if defined SCTP_MAXIMUM_DATA_LENGTH
    #undef SCTP_MAXIMUM_DATA_LENGTH
#endif

#define SCTP_MAXIMUM_DATA_LENGTH    450

static unsigned char localAddressList[MAXIMUM_NUMBER_OF_LOCAL_ADDRESSES][SCTP_MAX_IP_LEN];
static unsigned char destinationAddress[SCTP_MAX_IP_LEN]="192.168.10.100";

static unsigned short noOfLocalAddresses = 0;

static unsigned short remotePort = ECHO_PORT;
static unsigned short localPort  = 0;
static unsigned char  tosByte    = 0x10;  /* IPTOS_LOWDELAY */
static unsigned int video_associationID;
static unsigned int audio_associationID;
static int video_sctpInstance;
static int audio_sctpInstance;
static int useAbort = 0;
static int sendOOTBAborts = 0;
static unsigned int myRwnd = 0;
static int myRwndSpecified = 0;
static int HBInterval = 30000;
static int rto_min = 1000;
static int rto_max = 60000;
static int timeToLive     = SCTP_INFINITE_LIFETIME;
static short numberOutStreams = 0;
static short currentStream = 0;

static int rotateStreams = 0;
static int verbose  = 0;
static int vverbose = 1;
static int unknownCommand = 0;
static int hasDestinationAddress = 0;


static SCTPWrapper clientsctp;
class CSCTPClientDlg : public CDialog
{
// Construction
public:
	void checkArgs(void);
	int StartSctpclient();
	CSCTPClientDlg(CWnd* pParent = NULL);	// standard constructor




	SCTP_ulpCallbacks video_Ulp;
	SCTP_ulpCallbacks audio_Ulp;
    SCTP_InstanceParameters instanceParameters;
    SCTP_LibraryParameters params;
    char buffer[2000];

	bool m_IsAudio;

	H263Cont	*m_H263;

	unsigned char *m_buffer;

	CAudioIO	*m_audio_codec;

// Dialog Data
	//{{AFX_DATA(CSCTPClientDlg)
	enum { IDD = IDD_SCTPCLIENT_DIALOG };
	CListBox	m_list;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSCTPClientDlg)
	public:
	virtual BOOL DestroyWindow();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	friend UINT threadFunc ( LPVOID p ) ;

	friend void dataArriveNotif(unsigned int assocID, unsigned short streamID, unsigned int len,
                     unsigned short streamSN, unsigned int TSN, unsigned int protoID,
                     unsigned int unordered, void* ulpDataPtr);

	friend void sendFailureNotif(unsigned int assocID,
                      unsigned char *unsent_data, unsigned int dataLength, unsigned int *context, void* dummy);
	
	friend void networkStatusChangeNotif(unsigned int assocID, short destAddrIndex, unsigned short newState, void* ulpDataPtr);
	
	friend void* communicationUpNotif(unsigned int assocID, int status,
                           unsigned int noOfDestinations,
                           unsigned short noOfInStreams, unsigned short noOfOutStreams,
                           int associationSupportsPRSCTP, void* dummy);

	friend void communicationLostNotif(unsigned int assocID, unsigned short status, void* ulpDataPtr);
	
	friend void communicationErrorNotif(unsigned int assocID, unsigned short status, void* dummy);


	friend void restartNotif(unsigned int assocID, void* ulpDataPtr);


	friend void shutdownCompleteNotif(unsigned int assocID, void* ulpDataPtr);


	friend void shutdownReceivedNotif(unsigned int assocID, void* ulpDataPtr);

	friend char * pathStateName(unsigned int state);



	// Generated message map functions
	//{{AFX_MSG(CSCTPClientDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnExit();
	afx_msg void OnConnect_Server();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


extern CSCTPClientDlg *Maindlg;


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCTPCLIENTDLG_H__1618C5A8_D184_4398_B10D_B6BD85E0CD54__INCLUDED_)
