// SCTPWrapper.h: interface for the SCTPWrapper class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCTPWRAPPER_H__5C8B149B_2354_487B_B421_41B8B148E3D1__INCLUDED_)
#define AFX_SCTPWRAPPER_H__5C8B149B_2354_487B_B421_41B8B148E3D1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "sctp.h"

class SCTPWrapper  
{
public:
	SCTPWrapper();
	virtual ~SCTPWrapper();


	int 
	SCTP_getLibraryParameters(SCTP_LibraryParameters *params);

	int 
	SCTP_setLibraryParameters(SCTP_LibraryParameters *params);

	int
	SCTP_initLibrary(void);

	int
	SCTP_registerInstance(unsigned short port,
						  unsigned short noOfInStreams,
						  unsigned short noOfOutStreams,
						  unsigned int noOfLocalAddresses,
						  unsigned char localAddressList[][SCTP_MAX_IP_LEN],
						  SCTP_ulpCallbacks ULPcallbackFunctions);

	int
	SCTP_unregisterInstance(unsigned short instance_name);

	int
	SCTP_deleteAssociation(unsigned int associationID);

	int 
	SCTP_send(unsigned int associationID, unsigned short streamID,
			  unsigned char *buffer, unsigned int length, unsigned int protocolId, short path_id,
			  void*  context, 
			  unsigned int lifetime,
			  int unorderedDelivery, 
			  int dontBundle);
	int
	SCTP_receive(unsigned int associationID, unsigned short streamID, unsigned char *buffer,
				unsigned int *length, unsigned short* streamSN, unsigned int * tsn, unsigned int flags);

	int
	SCTP_shutdown(unsigned int associationID);

	int
	SCTP_abort(unsigned int associationID);

	short 
	SCTP_setPrimary(unsigned int associationID, short path_id);

	short
	SCTP_getPrimary(unsigned int associationID);

	int
	SCTP_receiveUnacked(unsigned int associationID, unsigned char *buffer, unsigned int *length, unsigned int* tsn,
						unsigned short *streamID, unsigned short *streamSN,unsigned int* protocolId);
	int
	SCTP_receiveUnsent(unsigned int associationID, unsigned char *buffer, unsigned int *length,unsigned int* tsn,
					   unsigned short *streamID, unsigned short *streamSN,unsigned int* protocolId);

	int
	SCTP_eventLoop(void);

	int 
	SCTP_getPathStatus(unsigned int associationID, short path_id, SCTP_PathStatus* status);

	int
	SCTP_getAssocStatus(unsigned int associationID, SCTP_AssociationStatus* status);

	unsigned int
	SCTP_associate(unsigned short SCTP_InstanceName,
				   unsigned short noOfOutStreams,
				   unsigned char destinationAddress[],
				   unsigned short destinationPort,
				   void* ulp_data);


	int
	SCTP_registerStdinCallback(sctp_StdinCallback sdf, char* buffer, int length);

	int SCTP_unregisterStdinCallback();

	int SCTP_changeHeartBeat(unsigned int associationID,
							 short path_id, int heartbeatON, unsigned int timeIntervall);

	#ifndef WIN32
	int
	SCTP_registerUserCallback(int fd, sctp_userCallback sdf, void* userData);
	#endif

	int
	SCTP_getAssocDefaults(unsigned short SCTP_InstanceName, SCTP_InstanceParameters* params);

	int
	SCTP_setAssocDefaults(unsigned short SCTP_InstanceName, SCTP_InstanceParameters* params);

	unsigned int
	SCTP_startTimer(unsigned int milliseconds, sctp_timerCallback timer_cb,
					void *param1, void *param2);

};

#endif // !defined(AFX_SCTPWRAPPER_H__5C8B149B_2354_487B_B421_41B8B148E3D1__INCLUDED_)
