/******************************************************************************

  Buffer.cpp: implementation of the CBuffer class.

******************************************************************************/

#include "stdafx.h"
#include "Buffer.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
 
#define DEF_BUFFSIZE IMAGE_BUFFER_SIZE

//-----------------------------------------------------------------------------
CBuffer::CBuffer()
{
	m_Buffer = NULL;
	SetBufferSize(DEF_BUFFSIZE);
}
//-----------------------------------------------------------------------------
CBuffer::~CBuffer()
{
	if (m_Buffer) delete [] m_Buffer;
}
//-----------------------------------------------------------------------------
bool CBuffer::SetBufferSize(int size)
{
	m_BufferSize = size;
	m_outputIndex = 0;
	m_inputIndex  = 0;

	if (m_Buffer) delete [] m_Buffer;
	m_Buffer = new unsigned char [m_BufferSize];
	if (!m_Buffer) return false;
	return true;
	
}
//-----------------------------------------------------------------------------
bool CBuffer::GetData(unsigned char &data)
{
	if ( GetBufferSize() == 0 )
	{
		// Buffer is Empty.
		return false;
	}

	data = *(m_Buffer + m_outputIndex);
	m_outputIndex++;
	if (m_outputIndex > m_BufferSize ) m_outputIndex = 0;
	return true;
}
//-----------------------------------------------------------------------------
bool CBuffer::PutData(unsigned char data)
{
	if ( GetBufferSize() == m_BufferSize )
	{
		// Buffer is Full.
		return false;
	}
	*(m_Buffer + m_inputIndex)	= data;
	m_inputIndex++;
	if (m_inputIndex > m_BufferSize ) m_inputIndex = 0;
	return true;
}
//-----------------------------------------------------------------------------
int CBuffer::GetBufferSize()
{
	int size;
	if (m_inputIndex >= m_outputIndex)
		size = m_inputIndex - m_outputIndex;
	else
		size = m_inputIndex + ( m_BufferSize - m_outputIndex) + 1;

	return size;
}
//-----------------------------------------------------------------------------