// SCTPServerDlg.h : header file
//

#if !defined(AFX_SCTPSERVERDLG_H__8376326E_102D_4030_AA44_521F5D00676D__INCLUDED_)
#define AFX_SCTPSERVERDLG_H__8376326E_102D_4030_AA44_521F5D00676D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CSCTPServerDlg dialog


#include"sctpwrapper.h"


////////////////////////////////////////

#include "H263Dec.h"
#include "resource.h"
#include "H263Cont.h"
#include "H263Enc.h"
#include "Vidcap.h"
#include "Buffer.h"

#include "AudioControl.h"
////////////////////////////////////////////


#ifndef WIN32
#include <unistd.h>
#endif
#include <string.h>
#include <stdio.h>
#include <stdlib.h>         /* for atoi() under Linux */
#include <time.h>

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#define ECHO_PORT                             7
#define DISCARD_PORT                          9
#define DAYTIME_PORT                         13
#define CHARGEN_PORT                         19

#define MAXIMUM_NUMBER_OF_LOCAL_ADDRESSES    10
#define MAXIMUM_NUMBER_OF_IN_STREAMS         17
#define MAXIMUM_NUMBER_OF_OUT_STREAMS        17
#define MAXIMUM_PAYLOAD_LENGTH             8192
#define BUFFER_LENGTH                      1024
#define SEND_QUEUE_SIZE                     100

#ifndef min
#define min(x,y)            (x)<(y)?(x):(y)
#endif

struct ulp_data {
    int maximumStreamID;
    int ShutdownReceived;
};

static unsigned char localAddressList[MAXIMUM_NUMBER_OF_LOCAL_ADDRESSES][SCTP_MAX_IP_LEN];
static unsigned short noOfLocalAddresses      = 0;

static int verbose                            = 0;
static int vverbose                           = 1;
static int unknownCommand                     = 0;
static int sendOOTBAborts                     = 0;
static int timeToLive                         = SCTP_INFINITE_LIFETIME;


static SCTPWrapper mysctp;



class CSCTPServerDlg : public CDialog
{
// Construction
public:	
	
	unsigned int video_assocID;
	unsigned int audio_assocID;
	
	int StartCamera();
	void checkArgs(void);
	int StartSctp();
	CSCTPServerDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CSCTPServerDlg)
	enum { IDD = IDD_SCTPSERVER_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSCTPServerDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

	

	
	bool m_IsCapture;
	bool m_IsAudio;

	CH263Dec	*m_H263Dec;
	H263Cont	*m_H263;


	CAudioIO	*m_audio_codec;

	SCTP_ulpCallbacks video_Ulp;
	SCTP_ulpCallbacks audio_Ulp;

    SCTP_LibraryParameters params;
    SCTP_InstanceParameters instanceParameters;

	


// Implementation
protected:
	HICON m_hIcon;

	friend UINT threadFunc ( LPVOID p ) ;
	friend char * pathStateName(unsigned int state);
	friend void echoDataArriveNotif(unsigned int assocID, unsigned short streamID, unsigned int len,
                         unsigned short streamSN, unsigned int TSN, unsigned int protoID, unsigned int unordered, void* ulpDataPtr);
	friend void audioDataArriveNotif(unsigned int assocID, unsigned short streamID, unsigned int len,
                         unsigned short streamSN, unsigned int TSN, unsigned int protoID, unsigned int unordered, void* ulpDataPtr);

	friend 	void sendFailureNotif(unsigned int assocID,
                      unsigned char *unsent_data, unsigned int dataLength, unsigned int *context, void* dummy);

	friend void networkStatusChangeNotif(unsigned int assocID, short affectedPathID, unsigned short newState, void* ulpDataPtr);

	friend void* echoCommunicationUpNotif(unsigned int assocID, int status,
                               unsigned int noOfPaths,
                               unsigned short noOfInStreams, unsigned short noOfOutStreams,
                               int associationSupportsPRSCTP, void* dummy);
	friend void* audioCommunicationUpNotif(unsigned int assocID, int status,
                               unsigned int noOfPaths,
                               unsigned short noOfInStreams, unsigned short noOfOutStreams,
                               int associationSupportsPRSCTP, void* dummy);


	friend void communicationLostNotif(unsigned int assocID, unsigned short status, void* ulpDataPtr);

	friend void communicationErrorNotif(unsigned int assocID, unsigned short status, void* dummy);

	friend void echoRestartNotif(unsigned int assocID, void* ulpDataPtr);

	friend void restartNotif(unsigned int assocID, void* ulpDataPtr);

	friend void shutdownCompleteNotif(unsigned int assocID, void* ulpDataPtr);

	friend void queueStatusChangeNotif(unsigned int assocID, int queueType, int queueID, int queueLength, void* ulpDataPtr);


	friend void shutdownReceivedNotif(unsigned int assocID, void* ulpDataPtr);








	// Generated message map functions
	//{{AFX_MSG(CSCTPServerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButton1();

	afx_msg void OnCapture(WPARAM wParam, LPARAM lParam);
	afx_msg void OnfinishFrame(WPARAM wParam, LPARAM lParam);

	virtual void OnOK();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

extern CSCTPServerDlg *Maindlg;

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCTPSERVERDLG_H__8376326E_102D_4030_AA44_521F5D00676D__INCLUDED_)
