/******************************************************************************

	VidCap.cpp: implementation of the CVidCap class.	2000. 1

******************************************************************************/

#include "stdafx.h"
#include "VidCap.h"
#include <vfw.h>
 
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

unsigned char *gpCapImage;

CVidCap *VidCap;

FARPROC fpFrameCallback;		/* VFW Callback Լ. */
LRESULT CALLBACK FrameCallbackProc(HWND hWnd, LPVIDEOHDR lpVHdr);
//-----------------------------------------------------------------------------
CVidCap::CVidCap(CWnd *pParent)
{
	m_hpWnd = pParent->m_hWnd;

	m_hWndC = capCreateCaptureWindow (	"CaptureWindow",
		WS_CHILD | WS_VISIBLE, 0, 0, 176, 144, m_hpWnd,  0);
}
//-----------------------------------------------------------------------------
CVidCap::~CVidCap()
{
	DisConnectDriver();
}
//-----------------------------------------------------------------------------
LRESULT CALLBACK FrameCallbackProc(HWND hWnd, LPVIDEOHDR lpVHdr)
{
	gpCapImage = lpVHdr->lpData;
	PostMessage( VidCap->m_hpWnd, WM_CAPTURE, (LPARAM)gpCapImage, 0);
	return 0;
}
//-----------------------------------------------------------------------------
/* Set The Video Format */
void CVidCap::SetVideoFormat()
{
	if (capDlgVideoFormat(m_hWndC))
		GetVideoFormat();
}
void CVidCap::SetVideoSource()
{
	if(capDlgVideoSource(m_hWndC))
		GetVideoFormat();
}
//-----------------------------------------------------------------------------
/* Set The Video Size */
bool CVidCap::SetVideoSize(int image_x,int image_y)
{
	BITMAPINFO bmi;
	capGetVideoFormat( m_hWndC, &bmi, sizeof(BITMAPINFO));

	bmi.bmiHeader.biWidth = image_x;
	bmi.bmiHeader.biHeight = image_y;

	if(capSetVideoFormat( m_hWndC, &bmi, sizeof(BITMAPINFO)))
		return true;
	else
		return false;

}
//-----------------------------------------------------------------------------
/* Get The Video Format */
void CVidCap::GetVideoFormat()
{
	
	/* ȭ Ʈʿ   ´. */
	BITMAPINFO bmi;
	capGetVideoFormat( m_hWndC, &bmi, sizeof(BITMAPINFO));

	m_ImageX	= bmi.bmiHeader.biWidth;
	m_ImageY	= bmi.bmiHeader.biHeight;
	m_BitCount  = bmi.bmiHeader.biBitCount;
}
//-----------------------------------------------------------------------------
void CVidCap::SetWindowSize(int x, int y, int dx, int dy)
{
	MoveWindow( m_hWndC, x, y, dx, dy, TRUE);
}
//-----------------------------------------------------------------------------
BOOL CVidCap::InitVideoCap()
{
	/*  ʱȭ Ѵ.  */

	if (!capDriverConnect (m_hWndC, 0))
	{
		MessageBox(m_hpWnd, "Video ġ  ߽ϴ.", "ERROR", MB_ICONERROR);
		return FALSE;
	}

	capPreviewRate(m_hWndC, 10);  // capture rate in milisec..
	
	capPreviewScale(m_hWndC, TRUE);
	capPreview(m_hWndC, TRUE);
		
    /* Frame callback Լ . */
	fpFrameCallback = MakeProcInstance((FARPROC)FrameCallbackProc, AfxGetInstanceHandle());
	capSetCallbackOnFrame( m_hWndC, fpFrameCallback); 

	GetVideoFormat();
	
	return TRUE;
}
//-----------------------------------------------------------------------------
void CVidCap::DisConnectDriver()
{
	if (m_hWndC)
	{
		capSetCallbackOnFrame( m_hWndC, NULL);
		if (fpFrameCallback)
		{
			FreeProcInstance(fpFrameCallback);
			fpFrameCallback = NULL;
		}
		capDriverDisconnect(m_hWndC);
	}
}
