//---------------------------------------------------------------------------
#include "StdAfx.h"
//---------------------------------------------------------------------------

#include <windows.h>

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <float.h>
#include <string.h>
#include <time.h>
//---------------------------------------------------------------------------
#include "AudioCodec.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#define F  float

//=======================================//
CCODEC    *m_coder;
CCODEC    *m_decoder;
//=======================================//


/*  */
CODCNGDEF CodCng;
CODSTATDEF  CodStat ;
DECCNGDEF DecCng;
DECSTATDEF  DecStat;
VADSTATDEF  VadStat ;


  Flag  UseHp = True;
  Flag  UsePf = True;
  Flag  UseVx = False;
  Flag  UsePr = True;

  /* working mode ʿ */

  int Both=0;
  int Cod = 1;
  int Dec = 2;

  int Rate63 = 0;
  int Rate53 = 1;

  int   ReinitSize = 0;

/* main fuction   */

  long  FrCnt = 0;
  long  FlLen;

  float  DataBuff[Frame];
  float  RDataBuff[Frame];

  Word16 Crc;
  char   Line[24];
  static int extra;


/* G.723.1 encoding decoding ʿ ̺ 
** Tables:      HammingWindowTable[180]
**
**              LPC Computation and Filtering
**
**                  BinomialWindowTable[10]
**                  BandExpTable[10]
**
**              LSP calculation and quantization
**
**                  CosineTable[512]
**                  LspDcTable[10]
**                  BandInfoTable[3][2], int
**                  Band0Tb8[256*3]
**                  Band1Tb8[256*3]
**                  Band2Tb8[256*4]
**                  BandQntTable[3], float*
**
**              Perceptual Filtering and Post Filtering
**
**
**                  PerFiltZeroTable[10]
**                  PerFiltPoleTable[10]
**                  PostFiltZeroTable[10]
**                  PostFiltPoleTable[10]
**                  LpfConstTable[2] (pitch postfilter)
**
**              ACELP or MP-MLQ
**
**                  Nb_puls[4] (MP-MLQ), int
**                  FcbkGainTable[24] (ACELP and MP-MLQ)
**                  MaxPosTable[4]  (MP-MLQ), Word32
**                  CombinatorialTable[6][30] (MP-MLQ), Word32
**                  epsi170[170] (ACELP), int
**                  gain170[170] (ACELP)
**
**              Pitch Prediction
**
**                  AcbkGainTable085[85*20]
**                  AcbkGainTable170[170*20]
**                  AcbkGainTablePtr[2], float*
**
**              Taming procedure
**
**                  tabgain170[170]
**                  tabgain85[85]
**
**              Comfort Noise Generation
**
**                  fact[4]
**                  bseg[3]
**                  base[3]
**
*/

/*
**  HammingWindowTable:
**
**  Hamming Window coefficients.
**
*/

float   HammingWindowTable[LpcFrame] = {
  (F)0.080000,
  (F)0.080283,
  (F)0.081133,
  (F)0.082548,
  (F)0.084527,
  (F)0.087067,
  (F)0.090164,
  (F)0.093816,
  (F)0.098018,
  (F)0.102764,
  (F)0.108049,
  (F)0.113866,
  (F)0.120208,
  (F)0.127067,
  (F)0.134435,
  (F)0.142303,
  (F)0.150660,
  (F)0.159498,
  (F)0.168804,
  (F)0.178567,
  (F)0.188775,
  (F)0.199417,
  (F)0.210478,
  (F)0.221944,
  (F)0.233803,
  (F)0.246039,
  (F)0.258637,
  (F)0.271582,
  (F)0.284857,
  (F)0.298447,
  (F)0.312335,
  (F)0.326502,
  (F)0.340933,
  (F)0.355609,
  (F)0.370513,
  (F)0.385625,
  (F)0.400927,
  (F)0.416401,
  (F)0.432026,
  (F)0.447785,
  (F)0.463658,
  (F)0.479624,
  (F)0.495665,
  (F)0.511761,
  (F)0.527891,
  (F)0.544037,
  (F)0.560177,
  (F)0.576292,
  (F)0.592363,
  (F)0.608369,
  (F)0.624291,
  (F)0.640109,
  (F)0.655804,
  (F)0.671356,
  (F)0.686747,
  (F)0.701956,
  (F)0.716966,
  (F)0.731758,
  (F)0.746314,
  (F)0.760616,
  (F)0.774645,
  (F)0.788386,
  (F)0.801821,
  (F)0.814933,
  (F)0.827706,
  (F)0.840125,
  (F)0.852174,
  (F)0.863839,
  (F)0.875104,
  (F)0.885957,
  (F)0.896384,
  (F)0.906371,
  (F)0.915907,
  (F)0.924980,
  (F)0.933579,
  (F)0.941693,
  (F)0.949312,
  (F)0.956426,
  (F)0.963028,
  (F)0.969109,
  (F)0.974660,
  (F)0.979677,
  (F)0.984151,
  (F)0.988079,
  (F)0.991454,
  (F)0.994273,
  (F)0.996533,
  (F)0.998230,
  (F)0.999363,
  (F)0.999929,
  (F)0.999929,
  (F)0.999363,
  (F)0.998230,
  (F)0.996533,
  (F)0.994273,
  (F)0.991454,
  (F)0.988079,
  (F)0.984151,
  (F)0.979677,
  (F)0.974660,
  (F)0.969109,
  (F)0.963028,
  (F)0.956427,
  (F)0.949312,
  (F)0.941693,
  (F)0.933579,
  (F)0.924980,
  (F)0.915907,
  (F)0.906371,
  (F)0.896384,
  (F)0.885957,
  (F)0.875104,
  (F)0.863839,
  (F)0.852174,
  (F)0.840125,
  (F)0.827706,
  (F)0.814933,
  (F)0.801821,
  (F)0.788386,
  (F)0.774645,
  (F)0.760616,
  (F)0.746314,
  (F)0.731758,
  (F)0.716966,
  (F)0.701956,
  (F)0.686747,
  (F)0.671356,
  (F)0.655804,
  (F)0.640110,
  (F)0.624291,
  (F)0.608369,
  (F)0.592363,
  (F)0.576292,
  (F)0.560177,
  (F)0.544037,
  (F)0.527891,
  (F)0.511761,
  (F)0.495665,
  (F)0.479624,
  (F)0.463658,
  (F)0.447785,
  (F)0.432027,
  (F)0.416401,
  (F)0.400927,
  (F)0.385625,
  (F)0.370513,
  (F)0.355609,
  (F)0.340933,
  (F)0.326502,
  (F)0.312335,
  (F)0.298447,
  (F)0.284857,
  (F)0.271582,
  (F)0.258637,
  (F)0.246039,
  (F)0.233803,
  (F)0.221945,
  (F)0.210478,
  (F)0.199417,
  (F)0.188775,
  (F)0.178567,
  (F)0.168804,
  (F)0.159498,
  (F)0.150660,
  (F)0.142303,
  (F)0.134435,
  (F)0.127067,
  (F)0.120208,
  (F)0.113866,
  (F)0.108049,
  (F)0.102764,
  (F)0.098018,
  (F)0.093816,
  (F)0.090164,
  (F)0.087067,
  (F)0.084527,
  (F)0.082548,
  (F)0.081133,
  (F)0.080283,
  (F)0.080000
 } ;


/*
**  BinomialWindowTable:
*/

float BinomialWindowTable[LpcOrder] = {
  (F)0.999443,
  (F)0.997775,
  (F)0.995002,
  (F)0.991132,
  (F)0.986178,
  (F)0.980157,
  (F)0.973088,
  (F)0.964995,
  (F)0.955905,
  (F)0.945847
  } ;

/*
**  BandExpTable:
*/

float BandExpTable[LpcOrder] = {
  (F)0.994 ,
  (F)0.988036 ,
  (F)0.9821078 ,
  (F)0.9762151 ,
  (F)0.9703578 ,
  (F)0.9645357 ,
  (F)0.9587485 ,
  (F)0.9529960 ,
  (F)0.9472780 ,
  (F)0.9415944 ,
};



/*
**  CosineTable:
*/

float CosineTable[CosineTableSize] = {
   (F)1 ,
   (F)0.999939 ,
   (F)0.999695 ,
   (F)0.999329 ,
   (F)0.998779 ,
   (F)0.998108 ,
   (F)0.997314 ,
   (F)0.996338 ,
   (F)0.995178 ,
   (F)0.993896 ,
   (F)0.992493 ,
   (F)0.990906 ,
   (F)0.989197 ,
   (F)0.987305 ,
   (F)0.985291 ,
   (F)0.983093 ,
   (F)0.980774 ,
   (F)0.978333 ,
   (F)0.975708 ,
   (F)0.972961 ,
   (F)0.970032 ,
   (F)0.96698 ,
   (F)0.963806 ,
   (F)0.960449 ,
   (F)0.95697 ,
   (F)0.953308 ,
   (F)0.949524 ,
   (F)0.945618 ,
   (F)0.941528 ,
   (F)0.937317 ,
   (F)0.932983 ,
   (F)0.928528 ,
   (F)0.923889 ,
   (F)0.919128 ,
   (F)0.914185 ,
   (F)0.90918 ,
   (F)0.903992 ,
   (F)0.898682 ,
   (F)0.89325 ,
   (F)0.887634 ,
   (F)0.881897 ,
   (F)0.876099 ,
   (F)0.870117 ,
   (F)0.863953 ,
   (F)0.857727 ,
   (F)0.851379 ,
   (F)0.844849 ,
   (F)0.838196 ,
   (F)0.831482 ,
   (F)0.824585 ,
   (F)0.817566 ,
   (F)0.810486 ,
   (F)0.803223 ,
   (F)0.795837 ,
   (F)0.78833 ,
   (F)0.780762 ,
   (F)0.77301 ,
   (F)0.765198 ,
   (F)0.757202 ,
   (F)0.749146 ,
   (F)0.740967 ,
   (F)0.732666 ,
   (F)0.724243 ,
   (F)0.715759 ,
   (F)0.707092 ,
   (F)0.698364 ,
   (F)0.689514 ,
   (F)0.680603 ,
   (F)0.67157 ,
   (F)0.662415 ,
   (F)0.653198 ,
   (F)0.64386 ,
   (F)0.634399 ,
   (F)0.624878 ,
   (F)0.615234 ,
   (F)0.60553 ,
   (F)0.595703 ,
   (F)0.585815 ,
   (F)0.575806 ,
   (F)0.565735 ,
   (F)0.555542 ,
   (F)0.545349 ,
   (F)0.534973 ,
   (F)0.524597 ,
   (F)0.514099 ,
   (F)0.50354 ,
   (F)0.49292 ,
   (F)0.482178 ,
   (F)0.471375 ,
   (F)0.46051 ,
   (F)0.449585 ,
   (F)0.438599 ,
   (F)0.427551 ,
   (F)0.416443 ,
   (F)0.405212 ,
   (F)0.393982 ,
   (F)0.38269 ,
   (F)0.371338 ,
   (F)0.359924 ,
   (F)0.348389 ,
   (F)0.336914 ,
   (F)0.325317 ,
   (F)0.31366 ,
   (F)0.302002 ,
   (F)0.290283 ,
   (F)0.278503 ,
   (F)0.266724 ,
   (F)0.254883 ,
   (F)0.242981 ,
   (F)0.231079 ,
   (F)0.219116 ,
   (F)0.207092 ,
   (F)0.195068 ,
   (F)0.183044 ,
   (F)0.170959 ,
   (F)0.158875 ,
   (F)0.146729 ,
   (F)0.134583 ,
   (F)0.122437 ,
   (F)0.110229 ,
   (F)0.0980225 ,
   (F)0.0858154 ,
   (F)0.0735474 ,
   (F)0.0613403 ,
   (F)0.0490723 ,
   (F)0.0368042 ,
   (F)0.0245361 ,
   (F)0.0122681 ,
   (F)0 ,
   (F)-0.0122681 ,
   (F)-0.0245361 ,
   (F)-0.0368042 ,
   (F)-0.0490723 ,
   (F)-0.0613403 ,
   (F)-0.0735474 ,
   (F)-0.0858154 ,
   (F)-0.0980225 ,
   (F)-0.110229 ,
   (F)-0.122437 ,
   (F)-0.134583 ,
   (F)-0.146729 ,
   (F)-0.158875 ,
   (F)-0.170959 ,
   (F)-0.183044 ,
   (F)-0.195068 ,
   (F)-0.207092 ,
   (F)-0.219116 ,
   (F)-0.231079 ,
   (F)-0.242981 ,
   (F)-0.254883 ,
   (F)-0.266724 ,
   (F)-0.278503 ,
   (F)-0.290283 ,
   (F)-0.302002 ,
   (F)-0.31366 ,
   (F)-0.325317 ,
   (F)-0.336914 ,
   (F)-0.348389 ,
   (F)-0.359924 ,
   (F)-0.371338 ,
   (F)-0.38269 ,
   (F)-0.393982 ,
   (F)-0.405212 ,
   (F)-0.416443 ,
   (F)-0.427551 ,
   (F)-0.438599 ,
   (F)-0.449585 ,
   (F)-0.46051 ,
   (F)-0.471375 ,
   (F)-0.482178 ,
   (F)-0.49292 ,
   (F)-0.50354 ,
   (F)-0.514099 ,
   (F)-0.524597 ,
   (F)-0.534973 ,
   (F)-0.545349 ,
   (F)-0.555542 ,
   (F)-0.565735 ,
   (F)-0.575806 ,
   (F)-0.585815 ,
   (F)-0.595703 ,
   (F)-0.60553 ,
   (F)-0.615234 ,
   (F)-0.624878 ,
   (F)-0.634399 ,
   (F)-0.64386 ,
   (F)-0.653198 ,
   (F)-0.662415 ,
   (F)-0.67157 ,
   (F)-0.680603 ,
   (F)-0.689514 ,
   (F)-0.698364 ,
   (F)-0.707092 ,
   (F)-0.715759 ,
   (F)-0.724243 ,
   (F)-0.732666 ,
   (F)-0.740967 ,
   (F)-0.749146 ,
   (F)-0.757202 ,
   (F)-0.765198 ,
   (F)-0.77301 ,
   (F)-0.780762 ,
   (F)-0.78833 ,
   (F)-0.795837 ,
   (F)-0.803223 ,
   (F)-0.810486 ,
   (F)-0.817566 ,
   (F)-0.824585 ,
   (F)-0.831482 ,
   (F)-0.838196 ,
   (F)-0.844849 ,
   (F)-0.851379 ,
   (F)-0.857727 ,
   (F)-0.863953 ,
   (F)-0.870117 ,
   (F)-0.876099 ,
   (F)-0.881897 ,
   (F)-0.887634 ,
   (F)-0.89325 ,
   (F)-0.898682 ,
   (F)-0.903992 ,
   (F)-0.90918 ,
   (F)-0.914185 ,
   (F)-0.919128 ,
   (F)-0.923889 ,
   (F)-0.928528 ,
   (F)-0.932983 ,
   (F)-0.937317 ,
   (F)-0.941528 ,
   (F)-0.945618 ,
   (F)-0.949524 ,
   (F)-0.953308 ,
   (F)-0.95697 ,
   (F)-0.960449 ,
   (F)-0.963806 ,
   (F)-0.96698 ,
   (F)-0.970032 ,
   (F)-0.972961 ,
   (F)-0.975708 ,
   (F)-0.978333 ,
   (F)-0.980774 ,
   (F)-0.983093 ,
   (F)-0.985291 ,
   (F)-0.987305 ,
   (F)-0.989197 ,
   (F)-0.990906 ,
   (F)-0.992493 ,
   (F)-0.993896 ,
   (F)-0.995178 ,
   (F)-0.996338 ,
   (F)-0.997314 ,
   (F)-0.998108 ,
   (F)-0.998779 ,
   (F)-0.999329 ,
   (F)-0.999695 ,
   (F)-0.999939 ,
   (F)-1 ,
   (F)-0.999939 ,
   (F)-0.999695 ,
   (F)-0.999329 ,
   (F)-0.998779 ,
   (F)-0.998108 ,
   (F)-0.997314 ,
   (F)-0.996338 ,
   (F)-0.995178 ,
   (F)-0.993896 ,
   (F)-0.992493 ,
   (F)-0.990906 ,
   (F)-0.989197 ,
   (F)-0.987305 ,
   (F)-0.985291 ,
   (F)-0.983093 ,
   (F)-0.980774 ,
   (F)-0.978333 ,
   (F)-0.975708 ,
   (F)-0.972961 ,
   (F)-0.970032 ,
   (F)-0.96698 ,
   (F)-0.963806 ,
   (F)-0.960449 ,
   (F)-0.95697 ,
   (F)-0.953308 ,
   (F)-0.949524 ,
   (F)-0.945618 ,
   (F)-0.941528 ,
   (F)-0.937317 ,
   (F)-0.932983 ,
   (F)-0.928528 ,
   (F)-0.923889 ,
   (F)-0.919128 ,
   (F)-0.914185 ,
   (F)-0.90918 ,
   (F)-0.903992 ,
   (F)-0.898682 ,
   (F)-0.89325 ,
   (F)-0.887634 ,
   (F)-0.881897 ,
   (F)-0.876099 ,
   (F)-0.870117 ,
   (F)-0.863953 ,
   (F)-0.857727 ,
   (F)-0.851379 ,
   (F)-0.844849 ,
   (F)-0.838196 ,
   (F)-0.831482 ,
   (F)-0.824585 ,
   (F)-0.817566 ,
   (F)-0.810486 ,
   (F)-0.803223 ,
   (F)-0.795837 ,
   (F)-0.78833 ,
   (F)-0.780762 ,
   (F)-0.77301 ,
   (F)-0.765198 ,
   (F)-0.757202 ,
   (F)-0.749146 ,
   (F)-0.740967 ,
   (F)-0.732666 ,
   (F)-0.724243 ,
   (F)-0.715759 ,
   (F)-0.707092 ,
   (F)-0.698364 ,
   (F)-0.689514 ,
   (F)-0.680603 ,
   (F)-0.67157 ,
   (F)-0.662415 ,
   (F)-0.653198 ,
   (F)-0.64386 ,
   (F)-0.634399 ,
   (F)-0.624878 ,
   (F)-0.615234 ,
   (F)-0.60553 ,
   (F)-0.595703 ,
   (F)-0.585815 ,
   (F)-0.575806 ,
   (F)-0.565735 ,
   (F)-0.555542 ,
   (F)-0.545349 ,
   (F)-0.534973 ,
   (F)-0.524597 ,
   (F)-0.514099 ,
   (F)-0.50354 ,
   (F)-0.49292 ,
   (F)-0.482178 ,
   (F)-0.471375 ,
   (F)-0.46051 ,
   (F)-0.449585 ,
   (F)-0.438599 ,
   (F)-0.427551 ,
   (F)-0.416443 ,
   (F)-0.405212 ,
   (F)-0.393982 ,
   (F)-0.38269 ,
   (F)-0.371338 ,
   (F)-0.359924 ,
   (F)-0.348389 ,
   (F)-0.336914 ,
   (F)-0.325317 ,
   (F)-0.31366 ,
   (F)-0.302002 ,
   (F)-0.290283 ,
   (F)-0.278503 ,
   (F)-0.266724 ,
   (F)-0.254883 ,
   (F)-0.242981 ,
   (F)-0.231079 ,
   (F)-0.219116 ,
   (F)-0.207092 ,
   (F)-0.195068 ,
   (F)-0.183044 ,
   (F)-0.170959 ,
   (F)-0.158875 ,
   (F)-0.146729 ,
   (F)-0.134583 ,
   (F)-0.122437 ,
   (F)-0.110229 ,
   (F)-0.0980225 ,
   (F)-0.0858154 ,
   (F)-0.0735474 ,
   (F)-0.0613403 ,
   (F)-0.0490723 ,
   (F)-0.0368042 ,
   (F)-0.0245361 ,
   (F)-0.0122681 ,
   (F)0 ,
   (F)0.0122681 ,
   (F)0.0245361 ,
   (F)0.0368042 ,
   (F)0.0490723 ,
   (F)0.0613403 ,
   (F)0.0735474 ,
   (F)0.0858154 ,
   (F)0.0980225 ,
   (F)0.110229 ,
   (F)0.122437 ,
   (F)0.134583 ,
   (F)0.146729 ,
   (F)0.158875 ,
   (F)0.170959 ,
   (F)0.183044 ,
   (F)0.195068 ,
   (F)0.207092 ,
   (F)0.219116 ,
   (F)0.231079 ,
   (F)0.242981 ,
   (F)0.254883 ,
   (F)0.266724 ,
   (F)0.278503 ,
   (F)0.290283 ,
   (F)0.302002 ,
   (F)0.31366 ,
   (F)0.325317 ,
   (F)0.336914 ,
   (F)0.348389 ,
   (F)0.359924 ,
   (F)0.371338 ,
   (F)0.38269 ,
   (F)0.393982 ,
   (F)0.405212 ,
   (F)0.416443 ,
   (F)0.427551 ,
   (F)0.438599 ,
   (F)0.449585 ,
   (F)0.46051 ,
   (F)0.471375 ,
   (F)0.482178 ,
   (F)0.49292 ,
   (F)0.50354 ,
   (F)0.514099 ,
   (F)0.524597 ,
   (F)0.534973 ,
   (F)0.545349 ,
   (F)0.555542 ,
   (F)0.565735 ,
   (F)0.575806 ,
   (F)0.585815 ,
   (F)0.595703 ,
   (F)0.60553 ,
   (F)0.615234 ,
   (F)0.624878 ,
   (F)0.634399 ,
   (F)0.64386 ,
   (F)0.653198 ,
   (F)0.662415 ,
   (F)0.67157 ,
   (F)0.680603 ,
   (F)0.689514 ,
   (F)0.698364 ,
   (F)0.707092 ,
   (F)0.715759 ,
   (F)0.724243 ,
   (F)0.732666 ,
   (F)0.740967 ,
   (F)0.749146 ,
   (F)0.757202 ,
   (F)0.765198 ,
   (F)0.77301 ,
   (F)0.780762 ,
   (F)0.78833 ,
   (F)0.795837 ,
   (F)0.803223 ,
   (F)0.810486 ,
   (F)0.817566 ,
   (F)0.824585 ,
   (F)0.831482 ,
   (F)0.838196 ,
   (F)0.844849 ,
   (F)0.851379 ,
   (F)0.857727 ,
   (F)0.863953 ,
   (F)0.870117 ,
   (F)0.876099 ,
   (F)0.881897 ,
   (F)0.887634 ,
   (F)0.89325 ,
   (F)0.898682 ,
   (F)0.903992 ,
   (F)0.90918 ,
   (F)0.914185 ,
   (F)0.919128 ,
   (F)0.923889 ,
   (F)0.928528 ,
   (F)0.932983 ,
   (F)0.937317 ,
   (F)0.941528 ,
   (F)0.945618 ,
   (F)0.949524 ,
   (F)0.953308 ,
   (F)0.95697 ,
   (F)0.960449 ,
   (F)0.963806 ,
   (F)0.96698 ,
   (F)0.970032 ,
   (F)0.972961 ,
   (F)0.975708 ,
   (F)0.978333 ,
   (F)0.980774 ,
   (F)0.983093 ,
   (F)0.985291 ,
   (F)0.987305 ,
   (F)0.989197 ,
   (F)0.990906 ,
   (F)0.992493 ,
   (F)0.993896 ,
   (F)0.995178 ,
   (F)0.996338 ,
   (F)0.997314 ,
   (F)0.998108 ,
   (F)0.998779 ,
   (F)0.999329 ,
   (F)0.999695 ,
   (F)0.999939
};

/*
**  LspDcTable: LSP long term Dc component
**
*/

float LspDcTable[LpcOrder] = {
   (F)24.4609,
   (F)36.8828,
   (F)60.0781,
   (F)84.4219,
   (F)108.375,
   (F)128.867,
   (F)154.312,
   (F)173.906,
   (F)199.094,
   (F)216.547,
};

/*
**  BandInfoTable:
*/

int BandInfoTable[LspQntBands][2] = {

   { 0,3},
   { 3,3},
   { 6,4}
   };

/*
**  Band0Tb8:
**
**  Table Structure:
**      8 bit, 256 entry table.
*/

float Band0Tb8[LspCbSize*3] = {
    (F)0,  (F)0,  (F)0,
    (F)-2.10938,  (F)-10.7188,  (F)-8.0625,
    (F)-4.22656,  (F)-12.8906,  (F)-10.7969,
    (F)-5.64844,  (F)-15.7109,  (F)-17.2891,
    (F)-7.35156,  (F)-8.76562,  (F)-15.1719,
    (F)-6.09375,  (F)-8.94531,  (F)-19.1719,
    (F)-6.90625,  (F)-10.2266,  (F)-10.7266,
    (F)-8.21094,  (F)-11.8984,  (F)-13.7969,
    (F)-8.46094,  (F)-12.6719,  (F)-17.9688,
    (F)-6.07031,  (F)-10.7578,  (F)-16.7734,
    (F)-7.30469,  (F)-11.4609,  (F)-21.5859,
    (F)-6.26562,  (F)-10.3672,  (F)-27.1172,
    (F)-7.30469,  (F)-15.3047,  (F)-31.2422,
    (F)-1.875,  (F)-0.695312,  (F)1.73438,
    (F)-5.16406,  (F)-2.00781,  (F)-1.25,
    (F)-7.76562,  (F)-3.64062,  (F)-3.27344,
    (F)-1.46875,  (F)-1.28125,  (F)-2.17188,
    (F)-2.67188,  (F)-4,  (F)-3.24219,
    (F)-4.74219,  (F)-3.99219,  (F)-6.22656,
    (F) 0.125,  (F)0.148438,  (F)-5.59375,
    (F) 2.92188,  (F)3.32031,  (F)-7.59375,
    (F)-2.70312,  (F)1.91406,  (F)-2.20312,
    (F)-2.07031,  (F)3.95312,  (F)-5.89062,
    (F)-4.84375,  (F)-1.14844,  (F)15.2734,
    (F)-5.79688,  (F)-6.71875,  (F)20.2891,
    (F)-1.17188,  (F)-2.75,  (F)21.125,
    (F) 2.38281,  (F)6.875,  (F)15.2656,
    (F) 0.960938,  (F)5.71094,  (F)21.6094,
    (F)-2.71875,  (F)5.97656,  (F)25.9922,
    (F) 4.82812,  (F)1.72656,  (F)25.4531,
    (F)-1.39062,  (F)-0.367188,  (F)32.9609,
    (F) 3.07031,  (F)10.1875,  (F)30.0156,
    (F) 5.45312,  (F)13.2969,  (F)37.5078,
    (F) 0.492188,  (F)-4.5625,  (F)9.60156,
    (F)-1.67969,  (F)-5.71875,  (F)13.3125,
    (F) 1.34375,  (F)-2.61719,  (F)14.9141,
    (F)-0.015625,  (F)1.6875,  (F)14.0391,
    (F) 2.75781,  (F)0.992188,  (F)17.2266,
    (F)-9.4375,  (F)1.46875,  (F)0.0859375,
    (F)-4.00781,  (F)-0.585938,  (F)-5.33594,
    (F)-7.60156,  (F)1.73438,  (F)-5.04688,
    (F)-4.8125,  (F)-6.58594,  (F)-3.03125,
    (F)-7.42188,  (F)-8.69531,  (F)-2.80469,
    (F)-11.1797,  (F)-4.86719,  (F)-5.50781,
    (F)-10.9219,  (F)-8.30469,  (F)-1.39062,
    (F)-0.351562,  (F)-3.60156,  (F)0.273438,
    (F)-0.0703125,  (F)-5.13281,  (F)-1.6875,
    (F) 0.992188,  (F)-8.42188,  (F)0.742188,
    (F)-7.42188,  (F)-9.03125,  (F)4.5625,
    (F)-11.5625,  (F)-11.6719,  (F)3.50781,
    (F)-0.9375,  (F)-5.50781,  (F)4.03125,
    (F)-2.875,  (F)-7.50781,  (F)5.67969,
    (F)-2.95312,  (F)-4.10938,  (F)7.60156,
    (F)-6.19531,  (F)-4.79688,  (F)5.28125,
    (F)-6.25781,  (F)-5.89844,  (F)10.0547,
    (F)-11.5312,  (F)-2.65625,  (F)12.7812,
    (F)-3.94531,  (F)-9.79688,  (F)12.0547,
    (F)-9.71094,  (F)-12.6719,  (F)11.9688,
    (F)-6.0625,  (F)-11.5391,  (F)-5.11719,
    (F)-8.99219,  (F)-10.125,  (F)-6.42969,
    (F)-9.00781,  (F)-13.0625,  (F)-8.78125,
    (F)-10.0859,  (F)-15.6484,  (F)-13.2969,
    (F)-4.85938,  (F)-10.0234,  (F)0.445312,
    (F)-3.67969,  (F)-12.5859,  (F)3.97656,
    (F)-8.28125,  (F)-12.2656,  (F)-1.08594,
    (F)-6.82031,  (F)-16.8438,  (F)-4.1875,
    (F)-13.4062,  (F)-15.7891,  (F)-2.84375,
    (F)-16.7969,  (F)-25.1406,  (F)-10.0859,
    (F)-9.75,  (F)-15.1953,  (F)-22.6875,
    (F)-9.49219,  (F)-20.5703,  (F)-22.3047,
    (F) 1.30469,  (F)-1.90625,  (F)0.65625,
    (F) 2.72656,  (F)-3.21875,  (F)-1.69531,
    (F)-0.3125,  (F)-2.75,  (F)4.9375,
    (F) 1.77344,  (F)-4.13281,  (F)3.16406,
    (F) 0.53125,  (F)-2.99219,  (F)-3.46094,
    (F) 1.30469,  (F)-4.35938,  (F)-5.51562,
    (F)-2.14844,  (F)-6.67188,  (F)-0.109375,
    (F)-2.74219,  (F)-8.50781,  (F)-3.50781,
    (F) 2.66406,  (F)-0.5625,  (F)-2.25781,
    (F) 4.71094,  (F)-0.828125,  (F)-3.70312,
    (F) 2.51562,  (F)-1.71094,  (F)-5.07031,
    (F) 1.39844,  (F)-2.47656,  (F)-7.79688,
    (F) 3.51562,  (F)-2.27344,  (F)-7.78125,
    (F) 4.33594,  (F)1.52344,  (F)-4.10156,
    (F) 6.125,  (F)2.125,  (F)-6.49219,
    (F)-1.15625,  (F)-3,  (F)-6.63281,
    (F) 0.640625,  (F)-4.1875,  (F)-10.6016,
    (F) 1.85938,  (F)-1.34375,  (F)-10.5781,
    (F) 3.29688,  (F)-2.09375,  (F)-14.3828,
    (F) 2.32031,  (F)-5.75781,  (F)-16.2422,
    (F)-0.867188,  (F)-6.25781,  (F)-4.67188,
    (F) 0.0078125,  (F)-5.21875,  (F)-7.6875,
    (F)-1.02344,  (F)-6.39062,  (F)-10.1484,
    (F)-2.57031,  (F)-4.07031,  (F)-10.2344,
    (F)-1.17969,  (F)-6.07812,  (F)-14.3281,
    (F)-0.726562,  (F)-2.75,  (F)-13.6406,
    (F)-4.4375,  (F)-5,  (F)-14.2266,
    (F)-3.97656,  (F)-7.35156,  (F)-17.0547,
    (F) 3.625,  (F)-6.36719,  (F)-9.76562,
    (F) 0.617188,  (F)-8.85156,  (F)-12.4766,
    (F)-1.4375,  (F)-10.5703,  (F)-16.5859,
    (F)-1.53125,  (F)-3.20312,  (F)-18.9609,
    (F)-1.5,  (F)-6.50781,  (F)-21.9531,
    (F)-2.02344,  (F)-10.7969,  (F)-23.7891,
    (F)-1.69531,  (F)0.03125,  (F)-9.10938,
    (F)-6.25,  (F)-2.53906,  (F)-9.52344,
    (F)-2.83594,  (F)-6.48438,  (F)-7.01562,
    (F)-5.16406,  (F)-8.85938,  (F)-7.5,
    (F)-3.01562,  (F)-7.65625,  (F)-11.7266,
    (F)-4.89844,  (F)-9.05469,  (F)-13.4531,
    (F)-7.05469,  (F)-6.47656,  (F)-6.67969,
    (F)-5.35156,  (F)-6.47656,  (F)-10.2578,
    (F)-8.32031,  (F)-7.49219,  (F)-10.9766,
    (F) 3.44531,  (F)0.195312,  (F)-6.61719,
    (F) 5.11719,  (F)-0.210938,  (F)-9.22656,
    (F) 9.05469,  (F)-0.859375,  (F)-5.50781,
    (F) 6.6875,  (F)1.97656,  (F)-13.0547,
    (F) 3.24219,  (F)3.15625,  (F)-0.0078125,
    (F) 2.51562,  (F)7.05469,  (F)-3.10938,
    (F) 5.23438,  (F)3.89844,  (F)-2.28125,
    (F) 6.27344,  (F)4.61719,  (F)-4.76562,
    (F) 8.9375,  (F)4.61719,  (F)-6.35938,
    (F) 5.60156,  (F)1.42969,  (F)3.07031,
    (F) 6.69531,  (F)2.97656,  (F)0.828125,
    (F) 4.75781,  (F)0.484375,  (F)-0.210938,
    (F) 6.1875,  (F)1.54688,  (F)-2.53906,
    (F) 5.74219,  (F)6.28906,  (F)0.6875,
    (F) 8.92188,  (F)6.34375,  (F)0.609375,
    (F) 8.03125,  (F)2.85938,  (F)-2.28125,
    (F) 10.2266,  (F)5.80469,  (F)-1.85156,
    (F) 12.6172,  (F)4.60156,  (F)-0.617188,
    (F) 7.89062,  (F)4.99219,  (F)-1.89844,
    (F) 7.80469,  (F)7.53125,  (F)-2.42969,
    (F) 11.7188,  (F)8.88281,  (F)-4.80469,
    (F) 7.71875,  (F)2.78906,  (F)5.04688,
    (F) 9.58594,  (F)5.21094,  (F)5.33594,
    (F) 9.09375,  (F)12.2266,  (F)6.98438,
    (F) 10.875,  (F)15.7422,  (F)3.72656,
    (F) 8.89062,  (F)4.16406,  (F)1.95312,
    (F) 11.2266,  (F)7,  (F)3.05469,
    (F) 13.7891,  (F)8.73438,  (F)0.773438,
    (F) 8.6875,  (F)8.51562,  (F)6.26562,
    (F) 12.4688,  (F)6.60938,  (F)8.85938,
    (F) 7.32031,  (F)9.07031,  (F)2.17969,
    (F) 13.4297,  (F)9.79688,  (F)5.33594,
    (F) 10.4531,  (F)8.48438,  (F)0.273438,
    (F) 11.0859,  (F)10.3438,  (F)3.34375,
    (F) 11.1562,  (F)11.9062,  (F)0.3125,
    (F) 16.4688,  (F)12.4531,  (F)0.695312,
    (F) 7.92969,  (F)4.25,  (F)9.54688,
    (F) 8.75781,  (F)7.22656,  (F)9.86719,
    (F) 8.04688,  (F)10.2969,  (F)11.6016,
    (F) 10.1172,  (F)6.16406,  (F)14.1953,
    (F) 10.3359,  (F)9.9375,  (F)14.9141,
    (F) 13.4688,  (F)9.66406,  (F)14.0859,
    (F) 14.0391,  (F)13.1953,  (F)6.70312,
    (F) 16.7891,  (F)10.6797,  (F)10.1641,
    (F) 17.9844,  (F)14.5859,  (F)5.94531,
    (F) 22.3672,  (F)18.3672,  (F)8.22656,
    (F) 0.40625,  (F)1.27344,  (F)-0.59375,
    (F) 1.79688,  (F)2.41406,  (F)-3.84375,
    (F)-0.554688,  (F)4.83594,  (F)0.304688,
    (F)-1.70312,  (F)6.6875,  (F)3.89844,
    (F)-5.10938,  (F)5.75,  (F)-1.61719,
    (F)-4.17969,  (F)9.83594,  (F)1.21094,
    (F)-3.75,  (F)11.5312,  (F)5.02344,
    (F) 2.04688,  (F)8.44531,  (F)0.796875,
    (F) 2.41406,  (F)12.4375,  (F)-1.42188,
    (F) 4.89844,  (F)12.7266,  (F)4.17188,
    (F) 2.63281,  (F)5.02344,  (F)3.5625,
    (F) 5.92188,  (F)5.23438,  (F)5.57031,
    (F) 1.57812,  (F)8.79688,  (F)5.14062,
    (F) 4.78125,  (F)8.83594,  (F)5.20312,
    (F) 5.35938,  (F)9.55469,  (F)8.875,
    (F)-1.02344,  (F)2.94531,  (F)4.10156,
    (F) 0.328125,  (F)5.53125,  (F)7.08594,
    (F) 0.679688,  (F)11.625,  (F)8.08594,
    (F) 3.375,  (F)16.5391,  (F)7.0625,
    (F) 1.07031,  (F)7.66406,  (F)10.4062,
    (F)-3.49219,  (F)7.92188,  (F)8.875,
    (F)-6.55469,  (F)14.0078,  (F)9.73438,
    (F)-4.36719,  (F)2.32031,  (F)1.54688,
    (F)-6.64062,  (F)5.35156,  (F)3.48438,
    (F)-9.94531,  (F)4.9375,  (F)6.45312,
    (F)-3.13281,  (F)-4.25,  (F)1.35156,
    (F)-5.88281,  (F)-6.19531,  (F)1.125,
    (F)-3.40625,  (F)-0.0703125,  (F)6.03125,
    (F)-0.898438,  (F)-1.89844,  (F)10.2344,
    (F)-5.23438,  (F)-2.10156,  (F)2.92188,
    (F)-8.02344,  (F)-0.101562,  (F)4.99219,
    (F)-6.92969,  (F)-0.632812,  (F)8.88281,
    (F)-9.97656,  (F)-3.55469,  (F)1.23438,
    (F)-11.0234,  (F)-5.625,  (F)5.75,
    (F) 1.34375,  (F)0.6875,  (F)3.14844,
    (F) 3.01562,  (F)1.99219,  (F)5.90625,
    (F)-3.90625,  (F)4.07812,  (F)7.10938,
    (F)-7.48438,  (F)5.14844,  (F)10.8438,
    (F)-3.08594,  (F)2.35156,  (F)10.5,
    (F)-2.78125,  (F)6,  (F)14.1641,
    (F)-4.78906,  (F)6.57031,  (F)18.8984,
    (F) 3.47656,  (F)-0.953125,  (F)1.96875,
    (F) 4.91406,  (F)-0.679688,  (F)5.64844,
    (F) 2.21094,  (F)-1.97656,  (F)6.79688,
    (F) 3.5625,  (F)-0.90625,  (F)10.7891,
    (F) 5.91406,  (F)1.40625,  (F)8.27344,
    (F) 4.15625,  (F)3.1875,  (F)11.7891,
    (F) 7.39844,  (F)2.25,  (F)14.1094,
    (F) 10.3516,  (F)7.76562,  (F)19.7188,
    (F) 6.96875,  (F)9.52344,  (F)23.6172,
    (F) 10.9141,  (F)12.4688,  (F)26.6094,
    (F) 8.92969,  (F)12.125,  (F)19.8906,
    (F) 14.4531,  (F)11.1953,  (F)21.1719,
    (F)-0.078125,  (F)1.04688,  (F)7.82812,
    (F) 1.20312,  (F)3.89844,  (F)10.3359,
    (F) 3.96875,  (F)6.1875,  (F)8.72656,
    (F) 3.97656,  (F)10.4688,  (F)12.625,
    (F) 5.95312,  (F)6.73438,  (F)12.5625,
    (F) 6.14844,  (F)5.78125,  (F)18.125,
    (F) 6.20312,  (F)13.4922,  (F)10.0234,
    (F) 3.63281,  (F)16.4688,  (F)12.9688,
    (F)-0.9375,  (F)11.3359,  (F)12.6016,
    (F)-3.01562,  (F)15.75,  (F)16.9453,
    (F) 6.96094,  (F)9.57031,  (F)16.0156,
    (F) 3.5625,  (F)11.5625,  (F)17.0703,
    (F) 11.6641,  (F)10.0234,  (F)9.44531,
    (F) 10.9141,  (F)12.7812,  (F)11.8594,
    (F) 13.875,  (F)13.5781,  (F)12.125,
    (F) 12.2812,  (F)13.2656,  (F)16.7266,
    (F) 10.8516,  (F)16.6094,  (F)9.92969,
    (F) 15.3047,  (F)18.8516,  (F)8.74219,
    (F) 10.6641,  (F)22.5938,  (F)11.7578,
    (F) 17.2344,  (F)15.3984,  (F)12.6797,
    (F) 16.2188,  (F)15.2344,  (F)17.8125,
    (F) 13.4141,  (F)17.8984,  (F)14.5859,
    (F) 18.4844,  (F)19.6484,  (F)15.2578,
    (F) 22.3828,  (F)22.1719,  (F)19.7031,
    (F) 19.8047,  (F)27.0703,  (F)15.7109,
    (F) 26.4141,  (F)32.2422,  (F)20.6094,
    (F) 6.53125,  (F)20.8359,  (F)17.8828,
    (F) 13.7578,  (F)21.6641,  (F)18.2578,
    (F) 11.0547,  (F)25.9766,  (F)22.7422,
    (F) 18.3906,  (F)24.5156,  (F)24.4219,
    (F) 20.7734,  (F)32.75,  (F)31.3281,
    (F) 8.1875,  (F)13.9531,  (F)14.2031,
    (F) 9.70312,  (F)16.4922,  (F)17.5,
    (F) 11.8125,  (F)16.2422,  (F)21.7188,
    (F) 12.2891,  (F)19.4609,  (F)24.5156,
    (F) 17.4219,  (F)18.5703,  (F)21.7344,
    (F) 3.25,  (F)13.8516,  (F)21.125,
    (F) 5.66406,  (F)18.25,  (F)25.7578,
    (F) 9.78125,  (F)18.5391,  (F)31.0781,
    (F) 16.3594,  (F)17.7188,  (F)27.875,
    (F) 15.7109,  (F)21.1875,  (F)35.375,
    (F) 10.4766,  (F)27.3984,  (F)30.2812,
    (F) 9.5,  (F)30.6172,  (F)38.4531,
    (F) 13.2266,  (F)37.4453,  (F)46.9688,
};

/*
**  Band1Tb8:
**
**  Table Structure:
**      8 bit, 256 entry table.
*/

float Band1Tb8[LspCbSize*3] = {
    (F)0,  (F)0,  (F)0,
    (F)-16.5156,  (F)-10.1719,  (F)0.59375,
    (F)-20.7188,  (F)-9.98438,  (F)-10.6875,
    (F)-22.2422,  (F)-6.46875,  (F)-2.72656,
    (F)-29.7812,  (F)-17.1094,  (F)-2.72656,
    (F)-30.8281,  (F)-2.84375,  (F)-3.50781,
    (F)-21.2891,  (F)-35.0938,  (F)-28.1797,
    (F)-27.3047,  (F)-37.2188,  (F)-13.625,
    (F)-0.398438,  (F)-5.90625,  (F)0.65625,
    (F)-1.19531,  (F)-9.30469,  (F)3.9375,
    (F) 0.84375,  (F)-11.0781,  (F)9.11719,
    (F)-6.52344,  (F)-7,  (F)3.04688,
    (F)-4.44531,  (F)-13.2969,  (F)0.679688,
    (F)-8.99219,  (F)-14.2031,  (F)7.28906,
    (F)-14.2656,  (F)-19.8984,  (F)3.21094,
    (F)-14.3906,  (F)-14.2031,  (F)11.3359,
    (F)-19.0469,  (F)-12.5859,  (F)6.10156,
    (F)-21.4609,  (F)-19.3516,  (F)10.2422,
    (F)-7.34375,  (F)9.78125,  (F)3.72656,
    (F)-12.7266,  (F)13.1875,  (F)4.70312,
    (F)-9.39062,  (F)4.82031,  (F)2.1875,
    (F)-13.5703,  (F)3.07031,  (F)4.53125,
    (F)-11.9375,  (F)8.41406,  (F)9.36719,
    (F)-16.9141,  (F)-1.25781,  (F)11,
    (F)-19.5625,  (F)-8.49219,  (F)18.5234,
    (F)-27.0156,  (F)-1.36719,  (F)10.8984,
    (F)-10.9141,  (F)-0.765625,  (F)-6.58594,
    (F)-17.5938,  (F)-1.38281,  (F)-8.97656,
    (F)-11.6328,  (F)-5.67188,  (F)-10.0234,
    (F)-12.1719,  (F)-2.07031,  (F)-13.625,
    (F)-14.5859,  (F)-6.41406,  (F)-14.8203,
    (F)-16.1094,  (F)-11.8438,  (F)-18.2812,
    (F)-20.2734,  (F)-8.92188,  (F)-22.3516,
    (F) 1.32812,  (F)0.359375,  (F)-6.39844,
    (F)-1.50781,  (F)-1.59375,  (F)-8.99219,
    (F) 2.54688,  (F)-1.53125,  (F)-11.9688,
    (F) 6.09375,  (F)2.57031,  (F)-6.375,
    (F) 1.57031,  (F)2.88281,  (F)-9.71094,
    (F) 5.07812,  (F)-1.63281,  (F)-8.28125,
    (F) 8.9375,  (F)-0.117188,  (F)-9.5,
    (F) 9.39844,  (F)-2.02344,  (F)-14.5859,
    (F)-6.95312,  (F)-4.40625,  (F)-11.1719,
    (F)-4.98438,  (F)-6.65625,  (F)-15.0078,
    (F) 1.38281,  (F)-5.77344,  (F)-10.6094,
    (F)-2.03906,  (F)-4.10938,  (F)-13.0156,
    (F) 1.60938,  (F)-3.17969,  (F)-17.6172,
    (F) 2.64062,  (F)-4.10938,  (F)-6.42188,
    (F) 3.28906,  (F)-8.55469,  (F)-7.88281,
    (F) 5.97656,  (F)-4.74219,  (F)-11,
    (F) 6.44531,  (F)-10.1172,  (F)-15.6562,
    (F) 2.78906,  (F)-7.07031,  (F)-14.1797,
    (F)-0.453125,  (F)-9.75,  (F)-12.4062,
    (F)-4.65625,  (F)-11.2188,  (F)-15.9844,
    (F)-0.570312,  (F)-9.05469,  (F)-16.5312,
    (F)-0.898438,  (F)-10.7969,  (F)-20.1641,
    (F)-1.25,  (F)-13.4609,  (F)-15.25,
    (F)-0.046875,  (F)-17.1562,  (F)-23.0781,
    (F)-5.07031,  (F)-13.3203,  (F)-20.3359,
    (F)-4.82031,  (F)-11.3516,  (F)-25.6406,
    (F)-7.41406,  (F)-15.7734,  (F)-24.2344,
    (F)-6.34375,  (F)12.0625,  (F)15.1328,
    (F)-14.4844,  (F)4.48438,  (F)15.625,
    (F)-11.4297,  (F)8.90625,  (F)20.6953,
    (F)-20.9609,  (F)13.6562,  (F)11.3438,
    (F)-19.4219,  (F)17.5078,  (F)19.7109,
    (F) 6.11719,  (F)14.9219,  (F)11.2109,
    (F) 4.53906,  (F)20.9531,  (F)10.75,
    (F) 1.84375,  (F)17.1641,  (F)14.7266,
    (F)-3.53906,  (F)22.9922,  (F)16.0703,
    (F)-5.32812,  (F)17.0156,  (F)20.0391,
    (F)-10.4844,  (F)25.0078,  (F)26,
    (F)-2.25,  (F)-1.4375,  (F)2.04688,
    (F) 0.945312,  (F)-1.16406,  (F)-1.42969,
    (F) 5.92188,  (F)-3.21875,  (F)1.60938,
    (F) 8.10938,  (F)-1.59375,  (F)6.66406,
    (F) 12.3203,  (F)-3.57031,  (F)5.46875,
    (F) 7.32031,  (F)-5,  (F)-4.42969,
    (F) 11.7812,  (F)-4.125,  (F)-8,
    (F)-1.75781,  (F)-4.11719,  (F)-3.33594,
    (F)-4.40625,  (F)-8.55469,  (F)-2.59375,
    (F)-5.79688,  (F)-2.75781,  (F)-1.45312,
    (F)-10.0625,  (F)-3.58594,  (F)0.65625,
    (F)-14.4766,  (F)-3.78125,  (F)-2.14062,
    (F)-12.1406,  (F)-5.71094,  (F)6.44531,
    (F)-18.9453,  (F)-1.82812,  (F)2.98438,
    (F)-13.4531,  (F)2.28906,  (F)-2.11719,
    (F)-19.6484,  (F)3.32031,  (F)-4.40625,
    (F)-20.3047,  (F)6.39062,  (F)3.625,
    (F)-2.79688,  (F)0.921875,  (F)-2.92969,
    (F)-4.78906,  (F)1.54688,  (F)-6.82812,
    (F)-5.39062,  (F)5.33594,  (F)-2.53125,
    (F)-10.5625,  (F)9.02344,  (F)-1.3125,
    (F)-8.53906,  (F)1.00781,  (F)-2.53125,
    (F)-9.25,  (F)4.77344,  (F)-6.70312,
    (F) 3.38281,  (F)3.01562,  (F)-2.90625,
    (F)-0.9375,  (F)3.79688,  (F)-4.95312,
    (F) 1.82812,  (F)6.64844,  (F)-4.92969,
    (F) 4.70312,  (F)1,  (F)0.359375,
    (F) 8.58594,  (F)3.20312,  (F)1.24219,
    (F) 5.58594,  (F)-1.13281,  (F)-3.3125,
    (F) 9.35938,  (F)-0.664062,  (F)-4.63281,
    (F) 10.8594,  (F)2.86719,  (F)-2.79688,
    (F) 13.1484,  (F)2.82812,  (F)-7.53125,
    (F) 13.3672,  (F)4.85938,  (F)0.351562,
    (F) 15.8828,  (F)6.50781,  (F)-2.99219,
    (F) 22.5781,  (F)4.28906,  (F)-3.95312,
    (F) 0.0546875,  (F)3.13281,  (F)0.40625,
    (F) 0.5625,  (F)6.33594,  (F)3.24219,
    (F) 4.42188,  (F)5.21875,  (F)0.320312,
    (F) 3.64844,  (F)9.51562,  (F)1.01562,
    (F) 0.53125,  (F)7.47656,  (F)-1.46094,
    (F)-0.195312,  (F)12.8828,  (F)-0.804688,
    (F)-5.16406,  (F)2.03125,  (F)1.67188,
    (F)-7.22656,  (F)-0.734375,  (F)4.78125,
    (F)-2.50781,  (F)-3.29688,  (F)7.53906,
    (F)-6.15625,  (F)-5.25,  (F)13.9297,
    (F) 3.125,  (F)-5.25781,  (F)6.08594,
    (F) 5.78906,  (F)-4.64844,  (F)12.7734,
    (F)-1.25781,  (F)2.39844,  (F)5.13281,
    (F)-2.98438,  (F)6.53125,  (F)6.80469,
    (F)-6.35938,  (F)3.125,  (F)9.55469,
    (F) 2.84375,  (F)4.73438,  (F)9.74219,
    (F) 0.445312,  (F)0.585938,  (F)12.2734,
    (F) 1.17969,  (F)3.67969,  (F)17.8672,
    (F)-0.632812,  (F)7.97656,  (F)11.7344,
    (F) 1.77344,  (F)11.4844,  (F)8.57031,
    (F) 5.14062,  (F)9.96094,  (F)12.9141,
    (F) 5.1875,  (F)11.5469,  (F)18.5703,
    (F) 2.05469,  (F)-0.992188,  (F)3.46875,
    (F) 2.0625,  (F)0.695312,  (F)7.57031,
    (F) 6.20312,  (F)1.33594,  (F)4.5,
    (F) 6.41406,  (F)1.45312,  (F)9.57812,
    (F) 3.15625,  (F)3.60938,  (F)4.03906,
    (F) 2.64844,  (F)7.17188,  (F)6.20312,
    (F) 10,  (F)11.1172,  (F)1.53125,
    (F) 11.3516,  (F)15.7734,  (F)2.85156,
    (F) 12.6172,  (F)11.5703,  (F)5.25,
    (F) 18.7031,  (F)13.3438,  (F)3.96875,
    (F) 6.29688,  (F)9.67188,  (F)4.47656,
    (F) 5.57031,  (F)9.04688,  (F)8.42188,
    (F) 10.0391,  (F)11.2188,  (F)9.625,
    (F) 13.9844,  (F)9.28125,  (F)8.91406,
    (F) 5.97656,  (F)5.02344,  (F)6.75,
    (F) 8.0625,  (F)6.22656,  (F)9.99219,
    (F) 7.03125,  (F)4.39844,  (F)14.2734,
    (F) 11.8281,  (F)5.25781,  (F)18.0625,
    (F) 12.0625,  (F)8.82031,  (F)25.3125,
    (F) 11.4766,  (F)8.20312,  (F)12.4531,
    (F) 15.1953,  (F)10.2969,  (F)15.5312,
    (F) 18.7266,  (F)15.8281,  (F)16.0938,
    (F) 27.6406,  (F)16.0703,  (F)20.4688,
    (F) 9.75781,  (F)-0.921875,  (F)0.578125,
    (F) 13.4922,  (F)1.51562,  (F)3.28906,
    (F) 16.2344,  (F)-0.390625,  (F)-3.61719,
    (F) 7.57812,  (F)5.375,  (F)-3.375,
    (F) 8.97656,  (F)7.4375,  (F)-0.859375,
    (F) 9.79688,  (F)9.96094,  (F)-5.08594,
    (F) 10.8281,  (F)7.25781,  (F)3.13281,
    (F) 15.3125,  (F)9.11719,  (F)1.8125,
    (F) 3.17969,  (F)-5.875,  (F)-1.89844,
    (F) 6.71094,  (F)-8.73438,  (F)1.34375,
    (F)-1.77344,  (F)-6.71875,  (F)-7.75,
    (F)-6.21875,  (F)-9.17969,  (F)-10.7812,
    (F) 0.0625,  (F)-10.0156,  (F)-3.03125,
    (F) 2.75781,  (F)-13.9141,  (F)-8.10156,
    (F)-5.71875,  (F)-3.10156,  (F)-6.30469,
    (F)-6.66406,  (F)-0.21875,  (F)-10.4844,
    (F)-9.60156,  (F)-9.42969,  (F)-15.3047,
    (F)-7.92969,  (F)-8.78906,  (F)-19.8672,
    (F)-11.3438,  (F)-13.9922,  (F)-21.2891,
    (F)-14.7734,  (F)-18.875,  (F)-25.5391,
    (F)-7.17188,  (F)-12.7266,  (F)-6.11719,
    (F)-4.53125,  (F)-16.8359,  (F)-5.45312,
    (F)-8.57031,  (F)-18.4688,  (F)-0.75,
    (F)-10.8359,  (F)-11.8203,  (F)0.0546875,
    (F)-12.4062,  (F)-16.2188,  (F)-5.1875,
    (F)-11.5078,  (F)-21.4062,  (F)-6.125,
    (F)-18.5781,  (F)-24.6016,  (F)-0.4375,
    (F)-22.3125,  (F)-16.3438,  (F)-1.32031,
    (F)-26.4922,  (F)-28.9688,  (F)2.46875,
    (F)-9.1875,  (F)-6.95312,  (F)-4.79688,
    (F)-15.1875,  (F)-8.28906,  (F)-6.25,
    (F)-2.33594,  (F)-11.8516,  (F)-7.8125,
    (F)-5,  (F)-14.4531,  (F)-11.9219,
    (F)-11.3594,  (F)-12,  (F)-9.63281,
    (F)-14.7656,  (F)-15.2734,  (F)-13.7188,
    (F)-8.48438,  (F)-15.0078,  (F)-16.5781,
    (F)-5.85938,  (F)-18.1641,  (F)-17.6562,
    (F)-10.3516,  (F)-18.8516,  (F)-20.8828,
    (F)-8.70312,  (F)-19.8594,  (F)-27.0234,
    (F)-10.4766,  (F)-22.6641,  (F)-30.9609,
    (F)-9.0625,  (F)-17.3906,  (F)-10.8828,
    (F)-7.82031,  (F)-21.6562,  (F)-12.2891,
    (F)-12.4531,  (F)-20.6328,  (F)-15.4531,
    (F)-11.9844,  (F)-23.7969,  (F)-20.5,
    (F)-17.375,  (F)-17.1562,  (F)-5.27344,
    (F)-21.9297,  (F)-23.8594,  (F)-8.60938,
    (F)-15.6875,  (F)-22.1875,  (F)-9.26562,
    (F)-15.4688,  (F)-26.0312,  (F)-13.2422,
    (F)-13.3984,  (F)-27.8281,  (F)-3.94531,
    (F)-19.7422,  (F)-31.25,  (F)-14.7422,
    (F)-18.2266,  (F)-21.3594,  (F)-17.9375,
    (F)-26.875,  (F)-18.7578,  (F)-25.0859,
    (F)-15.6875,  (F)-27.5625,  (F)-26.0703,
    (F)-17.5547,  (F)-25.7109,  (F)-35.2344,
    (F)-3.71094,  (F)7.41406,  (F)1.21094,
    (F)-1.16406,  (F)10.6641,  (F)4.25781,
    (F)-5.91406,  (F)12.8438,  (F)8.46094,
    (F)-1.69531,  (F)16.0391,  (F)10.5703,
    (F)-11.1953,  (F)17.9766,  (F)11.4219,
    (F) 3.86719,  (F)12.9766,  (F)4.13281,
    (F) 0.078125,  (F)15.9141,  (F)5.78125,
    (F) 16.2656,  (F)14.8281,  (F)7.64062,
    (F) 22.1172,  (F)17.9219,  (F)7.11719,
    (F) 6.57812,  (F)6.19531,  (F)3.28125,
    (F) 9.55469,  (F)7.99219,  (F)6.74219,
    (F) 9.66406,  (F)3.52344,  (F)6.09375,
    (F) 13.625,  (F)5.53125,  (F)6.42188,
    (F) 11.9766,  (F)2.21875,  (F)10.8125,
    (F) 16.6797,  (F)4.75781,  (F)12.0156,
    (F) 18.0078,  (F)4.89062,  (F)4.21875,
    (F) 18.5,  (F)9.27344,  (F)7.46094,
    (F) 20.2031,  (F)9.80469,  (F)-0.0546875,
    (F) 24.3438,  (F)8.83594,  (F)5.67188,
    (F) 26.8047,  (F)13.5156,  (F)3.34375,
    (F) 21.3594,  (F)12.875,  (F)10.2109,
    (F) 23.3438,  (F)9.61719,  (F)15.7031,
    (F) 27.5234,  (F)15.8125,  (F)11.625,
    (F) 8.07812,  (F)12.9453,  (F)6.80469,
    (F) 9.42188,  (F)16.8984,  (F)8.09375,
    (F) 14.1172,  (F)18.5312,  (F)9.63281,
    (F) 14.125,  (F)13.8203,  (F)11.6641,
    (F) 12.2891,  (F)18.2188,  (F)13.8984,
    (F) 9.5,  (F)12.5703,  (F)14.5781,
    (F) 11.5625,  (F)14.8281,  (F)19.6328,
    (F) 3.63281,  (F)21.1562,  (F)21.6875,
    (F) 6.02344,  (F)28.4219,  (F)26.0781,
    (F) 14.6016,  (F)20.3047,  (F)20.4922,
    (F) 22.0703,  (F)21.4453,  (F)19.2812,
    (F) 20.6094,  (F)19.0547,  (F)12.3828,
    (F) 16.3594,  (F)23.2031,  (F)10.2188,
    (F) 15.7969,  (F)23.8828,  (F)15.6172,
    (F) 26.7812,  (F)22.75,  (F)14.1875,
    (F) 35.4375,  (F)23.2344,  (F)16.6328,
    (F) 8.17188,  (F)20.0234,  (F)16.2969,
    (F) 10.6484,  (F)27.8281,  (F)18.1094,
    (F) 19.6172,  (F)14.7734,  (F)23.3125,
    (F) 14.5781,  (F)18.0156,  (F)31.1406,
    (F) 25.5625,  (F)22.8438,  (F)28.7656,
    (F) 24.5781,  (F)27.8438,  (F)17.75,
    (F) 28.0625,  (F)31,  (F)22.0469,
    (F) 18.9922,  (F)26.3203,  (F)23.9766,
    (F) 15.0859,  (F)36.7891,  (F)24.1406,
    (F) 20.5391,  (F)32.9688,  (F)31.1406,
    (F) 36.2422,  (F)31.6875,  (F)28.625,
    (F) 31.5234,  (F)41.6719,  (F)38.375,
};


/*
**  Band2Tb8:
**
**  Table Structure:
**      8 bit, 256 entry table.
*/

float Band2Tb8[LspCbSize*4] = {
    (F) 0,  (F)0,  (F)0,  (F)0,
    (F) 4.69531,  (F)4,  (F)-4.23438,  (F)2.60938,
    (F) 3.34375,  (F)8.49219,  (F)-3.78125,  (F)-1.03125,
    (F) 5.09375,  (F)4.85938,  (F)-3.05469,  (F)-4.46875,
    (F) 2.95312,  (F)6.24219,  (F)1.10156,  (F)-6.71875,
    (F) 8.125,  (F)3.19531,  (F)0.875,  (F)-4.32812,
    (F) 8.77344,  (F)5.23438,  (F)-0.585938,  (F)-6.61719,
    (F) 11.1016,  (F)3.85938,  (F)-2.46094,  (F)-8.55469,
    (F) 6.14844,  (F)7.82031,  (F)0.890625,  (F)-3.59375,
    (F) 7.71875,  (F)13.0625,  (F)1.6875,  (F)-5.32031,
    (F) 7.86719,  (F)9.69531,  (F)-1.03125,  (F)-9.74219,
    (F) 8.38281,  (F)3.11719,  (F)1.45312,  (F)-0.0390625,
    (F) 9.85938,  (F)1.50781,  (F)-5.42188,  (F)-1.00781,
    (F) 2.53906,  (F)1.53125,  (F)0.398438,  (F)-5.00781,
    (F) 6.72656,  (F)-0.460938,  (F)2.73438,  (F)-3.57812,
    (F) 9.85156,  (F)4.42969,  (F)4.57812,  (F)-2.70312,
    (F) 11.9688,  (F)6.91406,  (F)1.64062,  (F)-4.03906,
    (F) 15.8359,  (F)7.32031,  (F)0.882812,  (F)-6.1875,
    (F) 10.8047,  (F)8.3125,  (F)2.60938,  (F)0.296875,
    (F) 15.3438,  (F)11.4688,  (F)3.58594,  (F)1.03906,
    (F) 16.1094,  (F)9.26562,  (F)-0.765625,  (F)-0.945312,
    (F) 20.1328,  (F)11.2891,  (F)3.95312,  (F)-2.91406,
    (F) 18.0469,  (F)13.1406,  (F)-0.015625,  (F)-7.5,
    (F) 22.4688,  (F)15.1484,  (F)5.97656,  (F)1.07812,
    (F) 27.9766,  (F)18.4375,  (F)5.07031,  (F)-3.23438,
    (F) 1.71094,  (F)1.375,  (F)-3.10938,  (F)-2.41406,
    (F) 3.39062,  (F)-0.609375,  (F)-3.39844,  (F)-6.875,
    (F)-2.6875,  (F)2.35156,  (F)2.07031,  (F)-4.3125,
    (F)-7.14844,  (F)3.67188,  (F)5.13281,  (F)-2.96875,
    (F) 3.27344,  (F)-3.375,  (F)-1.27344,  (F)-3.53906,
    (F) 2.74219,  (F)-7.44531,  (F)0.0625,  (F)-4.39062,
    (F) 6.16406,  (F)-0.335938,  (F)0.15625,  (F)-7.48438,
    (F) 2.35938,  (F)-4.64062,  (F)-2.75,  (F)-9.05469,
    (F) 8.125,  (F)0.84375,  (F)-5.21875,  (F)-7.21875,
    (F) 10.4141,  (F)1.64062,  (F)-9.50781,  (F)-12.9922,
    (F) 3.77344,  (F)4.60156,  (F)-2.73438,  (F)-8.90625,
    (F) 7.83594,  (F)6.4375,  (F)-6.26562,  (F)-9.25,
    (F) 5.82031,  (F)0.453125,  (F)-4.60156,  (F)-11.2734,
    (F) 2.70312,  (F)1.92969,  (F)-7.14844,  (F)-13.1484,
    (F) 2.10938,  (F)6.21875,  (F)-5.625,  (F)-15.9609,
    (F) 9.4375,  (F)5.64062,  (F)-1.73438,  (F)-1.50781,
    (F) 11.6094,  (F)9.21875,  (F)-3.21875,  (F)-5.25,
    (F) 13.4531,  (F)1.39844,  (F)-0.539062,  (F)-4.07031,
    (F) 15.9922,  (F)6.71875,  (F)-5.20312,  (F)-11.0156,
    (F)-1.14062,  (F)1.73438,  (F)-2.19531,  (F)-6.28906,
    (F)-1.47656,  (F)0.703125,  (F)-0.890625,  (F)-10.2109,
    (F)-1.1875,  (F)8.48438,  (F)-1.88281,  (F)-5.96875,
    (F)-3.42969,  (F)5.72656,  (F)-4.69531,  (F)-10.1719,
    (F)-6.50781,  (F)-1.30469,  (F)-2.74219,  (F)-4.69531,
    (F)-6.6875,  (F)-3.29688,  (F)-3.21094,  (F)-8.27344,
    (F)-5.83594,  (F)-2.77344,  (F)-4.54688,  (F)-12.8438,
    (F)-6.53906,  (F)1.64062,  (F)-7.15625,  (F)-8.9375,
    (F)-14.0625,  (F)0.25,  (F)-6.85938,  (F)-13.1797,
    (F)-0.375,  (F)-0.179688,  (F)-8.95312,  (F)0.40625,
    (F)-2.73438,  (F)-3.19531,  (F)-12.9375,  (F)-2.84375,
    (F) 2.07031,  (F)-5.6875,  (F)-6.70312,  (F)-4.50781,
    (F) 3.57812,  (F)-1.92969,  (F)-8.91406,  (F)-7.78906,
    (F) 5.39844,  (F)-3.17969,  (F)-15.5312,  (F)-9.07031,
    (F)-0.515625,  (F)-0.8125,  (F)-5.50781,  (F)-9.75781,
    (F)-3.36719,  (F)-0.726562,  (F)-9.30469,  (F)-14.4062,
    (F) 1.58594,  (F)-5.71875,  (F)-7.8125,  (F)-13.2266,
    (F) 0.078125,  (F)-6.5,  (F)-14.4219,  (F)-14.2109,
    (F) 3.85156,  (F)-1,  (F)-11.2188,  (F)-13.8125,
    (F) 3.8125,  (F)-2.42969,  (F)-13.5156,  (F)-19.8438,
    (F)-5.10156,  (F)-4.15625,  (F)-8.98438,  (F)-9.15625,
    (F)-8.48438,  (F)-2.25781,  (F)-13.3281,  (F)-11.9766,
    (F)-5.46094,  (F)-9.41406,  (F)-9.5,  (F)-13.7969,
    (F)-8.0625,  (F)-11.5703,  (F)-16.2031,  (F)-11.8984,
    (F)-5.63281,  (F)-9.53125,  (F)-17.7891,  (F)-20.3125,
    (F) 0.09375,  (F)-4.21094,  (F)-11.5938,  (F)-8.83594,
    (F)-0.3125,  (F)-7.11719,  (F)-16.4531,  (F)-3.44531,
    (F)-3.67969,  (F)-3.78125,  (F)-17.7109,  (F)-12.1016,
    (F)-1.10156,  (F)-7.71875,  (F)-23.4844,  (F)-13.4453,
    (F)-12.0703,  (F)-16.4219,  (F)-4.55469,  (F)2.67188,
    (F)-10.8047,  (F)-21.6562,  (F)-3.01562,  (F)-0.101562,
    (F)-16.5469,  (F)-20.2266,  (F)-9.41406,  (F)0.5625,
    (F)-16.7734,  (F)-25.2422,  (F)-7.53906,  (F)3.04688,
    (F)-23.0391,  (F)-25.7812,  (F)-4.85156,  (F)4.97656,
    (F)-30.5234,  (F)-32.3281,  (F)-6.75781,  (F)6.27344,
    (F)-10.0547,  (F)-6.60156,  (F)-2.92969,  (F)-4.28125,
    (F)-11.0625,  (F)-9.13281,  (F)-3.80469,  (F)-9.97656,
    (F)-10.9375,  (F)-13.2031,  (F)-8.02344,  (F)-3.26562,
    (F)-15.7656,  (F)-14.9141,  (F)-9.28125,  (F)-9.84375,
    (F)-11.0781,  (F)-17.3594,  (F)-15.8516,  (F)-1,
    (F)-16.1484,  (F)-23.4219,  (F)-21.0391,  (F)-2.42188,
    (F)-7.42188,  (F)-8.03125,  (F)-12.0156,  (F)1.44531,
    (F)-12.625,  (F)-7.14844,  (F)-17.2266,  (F)-4.28906,
    (F) 0.148438,  (F)-6.41406,  (F)-8.94531,  (F)2.75,
    (F) 1.4375,  (F)-9.17969,  (F)-10.5938,  (F)-4.89844,
    (F)-4.27344,  (F)-8.5,  (F)-12.9766,  (F)-7.11719,
    (F)-1.6875,  (F)-11.7344,  (F)-17.1641,  (F)-7.40625,
    (F)-6.21094,  (F)-10.2031,  (F)-18.5469,  (F)-3.52344,
    (F)-7.21875,  (F)-14.7578,  (F)-21.8438,  (F)-5.3125,
    (F)-4.6875,  (F)-12.6094,  (F)-28.1953,  (F)-6.91406,
    (F)-18.6875,  (F)-19.75,  (F)2.49219,  (F)2.36719,
    (F)-22.7188,  (F)-16.3672,  (F)-2.42188,  (F)4.47656,
    (F)-27.0312,  (F)-16.7266,  (F)0.382812,  (F)-0.882812,
    (F)-17.4297,  (F)-3.5,  (F)5.27344,  (F)-1.14062,
    (F)-21.9141,  (F)-4.15625,  (F)9.61719,  (F)3.74219,
    (F)-20.9688,  (F)-3.79688,  (F)-1.5625,  (F)4.77344,
    (F)-27.5391,  (F)-7.58594,  (F)-1.54688,  (F)5.5,
    (F)-28.9609,  (F)1.35156,  (F)2.72656,  (F)1.98438,
    (F)-36.9844,  (F)-11.3047,  (F)-0.265625,  (F)6.875,
    (F) 6.07031,  (F)-4,  (F)0.890625,  (F)-0.078125,
    (F) 9.76562,  (F)-0.515625,  (F)3.45312,  (F)-0.0390625,
    (F) 4.71875,  (F)4.78906,  (F)3.53125,  (F)-2.75,
    (F) 9.5625,  (F)6.07031,  (F)5.27344,  (F)-7.92188,
    (F)-10.7188,  (F)-0.617188,  (F)-9.4375,  (F)-1.85938,
    (F)-18.6641,  (F)-0.132812,  (F)-9.03906,  (F)-6.39062,
    (F)-11.75,  (F)-5.25781,  (F)-8.85156,  (F)-8.28125,
    (F)-15.5,  (F)-6.24219,  (F)-15.6641,  (F)-15.4141,
    (F)-15.9141,  (F)-6.23438,  (F)-8.34375,  (F)-0.820312,
    (F)-24.9219,  (F)-7.02344,  (F)-14.1953,  (F)-1.51562,
    (F)-1.21875,  (F)-6.92188,  (F)3.07812,  (F)-2.48438,
    (F)-2.01562,  (F)-10.0234,  (F)4.30469,  (F)1.57812,
    (F)-4.1875,  (F)-13.5078,  (F)7.10938,  (F)2.58594,
    (F)-6.61719,  (F)-8.66406,  (F)6.21094,  (F)-1.27344,
    (F)-9.14844,  (F)-8.8125,  (F)5.58594,  (F)4.05469,
    (F)-8.4375,  (F)-10.3047,  (F)13.1641,  (F)5.21875,
    (F)-7.8125,  (F)-15.0078,  (F)0.75,  (F)1.64844,
    (F)-11.6172,  (F)-16.7812,  (F)6.49219,  (F)1.35938,
    (F)-8.89844,  (F)-2.92188,  (F)3.23438,  (F)-0.03125,
    (F)-11.8516,  (F)-10.8047,  (F)3.09375,  (F)-2.75,
    (F)-7.90625,  (F)3.42969,  (F)-0.460938,  (F)-7.55469,
    (F)-14.1562,  (F)5.51562,  (F)-3.4375,  (F)-8.04688,
    (F)-15.3984,  (F)-2.57031,  (F)-0.265625,  (F)-6.46094,
    (F)-19.3125,  (F)-12.4062,  (F)-1.17969,  (F)-4.73438,
    (F)-16.8828,  (F)2.92188,  (F)-2.19531,  (F)0.59375,
    (F)-23.5312,  (F)1.80469,  (F)-0.117188,  (F)-5.39062,
    (F) 8.625,  (F)4.42188,  (F)5.63281,  (F)1.63281,
    (F) 13.1641,  (F)4.40625,  (F)2.99219,  (F)0.765625,
    (F) 14.8281,  (F)5.85938,  (F)6.1875,  (F)-0.757812,
    (F) 4.34375,  (F)-0.5,  (F)4.38281,  (F)-0.726562,
    (F) 6.84375,  (F)1.26562,  (F)7.13281,  (F)-0.171875,
    (F) 7.50781,  (F)5.27344,  (F)10.125,  (F)1.09375,
    (F) 5.90625,  (F)-3.09375,  (F)6.64844,  (F)4.25,
    (F) 2.8125,  (F)-2.36719,  (F)10.4766,  (F)3.09375,
    (F) 6.85938,  (F)-0.171875,  (F)11.4375,  (F)6.74219,
    (F)-2.41406,  (F)-2.13281,  (F)5.01562,  (F)-1.00781,
    (F)-5.35938,  (F)-0.640625,  (F)6.57812,  (F)3.54688,
    (F)-0.0390625,  (F)-0.367188,  (F)8.35156,  (F)7.79688,
    (F)-0.734375,  (F)7.55469,  (F)9.97656,  (F)2.32812,
    (F)-3.82031,  (F)3.00781,  (F)11.5078,  (F)5.82812,
    (F)-2.88281,  (F)-5.60156,  (F)10.4141,  (F)1.89062,
    (F) 2.19531,  (F)-7.75781,  (F)13.4844,  (F)7.21875,
    (F) 3.625,  (F)4.69531,  (F)12.3047,  (F)10.75,
    (F)-1.95312,  (F)1.60938,  (F)18.2734,  (F)9.17969,
    (F)-3.42188,  (F)2.94531,  (F)-4.66406,  (F)-2.22656,
    (F)-7.96875,  (F)6.14844,  (F)-6.17188,  (F)-2.24219,
    (F)-3.57812,  (F)-3.20312,  (F)1.67969,  (F)2.30469,
    (F)-4.60156,  (F)-6.71875,  (F)-0.945312,  (F)6.22656,
    (F)-9.17969,  (F)0.953125,  (F)-3.41406,  (F)3.64062,
    (F)-11.5625,  (F)-0.945312,  (F)2.86719,  (F)7.21875,
    (F) 1.82812,  (F)2.52344,  (F)6.01562,  (F)-4.33594,
    (F) 1.13281,  (F)0.234375,  (F)7.78125,  (F)0.203125,
    (F) 0.515625,  (F)6.63281,  (F)0.726562,  (F)-1.13281,
    (F)-0.914062,  (F)9.85156,  (F)3.70312,  (F)-3.11719,
    (F)-11.6797,  (F)8.21094,  (F)1.70312,  (F)-3.95312,
    (F)-10.8594,  (F)5.42188,  (F)7.76562,  (F)0.6875,
    (F) 4.8125,  (F)0.0546875,  (F)0.609375,  (F)2.375,
    (F) 8.28125,  (F)0.40625,  (F)-0.484375,  (F)6.52344,
    (F) 6.50781,  (F)3.54688,  (F)5.07031,  (F)10.6172,
    (F)-6.01562,  (F)3.625,  (F)0.367188,  (F)0.726562,
    (F)-4.48438,  (F)9.36719,  (F)-0.304688,  (F)2.96094,
    (F) 0.890625,  (F)-0.765625,  (F)3.8125,  (F)3.78906,
    (F) 5.67969,  (F)1.90625,  (F)4.73438,  (F)5.4375,
    (F)-0.59375,  (F)3.55469,  (F)5.24219,  (F)4.26562,
    (F)-4.41406,  (F)-0.101562,  (F)1.13281,  (F)6.39844,
    (F)-2.9375,  (F)4.44531,  (F)3.5,  (F)8.8125,
    (F) 1.70312,  (F)0.953125,  (F)2.07031,  (F)9.11719,
    (F) 1.79688,  (F)5.76562,  (F)7.28125,  (F)7.83594,
    (F) 1.07812,  (F)3.72656,  (F)0.28125,  (F)3.51562,
    (F) 3.15625,  (F)6.14844,  (F)-0.570312,  (F)7.8125,
    (F) 3.88281,  (F)9.83594,  (F)3.02344,  (F)9.61719,
    (F) 0.132812,  (F)1.61719,  (F)1.52344,  (F)-0.617188,
    (F) 4.39062,  (F)2.79688,  (F)0.414062,  (F)-1.23438,
    (F) 3.85156,  (F)3.02344,  (F)3.73438,  (F)1.47656,
    (F) 5.29688,  (F)6.49219,  (F)5,  (F)4.35938,
    (F)-1.53906,  (F)4.08594,  (F)4.78906,  (F)0.445312,
    (F) 3.35156,  (F)6.98438,  (F)6.00781,  (F)0.867188,
    (F) 0.523438,  (F)9.17188,  (F)4.4375,  (F)3.99219,
    (F) 9.70312,  (F)6.4375,  (F)1.96094,  (F)6.5625,
    (F) 11.0859,  (F)8.39062,  (F)6.75,  (F)3.75781,
    (F) 7.21875,  (F)11.5156,  (F)5.22656,  (F)5.65625,
    (F) 12.0234,  (F)14.6797,  (F)5.10938,  (F)12.4219,
    (F) 3.47656,  (F)2.63281,  (F)8.67969,  (F)4.22656,
    (F) 3.6875,  (F)11.1016,  (F)9.875,  (F)8.54688,
    (F) 6.20312,  (F)5.74219,  (F)8.61719,  (F)5.21875,
    (F) 8.24219,  (F)6.74219,  (F)9.3125,  (F)7.96875,
    (F) 6.07812,  (F)8.63281,  (F)6.29688,  (F)14.0469,
    (F) 8.21875,  (F)11.9297,  (F)12.3984,  (F)16.8047,
    (F) 6.88281,  (F)12.125,  (F)9.88281,  (F)3.05469,
    (F) 5.67188,  (F)6.8125,  (F)14.1562,  (F)4.69531,
    (F) 11.4766,  (F)2.1875,  (F)7.875,  (F)4.8125,
    (F) 10.9609,  (F)4.50781,  (F)14.0859,  (F)9.71875,
    (F) 12.8906,  (F)10.2656,  (F)8.96875,  (F)8.375,
    (F) 10.1328,  (F)13.0391,  (F)14.9297,  (F)8.01562,
    (F) 16.3516,  (F)8.15625,  (F)16.5234,  (F)9.28906,
    (F) 12.8438,  (F)15.3203,  (F)20.2109,  (F)11.8125,
    (F) 0.195312,  (F)-2.46094,  (F)-0.0703125,  (F)-0.828125,
    (F) 2.26562,  (F)-2.64844,  (F)3.34375,  (F)-3.46875,
    (F)-0.53125,  (F)-6.11719,  (F)5.74219,  (F)6.03125,
    (F) 1.91406,  (F)-4.33594,  (F)3.65625,  (F)0.367188,
    (F) 2.60938,  (F)-6.99219,  (F)6.35938,  (F)1.14062,
    (F) 1.83594,  (F)2.875,  (F)-7.53125,  (F)-7.49219,
    (F)-1.58594,  (F)2.46094,  (F)-12.2344,  (F)-9.50781,
    (F) 6.25781,  (F)0.132812,  (F)-2.15625,  (F)-2.76562,
    (F) 6.98438,  (F)-3.86719,  (F)-6.16406,  (F)-4.96094,
    (F) 5.59375,  (F)2.27344,  (F)-9.28906,  (F)-2.78906,
    (F) 4.375,  (F)-2.03125,  (F)-5.72656,  (F)-0.015625,
    (F) 5.30469,  (F)-3.96875,  (F)-11.1641,  (F)1.64844,
    (F)-0.398438,  (F)-0.484375,  (F)-3.34375,  (F)4.35156,
    (F) 2.51562,  (F)-4.98438,  (F)-1.64844,  (F)4.79688,
    (F)-6.85938,  (F)-8.25781,  (F)-0.65625,  (F)-0.554688,
    (F)-3.03125,  (F)-11.0547,  (F)-1.30469,  (F)-2.48438,
    (F)-5.89062,  (F)-12.2969,  (F)1.67188,  (F)-4.21094,
    (F)-11.0859,  (F)-15.6562,  (F)-0.71875,  (F)-6.14844,
    (F)-0.367188,  (F)-6.6875,  (F)-2.71094,  (F)-1.99219,
    (F) 0.179688,  (F)-9.46094,  (F)-1.35156,  (F)2.5,
    (F)-5.14062,  (F)-3.80469,  (F)-6.97656,  (F)2.75781,
    (F)-6.11719,  (F)-12.3984,  (F)-4.5625,  (F)3.96094,
    (F)-11.0938,  (F)-6.71094,  (F)-2.95312,  (F)3.44531,
    (F)-16.3672,  (F)-11.6484,  (F)-1.07031,  (F)3.42969,
    (F)-2.50781,  (F)-11.3281,  (F)-10.0625,  (F)-0.09375,
    (F)-2.80469,  (F)-16.5078,  (F)-4.32031,  (F)-0.0625,
    (F)-6.49219,  (F)-14.9844,  (F)-12.1953,  (F)0.25,
    (F)-7.92188,  (F)-19.4297,  (F)-10.6172,  (F)-7.33594,
    (F)-3.71094,  (F)-2.42969,  (F)-1.32031,  (F)-1.84375,
    (F)-7.08594,  (F)-3.32812,  (F)2.15625,  (F)-4.77344,
    (F)-0.75,  (F)-3.125,  (F)0.390625,  (F)-5.54688,
    (F)-3.32812,  (F)-7.98438,  (F)-0.078125,  (F)-7.69531,
    (F)-1.53906,  (F)-2.01562,  (F)-5.8125,  (F)-4.49219,
    (F)-4.77344,  (F)-7.26562,  (F)-6.02344,  (F)-3.07812,
    (F)-2.08594,  (F)-6.0625,  (F)-4.78125,  (F)-7.33594,
    (F)-2,  (F)-10.5156,  (F)-6.26562,  (F)-8.76562,
    (F)-6.21875,  (F)-12.2656,  (F)-6.44531,  (F)-5.89062,
    (F) 5.5625,  (F)6.84375,  (F)1.10156,  (F)1.77344,
    (F) 7.66406,  (F)11.7891,  (F)0.664062,  (F)0.96875,
    (F) 11.4219,  (F)9.59375,  (F)7.64844,  (F)-0.304688,
    (F) 13.5469,  (F)7.80469,  (F)11.5703,  (F)3.4375,
    (F) 17.9141,  (F)8.71875,  (F)6.00781,  (F)3.4375,
    (F) 19.5625,  (F)11.5625,  (F)9.69531,  (F)2.78125,
    (F) 19.3281,  (F)14.9141,  (F)12.1719,  (F)6.32812,
    (F) 7.16406,  (F)8.85938,  (F)4.74219,  (F)-1.04688,
    (F) 3.97656,  (F)14.1328,  (F)6.10156,  (F)-0.960938,
    (F) 13.375,  (F)11.7656,  (F)4.36719,  (F)-3.30469,
    (F) 15.9141,  (F)18.1016,  (F)5.67188,  (F)-1.21094,
    (F) 23.6797,  (F)20.9062,  (F)9.39844,  (F)2.58594,
    (F) 28.625,  (F)25.5781,  (F)13.8125,  (F)4.14844,
    (F) 12.5781,  (F)14.3672,  (F)6.77344,  (F)1.42969,
    (F) 13.8594,  (F)15.4062,  (F)12.0156,  (F)0.757812,
    (F) 14.2344,  (F)16.8594,  (F)10.0156,  (F)5.14844,
    (F) 17.3594,  (F)21.5469,  (F)14.2031,  (F)7.03125,
    (F) 25.3984,  (F)16.5938,  (F)13.4609,  (F)7.78125,
    (F) 28.3828,  (F)18.25,  (F)18.8125,  (F)11.3516,
    (F) 22.8359,  (F)27.4766,  (F)20.0547,  (F)10.2969,
};

/*
**  BandQntTable:
*/

float *BandQntTable[LspQntBands] = {
   Band0Tb8 ,
   Band1Tb8 ,
   Band2Tb8 ,
   };

/*
**  PerFiltZeroTable:
**
**  Table Structure:
**     (0.9) to the x power, where x = [1,..,10]
*/

float PerFiltZeroTable[LpcOrder] = {
   (F)0.9 ,
   (F)0.81 ,
   (F)0.729 ,
   (F)0.6561 ,
   (F)0.59049 ,
   (F)0.531441 ,
   (F)0.4781969 ,
   (F)0.43046721 ,
   (F)0.38742049 ,
   (F)0.34867844 ,
};

/*
**  PerFiltPoleTable:
**
**  Table Structure:
**     (0.5) to the x power, where x = [1,..,10]
*/

float PerFiltPoleTable[LpcOrder] = {
   (F)0.5 ,
   (F)0.25 ,
   (F)0.125 ,
   (F)0.0625 ,
   (F)0.03125 ,
   (F)0.015625 ,
   (F)0.0078125 ,
   (F)0.00390625 ,
   (F)0.001953125 ,
   (F)0.0009765625 ,
};

/*
**  PostFiltZeroTable:
**
**  Table Structure:
**     (0.65) to the x power, where x = [1,..,10]
*/

float   PostFiltZeroTable[LpcOrder] = {
   (F)0.65 ,
   (F)0.4225 ,
   (F)0.274625 ,
   (F)0.17850625 ,
   (F)0.11602906 ,
   (F)0.075418891 ,
   (F)0.049022279 ,
   (F)0.031864483 ,
   (F)0.020711913 ,
   (F)0.013462743 ,
   };

/*
**  PostFiltPoleTable:
**
**  Table Structure:
**     (0.75) to the x power, where x = [1,..,10]
*/

float   PostFiltPoleTable[LpcOrder] = {
   (F)0.75 ,
   (F)0.5625 ,
   (F)0.421875 ,
   (F)0.31640625 ,
   (F)0.23730469 ,
   (F)0.177978752 ,
   (F)0.13348389 ,
   (F)0.10011292 ,
   (F)0.075084686 ,
   (F)0.056313515 ,
   };

/*
**  Nb_puls:
*/

int Nb_puls[4] = { 6,5,6,5};

/*
**  FcbkGainTable:
**
**  Table Structure:
**      Contains x where 20*log10(x) = 3.2*i,  i = 1,..,24
*/

float FcbkGainTable[NumOfGainLev] = {
   (F)2 ,
   (F)4 ,
   (F)6 ,
   (F)8 ,
   (F)12 ,
   (F)18 ,
   (F)26 ,
   (F)36 ,
   (F)52 ,
   (F)76 ,
   (F)110 ,
   (F)160 ,
   (F)230 ,
   (F)332 ,
   (F)480 ,
   (F)696 ,
   (F)1004 ,
   (F)1452 ,
   (F)2100 ,
   (F)3034 ,
   (F)4386 ,
   (F)6340 ,
   (F)9164 ,
   (F)13246 ,
};

/*
**  MaxPosTable:
*/

Word32   MaxPosTable[4] = {
 0x00090f6fL,
 0x00022caaL,
 0x00090f6fL,
 0x00022caaL,
};

/*
**  CombinatorialTable:
**
**  Table Structure:
**      CombinatorialTable[i][j] is the number of combinations of
**      (MaxPulseNum-1-i) elements among (SubFrLen-2-j)
*/

Word32   CombinatorialTable[MaxPulseNum][SubFrLen/Sgrid] = {
 { 118755L,
  98280L,
  80730L,
  65780L,
  53130L,
  42504L,
  33649L,
  26334,
  20349,
  15504,
  11628,
   8568,
   6188,
   4368,
   3003,
   2002,
   1287,
    792,
    462,
    252,
    126,
     56,
     21,
      6,
      1,
      0,
      0,
      0,
      0,
      0 },

 { 23751,
  20475,
  17550,
  14950,
  12650,
  10626,
   8855,
   7315,
   5985,
   4845,
   3876,
   3060,
   2380,
   1820,
   1365,
   1001,
    715,
    495,
    330,
    210,
    126,
     70,
     35,
     15,
      5,
      1,
      0,
      0,
      0,
      0 },

  { 3654,
   3276,
   2925,
   2600,
   2300,
   2024,
   1771,
   1540,
   1330,
   1140,
    969,
    816,
    680,
    560,
    455,
    364,
    286,
    220,
    165,
    120,
     84,
     56,
     35,
     20,
     10,
      4,
      1,
      0,
      0,
      0 },

   {  406,
    378,
    351,
    325,
    300,
    276,
    253,
    231,
    210,
    190,
    171,
    153,
    136,
    120,
    105,
     91,
     78,
     66,
     55,
     45,
     36,
     28,
     21,
     15,
     10,
      6,
      3,
      1,
      0,
      0 },

   {   29,
     28,
     27,
     26,
     25,
     24,
     23,
     22,
     21,
     20,
     19,
     18,
     17,
     16,
     15,
     14,
     13,
     12,
     11,
     10,
      9,
      8,
      7,
      6,
      5,
      4,
      3,
      2,
      1,
      0  },

   {    1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1,
      1 }
   };

/*
**  AcbkGainTable085:
**
**  Table Structure:
**    1st 5 elements:   G1  G2  G3  G4  G5 in Q14
**    2nd 5 elements:  -G1^2  -G2^2  -G3^2  -G4^2  -G5^2
**    Next 10 elements: These are the off-diagonal elements
**           -G1*G2  -G1*G3  -G2*G3  -G1*G4  -G2*G4
**           -G3*G4  -G1*G5  -G2*G5  -G3*G5  -G4*G5
*/

 float   AcbkGainTable085[85*20] = {
 (F)0.000000, (F)0.000000, (F)0.000000, (F)0.000000, (F)0.000000, (F)0.000000,
(F)0.000000, (F)0.000000, (F)0.000000, (F)0.000000, (F)0.000000, (F)0.000000,
(F)0.000000, (F)0.000000, (F)0.000000, (F)0.000000, (F)0.000000, (F)0.000000,
(F)0.000000, (F)0.000000,
(F)0.048828, (F)0.091309, (F)0.010193, (F)-0.015625, (F)-0.020630, (F)-0.002384,
(F)-0.008337, (F)-0.000104, (F)-0.000244, (F)-0.000426, (F)-0.004458, (F)-0.000498,
(F)-0.000931, (F)0.000763, (F)0.001427, (F)0.000159, (F)0.001007, (F)0.001884,
(F)0.000210, (F)-0.000322,
(F)-0.028198, (F)-0.041870, (F)0.030090, (F)0.157166, (F)0.018982, (F)-0.000795,
(F)-0.001753, (F)-0.000905, (F)-0.024701, (F)-0.000360, (F)-0.001181, (F)0.000848,
(F)0.001260, (F)0.004432, (F)0.006581, (F)-0.004729, (F)0.000535, (F)0.000795,
(F)-0.000571, (F)-0.002983,
(F)0.090515, (F)0.008789, (F)0.047852, (F)0.056641, (F)0.075867, (F)-0.008193,
(F)-0.000077, (F)-0.002290, (F)-0.003208, (F)-0.005756, (F)-0.000796, (F)-0.004331,
(F)-0.000421, (F)-0.005127, (F)-0.000498, (F)-0.002710, (F)-0.006867, (F)-0.000667,
(F)-0.003630, (F)-0.004297,
(F)-0.004700, (F)0.016785, (F)0.214966, (F)0.064453, (F)-0.076538, (F)-0.000022,
(F)-0.000282, (F)-0.046210, (F)-0.004154, (F)-0.005858, (F)0.000079, (F)0.001010,
(F)-0.003608, (F)0.000303, (F)-0.001082, (F)-0.013855, (F)-0.000360, (F)0.001285,
(F)0.016453, (F)0.004933,
(F)-0.007629, (F)-0.002441, (F)-0.016113, (F)0.023254, (F)0.306824, (F)-0.000058,
(F)-0.000006, (F)-0.000260, (F)-0.000541, (F)-0.094141, (F)-0.000019, (F)-0.000123,
(F)-0.000039, (F)0.000177, (F)0.000057, (F)0.000375, (F)0.002341, (F)0.000749,
(F)0.004944, (F)-0.007135,
(F)0.008423, (F)0.020264, (F)0.135193, (F)0.157104, (F)0.081726, (F)-0.000071,
(F)-0.000411, (F)-0.018277, (F)-0.024682, (F)-0.006679, (F)-0.000171, (F)-0.001139,
(F)-0.002740, (F)-0.001323, (F)-0.003184, (F)-0.021239, (F)-0.000688, (F)-0.001656,
(F)-0.011049, (F)-0.012840,
(F)0.224915, (F)0.175964, (F)-0.054138, (F)0.052856, (F)-0.100037, (F)-0.050587,
(F)-0.030963, (F)-0.002931, (F)-0.002794, (F)-0.010007, (F)-0.039577, (F)0.012176,
(F)0.009526, (F)-0.011888, (F)-0.009301, (F)0.002862, (F)0.022500, (F)0.017603,
(F)-0.005416, (F)0.005288,
(F)0.085205, (F)0.130981, (F)0.136414, (F)0.021057, (F)0.057495, (F)-0.007260,
(F)-0.017156, (F)-0.018609, (F)-0.000443, (F)-0.003306, (F)-0.011160, (F)-0.011623,
(F)-0.017868, (F)-0.001794, (F)-0.002758, (F)-0.002872, (F)-0.004899, (F)-0.007531,
(F)-0.007843, (F)-0.001211,
(F)0.000793, (F)0.273132, (F)0.216614, (F)-0.049072, (F)-0.039978, (F)-0.000001,
(F)-0.074601, (F)-0.046922, (F)-0.002408, (F)-0.001598, (F)-0.000217, (F)-0.000172,
(F)-0.059164, (F)0.000039, (F)0.013403, (F)0.010630, (F)0.000032, (F)0.010919,
(F)0.008660, (F)-0.001962,
(F)-0.044189, (F)0.015503, (F)0.014771, (F)0.369202, (F)0.150269, (F)-0.001953,
(F)-0.000240, (F)-0.000218, (F)-0.136310, (F)-0.022581, (F)0.000685, (F)0.000653,
(F)-0.000229, (F)0.016315, (F)-0.005724, (F)-0.005453, (F)0.006640, (F)-0.002330,
(F)-0.002220, (F)-0.055479,
(F)0.038208, (F)-0.104553, (F)0.373596, (F)0.278381, (F)-0.064758, (F)-0.001460,
(F)-0.010931, (F)-0.139574, (F)-0.077496, (F)-0.004194, (F)0.003995, (F)-0.014274,
(F)0.039061, (F)-0.010636, (F)0.029106, (F)-0.104002, (F)0.002474, (F)-0.006771,
(F)0.024193, (F)0.018028,
(F)-0.021362, (F)0.084900, (F)0.487366, (F)0.031189, (F)-0.024719, (F)-0.000456,
(F)-0.007208, (F)-0.237525, (F)-0.000973, (F)-0.000611, (F)0.001814, (F)0.010411,
(F)-0.041377, (F)0.000666, (F)-0.002648, (F)-0.015200, (F)-0.000528, (F)0.002099,
(F)0.012047, (F)0.000771,
(F)0.191895, (F)-0.032288, (F)0.037109, (F)0.154419, (F)0.236694, (F)-0.036824,
(F)-0.001042, (F)-0.001377, (F)-0.023845, (F)-0.056024, (F)0.006196, (F)-0.007121,
(F)0.001198, (F)-0.029632, (F)0.004986, (F)-0.005730, (F)-0.045420, (F)0.007642,
(F)-0.008784, (F)-0.036550,
(F)0.158020, (F)-0.042053, (F)0.185852, (F)0.341980, (F)-0.024658, (F)-0.024970,
(F)-0.001768, (F)-0.034541, (F)-0.116950, (F)-0.000608, (F)0.006645, (F)-0.029368,
(F)0.007816, (F)-0.054040, (F)0.014381, (F)-0.063558, (F)0.003896, (F)-0.001037,
(F)0.004583, (F)0.008433,
(F)0.189636, (F)0.031311, (F)0.083862, (F)-0.219360, (F)-0.300415, (F)-0.035962,
(F)-0.000980, (F)-0.007033, (F)-0.048119, (F)-0.090249, (F)-0.005938, (F)-0.015903,
(F)-0.002626, (F)0.041599, (F)0.006868, (F)0.018396, (F)0.056970, (F)0.009406,
(F)0.025193, (F)-0.065899,
(F)0.150635, (F)0.366821, (F)0.067566, (F)-0.023804, (F)0.119690, (F)-0.022691,
(F)-0.134558, (F)-0.004565, (F)-0.000567, (F)-0.014326, (F)-0.055256, (F)-0.010178,
(F)-0.024785, (F)0.003586, (F)0.008732, (F)0.001608, (F)-0.018029, (F)-0.043905,
(F)-0.008087, (F)0.002849,
(F)0.291321, (F)0.168823, (F)0.144531, (F)0.296753, (F)-0.246826, (F)-0.084868,
(F)-0.028501, (F)-0.020889, (F)-0.088062, (F)-0.060923, (F)-0.049182, (F)-0.042105,
(F)-0.024400, (F)-0.086450, (F)-0.050099, (F)-0.042890, (F)0.071906, (F)0.041670,
(F)0.035674, (F)0.073246,
(F)0.101624, (F)-0.114685, (F)0.088074, (F)0.103821, (F)0.522583, (F)-0.010327,
(F)-0.013153, (F)-0.007757, (F)-0.010779, (F)-0.273093, (F)0.011655, (F)-0.008950,
(F)0.010101, (F)-0.010551, (F)0.011907, (F)-0.009144, (F)-0.053107, (F)0.059932,
(F)-0.046026, (F)-0.054255,
(F)0.165771, (F)0.549988, (F)-0.061462, (F)0.046082, (F)-0.108948, (F)-0.027480,
(F)-0.302487, (F)-0.003778, (F)-0.002124, (F)-0.011870, (F)-0.091172, (F)0.010189,
(F)0.033804, (F)-0.007639, (F)-0.025344, (F)0.002832, (F)0.018060, (F)0.059920,
(F)-0.006696, (F)0.005020,
(F)-0.166443, (F)0.460693, (F)0.078430, (F)0.057251, (F)0.208740, (F)-0.027703,
(F)-0.212238, (F)-0.006151, (F)-0.003278, (F)-0.043572, (F)0.076679, (F)0.013054,
(F)-0.036132, (F)0.009529, (F)-0.026375, (F)-0.004490, (F)0.034743, (F)-0.096165,
(F)-0.016372, (F)-0.011951,
(F)0.224426, (F)0.053833, (F)0.247192, (F)0.073364, (F)0.141785, (F)-0.050367,
(F)-0.002898, (F)-0.061104, (F)-0.005382, (F)-0.020103, (F)-0.012082, (F)-0.055476,
(F)-0.013307, (F)-0.016465, (F)-0.003949, (F)-0.018135, (F)-0.031820, (F)-0.007633,
(F)-0.035048, (F)-0.010402,
(F)0.124878, (F)-0.045959, (F)0.007446, (F)0.616577, (F)0.036804, (F)-0.015594,
(F)-0.002112, (F)-0.000055, (F)-0.380167, (F)-0.001355, (F)0.005739, (F)-0.000930,
(F)0.000342, (F)-0.076997, (F)0.028338, (F)-0.004591, (F)-0.004596, (F)0.001692,
(F)-0.000274, (F)-0.022693,
(F)0.027405, (F)-0.110779, (F)0.652466, (F)0.236206, (F)-0.032166, (F)-0.000751,
(F)-0.012272, (F)-0.425712, (F)-0.055793, (F)-0.001035, (F)0.003036, (F)-0.017881,
(F)0.072279, (F)-0.006473, (F)0.026167, (F)-0.154116, (F)0.000881, (F)-0.003563,
(F)0.020987, (F)0.007598,
(F)-0.057434, (F)0.143555, (F)0.308167, (F)0.222778, (F)0.160950, (F)-0.003299,
(F)-0.020608, (F)-0.094967, (F)-0.049630, (F)-0.025905, (F)0.008245, (F)0.017699,
(F)-0.044239, (F)0.012795, (F)-0.031981, (F)-0.068653, (F)0.009244, (F)-0.023105,
(F)-0.049599, (F)-0.035856,
(F)-0.114685, (F)0.048584, (F)0.190247, (F)0.584045, (F)-0.024658, (F)-0.013153,
(F)-0.002360, (F)-0.036194, (F)-0.341109, (F)-0.000608, (F)0.005572, (F)0.021818,
(F)-0.009243, (F)0.066981, (F)-0.028375, (F)-0.111113, (F)-0.002828, (F)0.001198,
(F)0.004691, (F)0.014402,
(F)-0.104675, (F)0.124695, (F)-0.127930, (F)0.607056, (F)0.244202, (F)-0.010957,
(F)-0.015549, (F)-0.016366, (F)-0.368517, (F)-0.059634, (F)0.013052, (F)-0.013391,
(F)0.015952, (F)0.063544, (F)-0.075697, (F)0.077660, (F)0.025562, (F)-0.030451,
(F)0.031241, (F)-0.148244,
(F)-0.352295, (F)-0.037720, (F)-0.239319, (F)0.017334, (F)-0.192566, (F)-0.124112,
(F)-0.001423, (F)-0.057274, (F)-0.000300, (F)-0.037082, (F)-0.013288, (F)-0.084311,
(F)-0.009027, (F)0.006107, (F)0.000654, (F)0.004148, (F)-0.067840, (F)-0.007264,
(F)-0.046085, (F)0.003338,
(F)0.023315, (F)0.289795, (F)0.488464, (F)-0.125977, (F)0.134155, (F)-0.000544,
(F)-0.083981, (F)-0.238597, (F)-0.015870, (F)-0.017998, (F)-0.006757, (F)-0.011389,
(F)-0.141554, (F)0.002937, (F)0.036507, (F)0.061535, (F)-0.003128, (F)-0.038878,
(F)-0.065530, (F)0.016900,
(F)-0.052917, (F)0.184021, (F)0.727905, (F)-0.102234, (F)0.057800, (F)-0.002800,
(F)-0.033864, (F)-0.529846, (F)-0.010452, (F)-0.003341, (F)0.009738, (F)0.038519,
(F)-0.133950, (F)-0.005410, (F)0.018813, (F)0.074417, (F)0.003059, (F)-0.010636,
(F)-0.042073, (F)0.005909,
(F)-0.301086, (F)-0.026367, (F)0.412415, (F)0.230164, (F)0.082520, (F)-0.090653,
(F)-0.000695, (F)-0.170086, (F)-0.052975, (F)-0.006809, (F)-0.007939, (F)0.124172,
(F)0.010874, (F)0.069299, (F)0.006069, (F)-0.094923, (F)0.024846, (F)0.002176,
(F)-0.034032, (F)-0.018993,
(F)0.009277, (F)0.593628, (F)0.258240, (F)-0.117676, (F)0.090942, (F)-0.000086,
(F)-0.352394, (F)-0.066688, (F)-0.013848, (F)-0.008271, (F)-0.005507, (F)-0.002396,
(F)-0.153298, (F)0.001092, (F)0.069856, (F)0.030389, (F)-0.000844, (F)-0.053986,
(F)-0.023485, (F)0.010702,
(F)0.153320, (F)0.011780, (F)0.551331, (F)0.327209, (F)-0.192139, (F)-0.023507,
(F)-0.000139, (F)-0.303965, (F)-0.107066, (F)-0.036917, (F)-0.001806, (F)-0.084530,
(F)-0.006495, (F)-0.050168, (F)-0.003854, (F)-0.180401, (F)0.029459, (F)0.002263,
(F)0.105932, (F)0.062870,
(F)0.516602, (F)0.173584, (F)0.000732, (F)0.033508, (F)0.130127, (F)-0.266877,
(F)-0.030131, (F)-0.000001, (F)-0.001123, (F)-0.016933, (F)-0.089674, (F)-0.000378,
(F)-0.000127, (F)-0.017310, (F)-0.005817, (F)-0.000025, (F)-0.067224, (F)-0.022588,
(F)-0.000095, (F)-0.004360,
(F)0.130676, (F)-0.158813, (F)0.437378, (F)0.552124, (F)-0.082397, (F)-0.017076,
(F)-0.025222, (F)-0.191299, (F)-0.304841, (F)-0.006789, (F)0.020753, (F)-0.057155,
(F)0.069462, (F)-0.072150, (F)0.087685, (F)-0.241487, (F)0.010767, (F)-0.013086,
(F)0.036039, (F)0.045494,
(F)-0.014893, (F)0.016968, (F)0.812195, (F)0.074890, (F)-0.009827, (F)-0.000222,
(F)-0.000288, (F)-0.659660, (F)-0.005609, (F)-0.000097, (F)0.000253, (F)0.012096,
(F)-0.013781, (F)0.001115, (F)-0.001271, (F)-0.060825, (F)-0.000146, (F)0.000167,
(F)0.007981, (F)0.000736,
(F)-0.118835, (F)0.501526, (F)0.382629, (F)0.055969, (F)-0.156189, (F)-0.014122,
(F)-0.251528, (F)-0.146405, (F)-0.003133, (F)-0.024395, (F)0.059599, (F)0.045470,
(F)-0.191899, (F)0.006651, (F)-0.028070, (F)-0.021415, (F)-0.018561, (F)0.078333,
(F)0.059762, (F)0.008742,
(F)-0.110474, (F)0.125793, (F)-0.169739, (F)0.369629, (F)0.613892, (F)-0.012204,
(F)-0.015824, (F)-0.028811, (F)-0.136626, (F)-0.376863, (F)0.013897, (F)-0.018752,
(F)0.021352, (F)0.040834, (F)-0.046497, (F)0.062740, (F)0.067819, (F)-0.077224,
(F)0.104201, (F)-0.226912,
(F)0.477722, (F)0.559143, (F)-0.208069, (F)0.150940, (F)-0.092163, (F)-0.228218,
(F)-0.312641, (F)-0.043293, (F)-0.022783, (F)-0.008494, (F)-0.267115, (F)0.099399,
(F)0.116340, (F)-0.072107, (F)-0.084397, (F)0.031406, (F)0.044028, (F)0.051532,
(F)-0.019176, (F)0.013911,
(F)-0.087280, (F)0.507385, (F)0.582336, (F)-0.180359, (F)0.099243, (F)-0.007618,
(F)-0.257440, (F)-0.339116, (F)-0.032529, (F)-0.009849, (F)0.044285, (F)0.050826,
(F)-0.295469, (F)-0.015742, (F)0.091511, (F)0.105030, (F)0.008662, (F)-0.050355,
(F)-0.057793, (F)0.017899,
(F)0.172058, (F)-0.259216, (F)0.329041, (F)0.529358, (F)0.168213, (F)-0.029604,
(F)-0.067193, (F)-0.108268, (F)-0.280220, (F)-0.028296, (F)0.044600, (F)-0.056614,
(F)0.085293, (F)-0.091080, (F)0.137218, (F)-0.174180, (F)-0.028942, (F)0.043604,
(F)-0.055349, (F)-0.089045,
(F)0.008606, (F)0.888184, (F)0.042114, (F)0.015686, (F)-0.006836, (F)-0.000074,
(F)-0.788870, (F)-0.001774, (F)-0.000246, (F)-0.000047, (F)-0.007644, (F)-0.000362,
(F)-0.037405, (F)-0.000135, (F)-0.013932, (F)-0.000661, (F)0.000059, (F)0.006072,
(F)0.000288, (F)0.000107,
(F)0.728638, (F)-0.113464, (F)0.110229, (F)-0.058716, (F)-0.053955, (F)-0.530913,
(F)-0.012874, (F)-0.012151, (F)-0.003448, (F)-0.002911, (F)0.082674, (F)-0.080317,
(F)0.012507, (F)0.042783, (F)-0.006662, (F)0.006472, (F)0.039314, (F)-0.006122,
(F)0.005947, (F)-0.003168,
(F)0.227539, (F)0.120972, (F)0.138184, (F)0.279785, (F)0.191101, (F)-0.051774,
(F)-0.014634, (F)-0.019095, (F)-0.078280, (F)-0.036520, (F)-0.027526, (F)-0.031442,
(F)-0.016716, (F)-0.063662, (F)-0.033846, (F)-0.038662, (F)-0.043483, (F)-0.023118,
(F)-0.026407, (F)-0.053467,
(F)-0.072083, (F)0.046753, (F)0.043945, (F)0.872986, (F)-0.013184, (F)-0.005196,
(F)-0.002186, (F)-0.001931, (F)-0.762104, (F)-0.000174, (F)0.003370, (F)0.003168,
(F)-0.002055, (F)0.062927, (F)-0.040815, (F)-0.038364, (F)-0.000950, (F)0.000616,
(F)0.000579, (F)0.011509,
(F)-0.267639, (F)0.294556, (F)0.617188, (F)0.095764, (F)0.206787, (F)-0.071631,
(F)-0.086763, (F)-0.380920, (F)-0.009171, (F)-0.042761, (F)0.078835, (F)0.165184,
(F)-0.181796, (F)0.025630, (F)-0.028208, (F)-0.059104, (F)0.055344, (F)-0.060910,
(F)-0.127626, (F)-0.019803,
(F)-0.027344, (F)0.117920, (F)0.951599, (F)-0.112427, (F)0.040100, (F)-0.000748,
(F)-0.013905, (F)-0.905541, (F)-0.012640, (F)-0.001608, (F)0.003224, (F)0.026020,
(F)-0.112212, (F)-0.003074, (F)0.013257, (F)0.106985, (F)0.001096, (F)-0.004729,
(F)-0.038159, (F)0.004508,
(F)-0.252747, (F)0.112549, (F)0.241821, (F)0.336731, (F)0.379639, (F)-0.063881,
(F)-0.012667, (F)-0.058478, (F)-0.113388, (F)-0.144126, (F)0.028446, (F)0.061120,
(F)-0.027217, (F)0.085108, (F)-0.037899, (F)-0.081429, (F)0.095952, (F)-0.042728,
(F)-0.091805, (F)-0.127836,
(F)0.044495, (F)-0.140320, (F)0.900574, (F)0.223206, (F)-0.058105, (F)-0.001980,
(F)-0.019690, (F)-0.811033, (F)-0.049821, (F)-0.003376, (F)0.006243, (F)-0.040071,
(F)0.126368, (F)-0.009931, (F)0.031320, (F)-0.201013, (F)0.002585, (F)-0.008153,
(F)0.052328, (F)0.012969,
(F)-0.084534, (F)0.354065, (F)0.814148, (F)-0.191467, (F)0.082031, (F)-0.007146,
(F)-0.125362, (F)-0.662837, (F)-0.036660, (F)-0.006729, (F)0.029930, (F)0.068823,
(F)-0.288261, (F)-0.016185, (F)0.067792, (F)0.155883, (F)0.006934, (F)-0.029044,
(F)-0.066786, (F)0.015706,
(F)0.287476, (F)0.589661, (F)0.065491, (F)-0.150574, (F)0.199829, (F)-0.082642,
(F)-0.347700, (F)-0.004289, (F)-0.022672, (F)-0.039932, (F)-0.169513, (F)-0.018827,
(F)-0.038617, (F)0.043286, (F)0.088787, (F)0.009861, (F)-0.057446, (F)-0.117831,
(F)-0.013087, (F)0.030089,
(F)0.112488, (F)-0.221191, (F)0.758179, (F)0.421021, (F)-0.095154, (F)-0.012654,
(F)-0.048926, (F)-0.574835, (F)-0.177258, (F)-0.009054, (F)0.024881, (F)-0.085286,
(F)0.167703, (F)-0.047360, (F)0.093126, (F)-0.319209, (F)0.010704, (F)-0.021047,
(F)0.072144, (F)0.040062,
(F)0.087463, (F)0.146118, (F)0.153015, (F)0.084229, (F)0.535889, (F)-0.007650,
(F)-0.021351, (F)-0.023414, (F)-0.007094, (F)-0.287177, (F)-0.012780, (F)-0.013383,
(F)-0.022358, (F)-0.007367, (F)-0.012307, (F)-0.012888, (F)-0.046871, (F)-0.078303,
(F)-0.081999, (F)-0.045137,
(F)-0.104492, (F)0.788269, (F)0.359070, (F)-0.134094, (F)0.060486, (F)-0.010919,
(F)-0.621368, (F)-0.128931, (F)-0.017981, (F)-0.003659, (F)0.082368, (F)0.037520,
(F)-0.283044, (F)-0.014012, (F)0.105702, (F)0.048149, (F)0.006320, (F)-0.047679,
(F)-0.021719, (F)0.008111,
(F)0.919922, (F)0.131714, (F)-0.075989, (F)0.055542, (F)-0.030273, (F)-0.846256,
(F)-0.017349, (F)-0.005774, (F)-0.003085, (F)-0.000916, (F)-0.121166, (F)0.069904,
(F)0.010009, (F)-0.051094, (F)-0.007316, (F)0.004221, (F)0.027849, (F)0.003987,
(F)-0.002300, (F)0.001681,
(F)0.284119, (F)0.446716, (F)0.300049, (F)0.035767, (F)-0.206360, (F)-0.080723,
(F)-0.199555, (F)-0.090029, (F)-0.001279, (F)-0.042584, (F)-0.126920, (F)-0.085249,
(F)-0.134037, (F)-0.010162, (F)-0.015978, (F)-0.010732, (F)0.058631, (F)0.092184,
(F)0.061918, (F)0.007381,
(F)0.072693, (F)-0.130615, (F)0.312500, (F)0.823853, (F)-0.086548, (F)-0.005284,
(F)-0.017060, (F)-0.097656, (F)-0.678733, (F)-0.007491, (F)0.009495, (F)-0.022717,
(F)0.040817, (F)-0.059888, (F)0.107608, (F)-0.257454, (F)0.006291, (F)-0.011304,
(F)0.027046, (F)0.071303,
(F)-0.093384, (F)-0.049866, (F)0.499939, (F)0.587891, (F)-0.088623, (F)-0.008721,
(F)-0.002487, (F)-0.249939, (F)-0.345615, (F)-0.007854, (F)-0.004657, (F)0.046686,
(F)0.024930, (F)0.054899, (F)0.029316, (F)-0.293909, (F)-0.008276, (F)-0.004419,
(F)0.044306, (F)0.052101,
(F)-0.197510, (F)0.037048, (F)0.103516, (F)-0.128540, (F)0.700989, (F)-0.039010,
(F)-0.001373, (F)-0.010715, (F)-0.016523, (F)-0.491385, (F)0.007317, (F)0.020445,
(F)-0.003835, (F)-0.025388, (F)0.004762, (F)0.013306, (F)0.138452, (F)-0.025970,
(F)-0.072563, (F)0.090105,
(F)0.195496, (F)-0.116150, (F)-0.051086, (F)0.590759, (F)0.430725, (F)-0.038219,
(F)-0.013491, (F)-0.002610, (F)-0.348997, (F)-0.185524, (F)0.022707, (F)0.009987,
(F)-0.005934, (F)-0.115491, (F)0.068617, (F)0.030180, (F)-0.084205, (F)0.050029,
(F)0.022004, (F)-0.254455,
(F)0.013000, (F)-0.039978, (F)1.038513, (F)0.037842, (F)-0.023438, (F)-0.000169,
(F)-0.001598, (F)-1.078510, (F)-0.001432, (F)-0.000549, (F)0.000520, (F)-0.013501,
(F)0.041518, (F)-0.000492, (F)0.001513, (F)-0.039299, (F)0.000305, (F)-0.000937,
(F)0.024340, (F)0.000887,
(F)0.310547, (F)0.002136, (F)-0.203796, (F)0.227417, (F)0.518066, (F)-0.096439,
(F)-0.000005, (F)-0.041533, (F)-0.051718, (F)-0.268393, (F)-0.000663, (F)0.063288,
(F)0.000435, (F)-0.070624, (F)-0.000486, (F)0.046347, (F)-0.160884, (F)-0.001107,
(F)0.105580, (F)-0.117817,
(F)-0.060303, (F)0.088745, (F)-0.164062, (F)0.917908, (F)0.163696, (F)-0.003636,
(F)-0.007876, (F)-0.026917, (F)-0.842555, (F)-0.026796, (F)0.005352, (F)-0.009893,
(F)0.014560, (F)0.055352, (F)-0.081460, (F)0.150594, (F)0.009871, (F)-0.014527,
(F)0.026856, (F)-0.150258,
(F)-0.296936, (F)-0.173462, (F)-0.003235, (F)0.335388, (F)0.398132, (F)-0.088171,
(F)-0.030089, (F)-0.000010, (F)-0.112485, (F)-0.158509, (F)-0.051507, (F)-0.000961,
(F)-0.000561, (F)0.099589, (F)0.058177, (F)0.001085, (F)0.118220, (F)0.069061,
(F)0.001288, (F)-0.133529,
(F)0.187744, (F)0.919739, (F)-0.177856, (F)0.110474, (F)-0.059265, (F)-0.035248,
(F)-0.845919, (F)-0.031633, (F)-0.012204, (F)-0.003512, (F)-0.172676, (F)0.033392,
(F)0.163581, (F)-0.020741, (F)-0.101607, (F)0.019648, (F)0.011127, (F)0.054508,
(F)-0.010541, (F)0.006547,
(F)0.080017, (F)0.326843, (F)0.674683, (F)0.140320, (F)-0.223022, (F)-0.006403,
(F)-0.106827, (F)-0.455197, (F)-0.019690, (F)-0.049739, (F)-0.026153, (F)-0.053986,
(F)-0.220515, (F)-0.011228, (F)-0.045863, (F)-0.094671, (F)0.017846, (F)0.072893,
(F)0.150469, (F)0.031294,
(F)0.246277, (F)0.342957, (F)0.281860, (F)0.110779, (F)0.116699, (F)-0.060652,
(F)-0.117619, (F)-0.079445, (F)-0.012272, (F)-0.013619, (F)-0.084462, (F)-0.069416,
(F)-0.096666, (F)-0.027282, (F)-0.037992, (F)-0.031224, (F)-0.028740, (F)-0.040023,
(F)-0.032893, (F)-0.012928,
(F)-0.130066, (F)0.168091, (F)-0.274719, (F)0.786072, (F)0.453613, (F)-0.016917,
(F)-0.028255, (F)-0.075471, (F)-0.617909, (F)-0.205765, (F)0.021863, (F)-0.035732,
(F)0.046178, (F)0.102241, (F)-0.132131, (F)0.215949, (F)0.059000, (F)-0.076248,
(F)0.124616, (F)-0.356573,
(F)0.342896, (F)-0.031433, (F)0.196472, (F)-0.253235, (F)0.296448, (F)-0.117577,
(F)-0.000988, (F)-0.038601, (F)-0.064128, (F)-0.087881, (F)0.010778, (F)-0.067369,
(F)0.006176, (F)0.086833, (F)-0.007960, (F)0.049754, (F)-0.101651, (F)0.009318,
(F)-0.058244, (F)0.075071,
(F)0.112183, (F)-0.104309, (F)0.069519, (F)1.029480, (F)0.043701, (F)-0.012585,
(F)-0.010880, (F)-0.004833, (F)-1.059829, (F)-0.001910, (F)0.011702, (F)-0.007799,
(F)0.007251, (F)-0.115490, (F)0.107384, (F)-0.071568, (F)-0.004903, (F)0.004558,
(F)-0.003038, (F)-0.044989,
(F)0.120728, (F)-0.234680, (F)0.613403, (F)0.723511, (F)-0.152100, (F)-0.014575,
(F)-0.055075, (F)-0.376264, (F)-0.523468, (F)-0.023134, (F)0.028332, (F)-0.074055,
(F)0.143954, (F)-0.087348, (F)0.169794, (F)-0.443804, (F)0.018363, (F)-0.035695,
(F)0.093298, (F)0.110046,
(F)-0.158691, (F)0.686401, (F)0.689026, (F)-0.222595, (F)0.089294, (F)-0.025183,
(F)-0.471147, (F)-0.474757, (F)-0.049549, (F)-0.007973, (F)0.108926, (F)0.109342,
(F)-0.472948, (F)-0.035324, (F)0.152790, (F)0.153374, (F)0.014170, (F)-0.061292,
(F)-0.061526, (F)0.019877,
(F)0.210083, (F)0.055359, (F)0.166321, (F)0.547485, (F)0.222046, (F)-0.044135,
(F)-0.003065, (F)-0.027663, (F)-0.299740, (F)-0.049304, (F)-0.011630, (F)-0.034941,
(F)-0.009207, (F)-0.115017, (F)-0.030308, (F)-0.091058, (F)-0.046648, (F)-0.012292,
(F)-0.036931, (F)-0.121567,
(F)-0.007690, (F)1.067993, (F)0.212463, (F)-0.122253, (F)0.066528, (F)-0.000059,
(F)-1.140609, (F)-0.045141, (F)-0.014946, (F)-0.004426, (F)0.008213, (F)0.001634,
(F)-0.226909, (F)-0.000940, (F)0.130566, (F)0.025974, (F)0.000512, (F)-0.071052,
(F)-0.014135, (F)0.008133,
(F)-0.110718, (F)0.063965, (F)-0.132080, (F)0.248413, (F)0.993164, (F)-0.012258,
(F)-0.004092, (F)-0.017445, (F)-0.061709, (F)-0.986375, (F)0.007082, (F)-0.014624,
(F)0.008448, (F)0.027504, (F)-0.015890, (F)0.032810, (F)0.109961, (F)-0.063528,
(F)0.131177, (F)-0.246715,
(F)0.570923, (F)0.767822, (F)-0.114929, (F)0.058716, (F)-0.037659, (F)-0.325953,
(F)-0.589551, (F)-0.013209, (F)-0.003448, (F)-0.001418, (F)-0.438367, (F)0.065616,
(F)0.088245, (F)-0.033522, (F)-0.045083, (F)0.006748, (F)0.021500, (F)0.028915,
(F)-0.004328, (F)0.002211,
(F)0.104248, (F)0.256287, (F)0.450867, (F)0.386658, (F)0.061218, (F)-0.010868,
(F)-0.065683, (F)-0.203281, (F)-0.149504, (F)-0.003748, (F)-0.026717, (F)-0.047002,
(F)-0.115551, (F)-0.040308, (F)-0.099095, (F)-0.174331, (F)-0.006382, (F)-0.015689,
(F)-0.027601, (F)-0.023671,
(F)-0.160156, (F)0.343201, (F)1.056519, (F)-0.143616, (F)0.036133, (F)-0.025650,
(F)-0.117787, (F)-1.116231, (F)-0.020625, (F)-0.001306, (F)0.054966, (F)0.169208,
(F)-0.362598, (F)-0.023001, (F)0.049289, (F)0.151733, (F)0.005787, (F)-0.012401,
(F)-0.038175, (F)0.005189,
(F)0.073914, (F)-0.051880, (F)0.072815, (F)-0.117554, (F)0.976074, (F)-0.005463,
(F)-0.002692, (F)-0.005302, (F)-0.013819, (F)-0.952721, (F)0.003835, (F)-0.005382,
(F)0.003778, (F)0.008689, (F)-0.006099, (F)0.008560, (F)-0.072145, (F)0.050639,
(F)-0.071073, (F)0.114741,
(F)0.243103, (F)-0.125366, (F)0.702271, (F)-0.001160, (F)0.221069, (F)-0.059099,
(F)-0.015717, (F)-0.493184, (F)-0.000001, (F)-0.048872, (F)0.030477, (F)-0.170724,
(F)0.088041, (F)0.000282, (F)-0.000145, (F)0.000814, (F)-0.053743, (F)0.027715,
(F)-0.155250, (F)0.000256,
(F)-0.047974, (F)-0.082642, (F)0.982178, (F)0.442261, (F)-0.101624, (F)-0.002301,
(F)-0.006830, (F)-0.964673, (F)-0.195595, (F)-0.010327, (F)-0.003965, (F)0.047119,
(F)0.081169, (F)0.021217, (F)0.036549, (F)-0.434379, (F)-0.004875, (F)-0.008398,
(F)0.099812, (F)0.044944,
(F)-0.263428, (F)-0.031189, (F)0.407349, (F)0.711975, (F)0.282776, (F)-0.069394,
(F)-0.000973, (F)-0.165933, (F)-0.506909, (F)-0.079962, (F)-0.008216, (F)0.107307,
(F)0.012705, (F)0.187554, (F)0.022206, (F)-0.290022, (F)0.074491, (F)0.008819,
(F)-0.115188, (F)-0.201329,
(F)0.482910, (F)0.278137, (F)0.118225, (F)0.115051, (F)0.429504, (F)-0.233202,
(F)-0.077360, (F)-0.013977, (F)-0.013237, (F)-0.184474, (F)-0.134315, (F)-0.057092,
(F)-0.032883, (F)-0.055559, (F)-0.032000, (F)-0.013602, (F)-0.207412, (F)-0.119461,
(F)-0.050778, (F)-0.049415,
(F)0.209595, (F)0.181091, (F)0.358093, (F)0.500244, (F)0.535034, (F)-0.043930,
(F)-0.032794, (F)-0.128231, (F)-0.250244, (F)-0.286262, (F)-0.037956, (F)-0.075054,
(F)-0.064848, (F)-0.104849, (F)-0.090590, (F)-0.179134, (F)-0.112140, (F)-0.096890,
(F)-0.191592, (F)-0.267648,
(F)0.358948, (F)0.560059, (F)0.495544, (F)0.240112, (F)0.204773, (F)-0.128843,
(F)-0.313666, (F)-0.245564, (F)-0.057654, (F)-0.041932, (F)-0.201032, (F)-0.177875,
(F)-0.277534, (F)-0.086188, (F)-0.134477, (F)-0.118986, (F)-0.073503, (F)-0.114685,
(F)-0.101474, (F)-0.049169 };


/*
**  AcbkGainTable170:
**
**  Table Structure:
**      1st 5 elements:   G1  G2  G3  G4  G5 in Q14
**      2nd 5 elements:  -G1^2  -G2^2  -G3^2  -G4^2  -G5^2
**      Next 10 elements: These are the off-diagonal elements
**           -G1*G2  -G1*G3  -G2*G3  -G1*G4  -G2*G4
**           -G3*G4  -G1*G5  -G2*G5  -G3*G5  -G4*G5
*/

 float   AcbkGainTable170[170*20] = {
 (F)0.000000, (F)0.000000, (F)0.000000, (F)0.000000, (F)0.000000, (F)0.000000,
(F)0.000000, (F)0.000000, (F)0.000000, (F)0.000000, (F)0.000000, (F)0.000000,
(F)0.000000, (F)0.000000, (F)0.000000, (F)0.000000, (F)0.000000, (F)0.000000,
(F)0.000000, (F)0.000000,
(F)0.047363, (F)0.012939, (F)0.043640, (F)0.040894, (F)0.049377, (F)-0.002243,
(F)-0.000167, (F)-0.001904, (F)-0.001672, (F)-0.002438, (F)-0.000613, (F)-0.002067,
(F)-0.000565, (F)-0.001937, (F)-0.000529, (F)-0.001785, (F)-0.002339, (F)-0.000639,
(F)-0.002155, (F)-0.002019,
(F)0.079102, (F)0.080322, (F)-0.010254, (F)-0.019531, (F)-0.049744, (F)-0.006257,
(F)-0.006452, (F)-0.000105, (F)-0.000381, (F)-0.002474, (F)-0.006354, (F)0.000811,
(F)0.000824, (F)0.001545, (F)0.001569, (F)-0.000200, (F)0.003935, (F)0.003996,
(F)-0.000510, (F)-0.000972,
(F)-0.035950, (F)0.041504, (F)0.151245, (F)0.018799, (F)-0.036377, (F)-0.001292,
(F)-0.001723, (F)-0.022875, (F)-0.000353, (F)-0.001323, (F)0.001492, (F)0.005437,
(F)-0.006277, (F)0.000676, (F)-0.000780, (F)-0.002843, (F)-0.001308, (F)0.001510,
(F)0.005502, (F)0.000684,
(F)-0.044861, (F)-0.029724, (F)-0.000305, (F)0.179932, (F)0.028564, (F)-0.002012,
(F)-0.000884, (F)0.000000, (F)-0.032375, (F)-0.000816, (F)-0.001333, (F)-0.000014,
(F)-0.000009, (F)0.008072, (F)0.005348, (F)0.000055, (F)0.001281, (F)0.000849,
(F)0.000009, (F)-0.005140,
(F)0.063599, (F)0.105591, (F)0.065186, (F)0.020325, (F)0.038208, (F)-0.004045,
(F)-0.011149, (F)-0.004249, (F)-0.000413, (F)-0.001460, (F)-0.006715, (F)-0.004146,
(F)-0.006883, (F)-0.001293, (F)-0.002146, (F)-0.001325, (F)-0.002430, (F)-0.004034,
(F)-0.002491, (F)-0.000777,
(F)0.029663, (F)-0.046936, (F)0.248657, (F)0.172424, (F)-0.067566, (F)-0.000880,
(F)-0.002203, (F)-0.061830, (F)-0.029730, (F)-0.004565, (F)0.001392, (F)-0.007376,
(F)0.011671, (F)-0.005115, (F)0.008093, (F)-0.042875, (F)0.002004, (F)-0.003171,
(F)0.016801, (F)0.011650,
(F)0.092834, (F)-0.046814, (F)-0.007568, (F)0.263672, (F)0.062622, (F)-0.008618,
(F)-0.002192, (F)-0.000057, (F)-0.069523, (F)-0.003922, (F)0.004346, (F)0.000703,
(F)-0.000354, (F)-0.024478, (F)0.012344, (F)0.001996, (F)-0.005813, (F)0.002932,
(F)0.000474, (F)-0.016512,
(F)0.148010, (F)0.077332, (F)0.209900, (F)-0.005554, (F)-0.071167, (F)-0.021907,
(F)-0.005980, (F)-0.044058, (F)-0.000031, (F)-0.005065, (F)-0.011446, (F)-0.031067,
(F)-0.016232, (F)0.000822, (F)0.000430, (F)0.001166, (F)0.010533, (F)0.005503,
(F)0.014938, (F)-0.000395,
(F)-0.076355, (F)0.059509, (F)0.010559, (F)0.246521, (F)0.122375, (F)-0.005830,
(F)-0.003541, (F)-0.000111, (F)-0.060773, (F)-0.014976, (F)0.004544, (F)0.000806,
(F)-0.000628, (F)0.018823, (F)-0.014670, (F)-0.002603, (F)0.009344, (F)-0.007282,
(F)-0.001292, (F)-0.030168,
(F)0.111084, (F)0.038574, (F)0.080688, (F)0.125854, (F)0.062927, (F)-0.012340,
(F)-0.001488, (F)-0.006511, (F)-0.015839, (F)-0.003960, (F)-0.004285, (F)-0.008963,
(F)-0.003112, (F)-0.013980, (F)-0.004855, (F)-0.010155, (F)-0.006990, (F)-0.002427,
(F)-0.005078, (F)-0.007920,
(F)-0.027283, (F)0.299316, (F)0.014893, (F)-0.019226, (F)-0.124390, (F)-0.000744,
(F)-0.089590, (F)-0.000222, (F)-0.000370, (F)-0.015473, (F)0.008166, (F)0.000406,
(F)-0.004458, (F)-0.000525, (F)0.005755, (F)0.000286, (F)-0.003394, (F)0.037232,
(F)0.001852, (F)-0.002392,
(F)-0.012695, (F)-0.067261, (F)0.028259, (F)-0.027344, (F)0.345032, (F)-0.000161,
(F)-0.004524, (F)-0.000799, (F)-0.000748, (F)-0.119047, (F)-0.000854, (F)0.000359,
(F)0.001901, (F)-0.000347, (F)-0.001839, (F)0.000773, (F)0.004380, (F)0.023207,
(F)-0.009750, (F)0.009434,
(F)0.289246, (F)0.158691, (F)-0.113770, (F)0.052246, (F)-0.094849, (F)-0.083663,
(F)-0.025183, (F)-0.012944, (F)-0.002730, (F)-0.008996, (F)-0.045901, (F)0.032907,
(F)0.018054, (F)-0.015112, (F)-0.008291, (F)0.005944, (F)0.027435, (F)0.015052,
(F)-0.010791, (F)0.004955,
(F)0.115601, (F)0.215637, (F)0.002136, (F)-0.001587, (F)0.130920, (F)-0.013363,
(F)-0.046499, (F)-0.000005, (F)-0.000003, (F)-0.017140, (F)-0.024928, (F)-0.000247,
(F)-0.000461, (F)0.000183, (F)0.000342, (F)0.000003, (F)-0.015134, (F)-0.028231,
(F)-0.000280, (F)0.000208,
(F)-0.164734, (F)0.112366, (F)0.248535, (F)0.149109, (F)0.096558, (F)-0.027137,
(F)-0.012626, (F)-0.061770, (F)-0.022233, (F)-0.009323, (F)0.018510, (F)0.040942,
(F)-0.027927, (F)0.024563, (F)-0.016755, (F)-0.037059, (F)0.015906, (F)-0.010850,
(F)-0.023998, (F)-0.014398,
(F)-0.051514, (F)0.204956, (F)0.372681, (F)-0.064636, (F)-0.032776, (F)-0.002654,
(F)-0.042007, (F)-0.138891, (F)-0.004178, (F)-0.001074, (F)0.010558, (F)0.019198,
(F)-0.076383, (F)-0.003330, (F)0.013248, (F)0.024089, (F)-0.001688, (F)0.006718,
(F)0.012215, (F)-0.002119,
(F)0.076355, (F)0.062012, (F)0.184326, (F)0.134888, (F)0.088196, (F)-0.005830,
(F)-0.003845, (F)-0.033976, (F)-0.018195, (F)-0.007778, (F)-0.004735, (F)-0.014074,
(F)-0.011430, (F)-0.010299, (F)-0.008365, (F)-0.024863, (F)-0.006734, (F)-0.005469,
(F)-0.016257, (F)-0.011897,
(F)0.128113, (F)0.138977, (F)0.246460, (F)0.215637, (F)-0.175171, (F)-0.016413,
(F)-0.019315, (F)-0.060743, (F)-0.046499, (F)-0.030685, (F)-0.017805, (F)-0.031575,
(F)-0.034252, (F)-0.027626, (F)-0.029969, (F)-0.053146, (F)0.022442, (F)0.024345,
(F)0.043173, (F)0.037773,
(F)0.024414, (F)-0.067993, (F)0.519775, (F)0.147827, (F)-0.068176, (F)-0.000596,
(F)-0.004623, (F)-0.270166, (F)-0.021853, (F)-0.004648, (F)0.001660, (F)-0.012690,
(F)0.035341, (F)-0.003609, (F)0.010051, (F)-0.076837, (F)0.001664, (F)-0.004636,
(F)0.035436, (F)0.010078,
(F)-0.268433, (F)-0.122742, (F)0.238770, (F)-0.146912, (F)0.137817, (F)-0.072056,
(F)-0.015066, (F)-0.057011, (F)-0.021583, (F)-0.018994, (F)-0.032948, (F)0.064094,
(F)0.029307, (F)-0.039436, (F)-0.018032, (F)0.035078, (F)0.036995, (F)0.016916,
(F)-0.032907, (F)0.020247,
(F)0.107849, (F)-0.088318, (F)0.258789, (F)0.375977, (F)-0.046204, (F)-0.011631,
(F)-0.007800, (F)-0.066972, (F)-0.141358, (F)-0.002135, (F)0.009525, (F)-0.027910,
(F)0.022856, (F)-0.040549, (F)0.033205, (F)-0.097299, (F)0.004983, (F)-0.004081,
(F)0.011957, (F)0.017371,
(F)0.097290, (F)-0.089294, (F)0.063171, (F)0.423462, (F)0.117188, (F)-0.009465,
(F)-0.007973, (F)-0.003991, (F)-0.179320, (F)-0.013733, (F)0.008687, (F)-0.006146,
(F)0.005641, (F)-0.041199, (F)0.037813, (F)-0.026751, (F)-0.011401, (F)0.010464,
(F)-0.007403, (F)-0.049624,
(F)-0.034302, (F)0.287842, (F)0.249329, (F)-0.036072, (F)0.147766, (F)-0.001177,
(F)-0.082853, (F)-0.062165, (F)-0.001301, (F)-0.021835, (F)0.009873, (F)0.008552,
(F)-0.071767, (F)-0.001237, (F)0.010383, (F)0.008994, (F)0.005069, (F)-0.042533,
(F)-0.036842, (F)0.005330,
(F)0.094727, (F)0.535767, (F)-0.057068, (F)0.021606, (F)-0.086914, (F)-0.008973,
(F)-0.287046, (F)-0.003257, (F)-0.000467, (F)-0.007554, (F)-0.050751, (F)0.005406,
(F)0.030575, (F)-0.002047, (F)-0.011576, (F)0.001233, (F)0.008233, (F)0.046566,
(F)-0.004960, (F)0.001878,
(F)0.294861, (F)-0.270447, (F)0.002502, (F)-0.090271, (F)-0.181641, (F)-0.086943,
(F)-0.073141, (F)-0.000006, (F)-0.008149, (F)-0.032993, (F)0.079744, (F)-0.000738,
(F)0.000677, (F)0.026617, (F)-0.024413, (F)0.000226, (F)0.053559, (F)-0.049124,
(F)0.000455, (F)-0.016397,
(F)0.127563, (F)0.072754, (F)0.061401, (F)0.100403, (F)0.296204, (F)-0.016272,
(F)-0.005293, (F)-0.003770, (F)-0.010081, (F)-0.087737, (F)-0.009281, (F)-0.007833,
(F)-0.004467, (F)-0.012808, (F)-0.007305, (F)-0.006165, (F)-0.037785, (F)-0.021550,
(F)-0.018187, (F)-0.029740,
(F)0.145630, (F)0.348633, (F)0.087036, (F)-0.005737, (F)0.082397, (F)-0.021208,
(F)-0.121545, (F)-0.007575, (F)-0.000033, (F)-0.006789, (F)-0.050771, (F)-0.012675,
(F)-0.030344, (F)0.000836, (F)0.002000, (F)0.000499, (F)-0.012000, (F)-0.028726,
(F)-0.007172, (F)0.000473,
(F)-0.082336, (F)0.066589, (F)0.101257, (F)0.542664, (F)0.019104, (F)-0.006779,
(F)-0.004434, (F)-0.010253, (F)-0.294484, (F)-0.000365, (F)0.005483, (F)0.008337,
(F)-0.006743, (F)0.044681, (F)-0.036136, (F)-0.054949, (F)0.001573, (F)-0.001272,
(F)-0.001934, (F)-0.010367,
(F)0.609131, (F)0.055908, (F)-0.023254, (F)-0.049316, (F)0.005371, (F)-0.371040,
(F)-0.003126, (F)-0.000541, (F)-0.002432, (F)-0.000029, (F)-0.034055, (F)0.014165,
(F)0.001300, (F)0.030040, (F)0.002757, (F)-0.001147, (F)-0.003272, (F)-0.000300,
(F)0.000125, (F)0.000265,
(F)0.142700, (F)-0.062927, (F)-0.015137, (F)0.239746, (F)0.395752, (F)-0.020363,
(F)-0.003960, (F)-0.000229, (F)-0.057478, (F)-0.156620, (F)0.008980, (F)0.002160,
(F)-0.000953, (F)-0.034212, (F)0.015087, (F)0.003629, (F)-0.056474, (F)0.024904,
(F)0.005990, (F)-0.094880,
(F)0.376343, (F)-0.075684, (F)-0.020569, (F)0.224121, (F)-0.077942, (F)-0.141634,
(F)-0.005728, (F)-0.000423, (F)-0.050230, (F)-0.006075, (F)0.028483, (F)0.007741,
(F)-0.001557, (F)-0.084346, (F)0.016962, (F)0.004610, (F)0.029333, (F)-0.005899,
(F)-0.001603, (F)0.017468,
(F)0.267151, (F)-0.008057, (F)-0.157959, (F)0.103821, (F)0.296936, (F)-0.071370,
(F)-0.000065, (F)-0.024951, (F)-0.010779, (F)-0.088171, (F)0.002152, (F)0.042199,
(F)-0.001273, (F)-0.027736, (F)0.000836, (F)0.016399, (F)-0.079327, (F)0.002392,
(F)0.046904, (F)-0.030828,
(F)0.158325, (F)0.201111, (F)0.240723, (F)0.090393, (F)0.041626, (F)-0.025067,
(F)-0.040446, (F)-0.057947, (F)-0.008171, (F)-0.001733, (F)-0.031841, (F)-0.038112,
(F)-0.048412, (F)-0.014311, (F)-0.018179, (F)-0.021760, (F)-0.006590, (F)-0.008371,
(F)-0.010020, (F)-0.003763,
(F)0.253357, (F)0.038086, (F)0.049744, (F)0.273743, (F)0.136047, (F)-0.064190,
(F)-0.001451, (F)-0.002474, (F)-0.074935, (F)-0.018509, (F)-0.009649, (F)-0.012603,
(F)-0.001895, (F)-0.069355, (F)-0.010426, (F)-0.013617, (F)-0.034469, (F)-0.005181,
(F)-0.006767, (F)-0.037242,
(F)-0.218201, (F)-0.022034, (F)0.300537, (F)0.170349, (F)0.286743, (F)-0.047612,
(F)-0.000485, (F)-0.090323, (F)-0.029019, (F)-0.082222, (F)-0.004808, (F)0.065577,
(F)0.006622, (F)0.037170, (F)0.003753, (F)-0.051196, (F)0.062568, (F)0.006318,
(F)-0.086177, (F)-0.048846,
(F)-0.153687, (F)0.231384, (F)0.526306, (F)0.019226, (F)0.150452, (F)-0.023620,
(F)-0.053539, (F)-0.276998, (F)-0.000370, (F)-0.022636, (F)0.035561, (F)0.080886,
(F)-0.121779, (F)0.002955, (F)-0.004449, (F)-0.010119, (F)0.023122, (F)-0.034812,
(F)-0.079184, (F)-0.002893,
(F)-0.042175, (F)0.182434, (F)0.607727, (F)-0.025696, (F)-0.069702, (F)-0.001779,
(F)-0.033282, (F)-0.369332, (F)-0.000660, (F)-0.004858, (F)0.007694, (F)0.025631,
(F)-0.110870, (F)-0.001084, (F)0.004688, (F)0.015616, (F)-0.002940, (F)0.012716,
(F)0.042360, (F)-0.001791,
(F)-0.117065, (F)0.006348, (F)-0.194702, (F)-0.208130, (F)-0.270996, (F)-0.013704,
(F)-0.000040, (F)-0.037909, (F)-0.043318, (F)-0.073439, (F)0.000743, (F)-0.022793,
(F)0.001236, (F)-0.024365, (F)0.001321, (F)-0.040523, (F)-0.031724, (F)0.001720,
(F)-0.052764, (F)-0.056402,
(F)-0.205017, (F)-0.101807, (F)0.113159, (F)0.423523, (F)0.087280, (F)-0.042032,
(F)-0.010365, (F)-0.012805, (F)-0.179372, (F)-0.007618, (F)-0.020872, (F)0.023200,
(F)0.011520, (F)0.086829, (F)0.043117, (F)-0.047926, (F)0.017894, (F)0.008886,
(F)-0.009877, (F)-0.036965,
(F)0.002563, (F)0.592407, (F)0.193115, (F)-0.058105, (F)0.055359, (F)-0.000007,
(F)-0.350946, (F)-0.037293, (F)-0.003376, (F)-0.003065, (F)-0.001519, (F)-0.000495,
(F)-0.114403, (F)0.000149, (F)0.034422, (F)0.011221, (F)-0.000142, (F)-0.032795,
(F)-0.010691, (F)0.003217,
(F)0.098083, (F)0.047913, (F)0.174683, (F)0.264099, (F)0.201843, (F)-0.009620,
(F)-0.002296, (F)-0.030514, (F)-0.069748, (F)-0.040741, (F)-0.004699, (F)-0.017133,
(F)-0.008369, (F)-0.025904, (F)-0.012654, (F)-0.046134, (F)-0.019797, (F)-0.009671,
(F)-0.035259, (F)-0.053307,
(F)0.415100, (F)0.208496, (F)0.135925, (F)0.102661, (F)-0.196350, (F)-0.172308,
(F)-0.043471, (F)-0.018476, (F)-0.010539, (F)-0.038553, (F)-0.086547, (F)-0.056423,
(F)-0.028340, (F)-0.042615, (F)-0.021404, (F)-0.013954, (F)0.081505, (F)0.040938,
(F)0.026689, (F)0.020158,
(F)0.211121, (F)0.237915, (F)0.022217, (F)0.478577, (F)-0.161133, (F)-0.044572,
(F)-0.056604, (F)-0.000494, (F)-0.229036, (F)-0.025964, (F)-0.050229, (F)-0.004690,
(F)-0.005286, (F)-0.101037, (F)-0.113861, (F)-0.010632, (F)0.034018, (F)0.038336,
(F)0.003580, (F)0.077114,
(F)-0.360229, (F)-0.211060, (F)-0.150452, (F)-0.115112, (F)0.264526, (F)-0.129765,
(F)-0.044546, (F)-0.022636, (F)-0.013251, (F)-0.069974, (F)-0.076030, (F)-0.054197,
(F)-0.031754, (F)-0.041467, (F)-0.024296, (F)-0.017319, (F)0.095290, (F)0.055831,
(F)0.039798, (F)0.030450,
(F)-0.226440, (F)0.069153, (F)0.479065, (F)0.210144, (F)-0.013123, (F)-0.051275,
(F)-0.004782, (F)-0.229503, (F)-0.044161, (F)-0.000172, (F)0.015659, (F)0.108480,
(F)-0.033129, (F)0.047585, (F)-0.014532, (F)-0.100673, (F)-0.002971, (F)0.000907,
(F)0.006287, (F)0.002758,
(F)0.252197, (F)0.172607, (F)0.000122, (F)-0.257080, (F)-0.251221, (F)-0.063603,
(F)-0.029793, (F)0.000000, (F)-0.066090, (F)-0.063112, (F)-0.043531, (F)-0.000031,
(F)-0.000021, (F)0.064835, (F)0.044374, (F)0.000031, (F)0.063357, (F)0.043363,
(F)0.000031, (F)-0.064584,
(F)0.358582, (F)0.518555, (F)-0.109619, (F)0.083984, (F)-0.109009, (F)-0.128581,
(F)-0.268899, (F)-0.012016, (F)-0.007053, (F)-0.011883, (F)-0.185944, (F)0.039307,
(F)0.056844, (F)-0.030115, (F)-0.043550, (F)0.009206, (F)0.039089, (F)0.056527,
(F)-0.011949, (F)0.009155,
(F)0.191833, (F)0.212585, (F)0.216431, (F)-0.048401, (F)0.273987, (F)-0.036800,
(F)-0.045193, (F)-0.046842, (F)-0.002343, (F)-0.075069, (F)-0.040781, (F)-0.041519,
(F)-0.046010, (F)0.009285, (F)0.010289, (F)0.010475, (F)-0.052560, (F)-0.058246,
(F)-0.059299, (F)0.013261,
(F)0.173645, (F)0.486145, (F)0.225525, (F)-0.331543, (F)0.242798, (F)-0.030153,
(F)-0.236337, (F)-0.050861, (F)-0.109921, (F)-0.058951, (F)-0.084417, (F)-0.039161,
(F)-0.109638, (F)0.057571, (F)0.161178, (F)0.074771, (F)-0.042161, (F)-0.118035,
(F)-0.054757, (F)0.080498,
(F)0.093872, (F)0.009155, (F)0.435730, (F)0.125061, (F)0.189026, (F)-0.008812,
(F)-0.000084, (F)-0.189861, (F)-0.015640, (F)-0.035731, (F)-0.000859, (F)-0.040903,
(F)-0.003989, (F)-0.011740, (F)-0.001145, (F)-0.054493, (F)-0.017744, (F)-0.001731,
(F)-0.082364, (F)-0.023640,
(F)0.037720, (F)0.458984, (F)0.288635, (F)-0.014526, (F)-0.205872, (F)-0.001423,
(F)-0.210667, (F)-0.083310, (F)-0.000211, (F)-0.042383, (F)-0.017313, (F)-0.010887,
(F)-0.132479, (F)0.000548, (F)0.006667, (F)0.004193, (F)0.007765, (F)0.094492,
(F)0.059422, (F)-0.002991,
(F)0.180969, (F)-0.183899, (F)0.482910, (F)0.431885, (F)-0.121887, (F)-0.032750,
(F)-0.033819, (F)-0.233202, (F)-0.186524, (F)-0.014856, (F)0.033280, (F)-0.087392,
(F)0.088807, (F)-0.078158, (F)0.079423, (F)-0.208562, (F)0.022058, (F)-0.022415,
(F)0.058861, (F)0.052641,
(F)0.149109, (F)-0.056702, (F)-0.067932, (F)0.590637, (F)0.252563, (F)-0.022233,
(F)-0.003215, (F)-0.004615, (F)-0.348852, (F)-0.063788, (F)0.008455, (F)0.010129,
(F)-0.003852, (F)-0.088069, (F)0.033490, (F)0.040123, (F)-0.037659, (F)0.014321,
(F)0.017157, (F)-0.149173,
(F)0.119995, (F)0.201965, (F)0.615540, (F)-0.207458, (F)0.128479, (F)-0.014399,
(F)-0.040790, (F)-0.378889, (F)-0.043039, (F)-0.016507, (F)-0.024235, (F)-0.073862,
(F)-0.124318, (F)0.024894, (F)0.041899, (F)0.127699, (F)-0.015417, (F)-0.025948,
(F)-0.079084, (F)0.026654,
(F)-0.006836, (F)-0.083496, (F)0.541260, (F)0.294312, (F)0.125000, (F)-0.000047,
(F)-0.006972, (F)-0.292962, (F)-0.086619, (F)-0.015625, (F)-0.000571, (F)0.003700,
(F)0.045193, (F)0.002012, (F)0.024574, (F)-0.159299, (F)0.000854, (F)0.010437,
(F)-0.067657, (F)-0.036789,
(F)-0.158508, (F)0.026733, (F)-0.112244, (F)0.380188, (F)0.443481, (F)-0.025125,
(F)-0.000715, (F)-0.012599, (F)-0.144543, (F)-0.196676, (F)0.004237, (F)-0.017792,
(F)0.003001, (F)0.060263, (F)-0.010164, (F)0.042674, (F)0.070295, (F)-0.011856,
(F)0.049778, (F)-0.168606,
(F)0.210815, (F)0.033752, (F)0.557068, (F)0.301880, (F)-0.341553, (F)-0.044443,
(F)-0.001139, (F)-0.310325, (F)-0.091131, (F)-0.116658, (F)-0.007116, (F)-0.117439,
(F)-0.018802, (F)-0.063641, (F)-0.010189, (F)-0.168168, (F)0.072005, (F)0.011528,
(F)0.190268, (F)0.103108,
(F)-0.032471, (F)-0.040466, (F)0.748413, (F)0.152283, (F)-0.061279, (F)-0.001054,
(F)-0.001638, (F)-0.560122, (F)-0.023190, (F)-0.003755, (F)-0.001314, (F)0.024301,
(F)0.030286, (F)0.004945, (F)0.006162, (F)-0.113970, (F)-0.001990, (F)-0.002480,
(F)0.045862, (F)0.009332,
(F)-0.128174, (F)0.080383, (F)-0.092102, (F)0.697327, (F)0.182922, (F)-0.016429,
(F)-0.006461, (F)-0.008483, (F)-0.486264, (F)-0.033461, (F)0.010303, (F)-0.011805,
(F)0.007403, (F)0.089379, (F)-0.056053, (F)0.064225, (F)0.023446, (F)-0.014704,
(F)0.016848, (F)-0.127557,
(F)0.072815, (F)-0.164612, (F)0.687195, (F)0.327942, (F)-0.046570, (F)-0.005302,
(F)-0.027097, (F)-0.472237, (F)-0.107546, (F)-0.002169, (F)0.011986, (F)-0.050038,
(F)0.113120, (F)-0.023879, (F)0.053983, (F)-0.225360, (F)0.003391, (F)-0.007666,
(F)0.032003, (F)0.015272,
(F)0.146790, (F)-0.028748, (F)0.676208, (F)0.012390, (F)0.047729, (F)-0.021547,
(F)-0.000826, (F)-0.457258, (F)-0.000154, (F)-0.002278, (F)0.004220, (F)-0.099260,
(F)0.019439, (F)-0.001819, (F)0.000356, (F)-0.008378, (F)-0.007006, (F)0.001372,
(F)-0.032275, (F)-0.000591,
(F)-0.114197, (F)0.346985, (F)0.689087, (F)-0.162476, (F)0.082581, (F)-0.013041,
(F)-0.120398, (F)-0.474841, (F)-0.026398, (F)-0.006820, (F)0.039625, (F)0.078692,
(F)-0.239103, (F)-0.018554, (F)0.056377, (F)0.111960, (F)0.009430, (F)-0.028654,
(F)-0.056905, (F)0.013417,
(F)-0.229980, (F)0.361755, (F)-0.188782, (F)0.307678, (F)0.318115, (F)-0.052891,
(F)-0.130867, (F)-0.035639, (F)-0.094666, (F)-0.101197, (F)0.083197, (F)-0.043416,
(F)0.068293, (F)0.070760, (F)-0.111304, (F)0.058084, (F)0.073160, (F)-0.115080,
(F)0.060054, (F)-0.097877,
(F)-0.155396, (F)0.579956, (F)0.364319, (F)-0.148926, (F)0.117676, (F)-0.024148,
(F)-0.336349, (F)-0.132728, (F)-0.022179, (F)-0.013848, (F)0.090123, (F)0.056614,
(F)-0.211289, (F)-0.023142, (F)0.086370, (F)0.054256, (F)0.018286, (F)-0.068247,
(F)-0.042872, (F)0.017525,
(F)-0.302917, (F)0.217773, (F)0.280273, (F)0.336182, (F)0.210632, (F)-0.091759,
(F)-0.047425, (F)-0.078553, (F)-0.113018, (F)-0.044366, (F)0.065967, (F)0.084900,
(F)-0.061036, (F)0.101835, (F)-0.073211, (F)-0.094223, (F)0.063804, (F)-0.045870,
(F)-0.059035, (F)-0.070811,
(F)0.106506, (F)-0.157837, (F)0.243103, (F)0.665222, (F)-0.094666, (F)-0.011344,
(F)-0.024912, (F)-0.059099, (F)-0.442521, (F)-0.008962, (F)0.016811, (F)-0.025892,
(F)0.038371, (F)-0.070850, (F)0.104997, (F)-0.161718, (F)0.010082, (F)-0.014942,
(F)0.023013, (F)0.062974,
(F)0.052917, (F)-0.027832, (F)-0.044373, (F)0.205627, (F)0.721558, (F)-0.002800,
(F)-0.000775, (F)-0.001969, (F)-0.042283, (F)-0.520645, (F)0.001473, (F)0.002348,
(F)-0.001235, (F)-0.010881, (F)0.005723, (F)0.009124, (F)-0.038183, (F)0.020082,
(F)0.032017, (F)-0.148372,
(F)0.459900, (F)0.147827, (F)0.117554, (F)0.085754, (F)0.097595, (F)-0.211508,
(F)-0.021853, (F)-0.013819, (F)-0.007354, (F)-0.009525, (F)-0.067986, (F)-0.054063,
(F)-0.017378, (F)-0.039438, (F)-0.012677, (F)-0.010081, (F)-0.044884, (F)-0.014427,
(F)-0.011473, (F)-0.008369,
(F)0.063538, (F)-0.044861, (F)-0.008667, (F)0.806213, (F)0.092468, (F)-0.004037,
(F)-0.002012, (F)-0.000075, (F)-0.649980, (F)-0.008550, (F)0.002850, (F)0.000551,
(F)-0.000389, (F)-0.051225, (F)0.036167, (F)0.006987, (F)-0.005875, (F)0.004148,
(F)0.000801, (F)-0.074549,
(F)0.485229, (F)0.411682, (F)-0.088135, (F)-0.061523, (F)0.166077, (F)-0.235448,
(F)-0.169482, (F)-0.007768, (F)-0.003785, (F)-0.027581, (F)-0.199760, (F)0.042766,
(F)0.036284, (F)0.029853, (F)0.025328, (F)-0.005422, (F)-0.080585, (F)-0.068371,
(F)0.014637, (F)0.010218,
(F)-0.290161, (F)-0.084167, (F)0.276001, (F)-0.035278, (F)-0.349915, (F)-0.084193,
(F)-0.007084, (F)-0.076177, (F)-0.001245, (F)-0.122440, (F)-0.024422, (F)0.080085,
(F)0.023230, (F)-0.010236, (F)-0.002969, (F)0.009737, (F)-0.101532, (F)-0.029451,
(F)0.096577, (F)-0.012344,
(F)0.196533, (F)0.364868, (F)0.361511, (F)0.148315, (F)-0.164124, (F)-0.038625,
(F)-0.133129, (F)-0.130690, (F)-0.021997, (F)-0.026937, (F)-0.071709, (F)-0.071049,
(F)-0.131904, (F)-0.029149, (F)-0.054116, (F)-0.053618, (F)0.032256, (F)0.059883,
(F)0.059333, (F)0.024342,
(F)0.023010, (F)0.080078, (F)0.853149, (F)-0.089722, (F)0.041321, (F)-0.000529,
(F)-0.006413, (F)-0.727864, (F)-0.008050, (F)-0.001707, (F)-0.001843, (F)-0.019631,
(F)-0.068319, (F)0.002065, (F)0.007185, (F)0.076546, (F)-0.000951, (F)-0.003309,
(F)-0.035253, (F)0.003707,
(F)-0.209656, (F)0.413208, (F)0.019165, (F)-0.054016, (F)0.347046, (F)-0.043956,
(F)-0.170741, (F)-0.000367, (F)-0.002918, (F)-0.120441, (F)0.086631, (F)0.004018,
(F)-0.007919, (F)-0.011325, (F)0.022320, (F)0.001035, (F)0.072760, (F)-0.143402,
(F)-0.006651, (F)0.018746,
(F)0.193542, (F)0.535522, (F)-0.137939, (F)0.163513, (F)0.187317, (F)-0.037459,
(F)-0.286784, (F)-0.019027, (F)-0.026737, (F)-0.035088, (F)-0.103646, (F)0.026697,
(F)0.073870, (F)-0.031647, (F)-0.087565, (F)0.022555, (F)-0.036254, (F)-0.100312,
(F)0.025838, (F)-0.030629,
(F)0.339172, (F)0.092102, (F)0.330017, (F)-0.007629, (F)-0.450806, (F)-0.115038,
(F)-0.008483, (F)-0.108911, (F)-0.000058, (F)-0.203226, (F)-0.031238, (F)-0.111933,
(F)-0.030395, (F)0.002588, (F)0.000703, (F)0.002518, (F)0.152901, (F)0.041520,
(F)0.148774, (F)-0.003439,
(F)-0.173218, (F)0.158386, (F)0.807373, (F)0.016541, (F)0.109436, (F)-0.030004,
(F)-0.025086, (F)-0.651851, (F)-0.000274, (F)-0.011976, (F)0.027435, (F)0.139851,
(F)-0.127877, (F)0.002865, (F)-0.002620, (F)-0.013354, (F)0.018956, (F)-0.017333,
(F)-0.088356, (F)-0.001810,
(F)0.040527, (F)-0.016968, (F)0.913452, (F)0.058044, (F)-0.043396, (F)-0.001642,
(F)-0.000288, (F)-0.834395, (F)-0.003369, (F)-0.001883, (F)0.000688, (F)-0.037020,
(F)0.015499, (F)-0.002352, (F)0.000985, (F)-0.053021, (F)0.001759, (F)-0.000736,
(F)0.039640, (F)0.002519,
(F)0.049316, (F)0.108032, (F)0.528442, (F)0.357849, (F)-0.090698, (F)-0.002432,
(F)-0.011671, (F)-0.279251, (F)-0.128056, (F)-0.008226, (F)-0.005328, (F)-0.026061,
(F)-0.057089, (F)-0.017648, (F)-0.038659, (F)-0.189103, (F)0.004473, (F)0.009798,
(F)0.047929, (F)0.032456,
(F)0.186951, (F)0.093933, (F)0.122070, (F)-0.033081, (F)0.584473, (F)-0.034951,
(F)-0.008823, (F)-0.014901, (F)-0.001094, (F)-0.341608, (F)-0.017561, (F)-0.022821,
(F)-0.011466, (F)0.006185, (F)0.003107, (F)0.004038, (F)-0.109268, (F)-0.054901,
(F)-0.071347, (F)0.019335,
(F)0.031372, (F)0.859558, (F)-0.019714, (F)0.054688, (F)-0.054382, (F)-0.000984,
(F)-0.738840, (F)-0.000389, (F)-0.002991, (F)-0.002957, (F)-0.026966, (F)0.000618,
(F)0.016946, (F)-0.001716, (F)-0.047007, (F)0.001078, (F)0.001706, (F)0.046745,
(F)-0.001072, (F)0.002974,
(F)0.054443, (F)0.009644, (F)0.319641, (F)0.674866, (F)-0.097839, (F)-0.002964,
(F)-0.000093, (F)-0.102170, (F)-0.455444, (F)-0.009573, (F)-0.000525, (F)-0.017402,
(F)-0.003082, (F)-0.036742, (F)-0.006508, (F)-0.215715, (F)0.005327, (F)0.000944,
(F)0.031273, (F)0.066028,
(F)-0.098389, (F)0.156494, (F)-0.262207, (F)0.764526, (F)0.348511, (F)-0.009680,
(F)-0.024490, (F)-0.068753, (F)-0.584501, (F)-0.121460, (F)0.015397, (F)-0.025798,
(F)0.041034, (F)0.075221, (F)-0.119644, (F)0.200464, (F)0.034290, (F)-0.054540,
(F)0.091382, (F)-0.266446,
(F)0.298401, (F)-0.419800, (F)0.037354, (F)0.372864, (F)0.290100, (F)-0.089043,
(F)-0.176232, (F)-0.001395, (F)-0.139027, (F)-0.084158, (F)0.125269, (F)-0.011146,
(F)0.015681, (F)-0.111263, (F)0.156528, (F)-0.013928, (F)-0.086566, (F)0.121784,
(F)-0.010836, (F)-0.108168,
(F)0.186340, (F)-0.030884, (F)0.146667, (F)0.587463, (F)0.080688, (F)-0.034723,
(F)-0.000954, (F)-0.021511, (F)-0.345113, (F)-0.006511, (F)0.005755, (F)-0.027330,
(F)0.004530, (F)-0.109468, (F)0.018143, (F)-0.086162, (F)-0.015036, (F)0.002492,
(F)-0.011834, (F)-0.047402,
(F)-0.046021, (F)0.787598, (F)0.273438, (F)-0.128967, (F)0.089783, (F)-0.002118,
(F)-0.620310, (F)-0.074768, (F)-0.016633, (F)-0.008061, (F)0.036246, (F)0.012584,
(F)-0.215359, (F)-0.005935, (F)0.101574, (F)0.035264, (F)0.004132, (F)-0.070713,
(F)-0.024550, (F)0.011579,
(F)0.259705, (F)0.090088, (F)0.308533, (F)0.146057, (F)0.177734, (F)-0.067446,
(F)-0.008116, (F)-0.095192, (F)-0.021333, (F)-0.031590, (F)-0.023396, (F)-0.080127,
(F)-0.027795, (F)-0.037932, (F)-0.013158, (F)-0.045063, (F)-0.046158, (F)-0.016012,
(F)-0.054837, (F)-0.025959,
(F)-0.083679, (F)0.032654, (F)0.086487, (F)0.891357, (F)-0.060852, (F)-0.007002,
(F)-0.001066, (F)-0.007480, (F)-0.794518, (F)-0.003703, (F)0.002732, (F)0.007237,
(F)-0.002824, (F)0.074588, (F)-0.029106, (F)-0.077091, (F)-0.005092, (F)0.001987,
(F)0.005263, (F)0.054241,
(F)0.327637, (F)-0.106445, (F)0.249207, (F)-0.075439, (F)0.229065, (F)-0.107346,
(F)-0.011331, (F)-0.062104, (F)-0.005691, (F)-0.052471, (F)0.034875, (F)-0.081649,
(F)0.026527, (F)0.024717, (F)-0.008030, (F)0.018800, (F)-0.075050, (F)0.024383,
(F)-0.057084, (F)0.017281,
(F)0.096924, (F)-0.189026, (F)0.879822, (F)0.225769, (F)-0.071472, (F)-0.009394,
(F)-0.035731, (F)-0.774086, (F)-0.050972, (F)-0.005108, (F)0.018321, (F)-0.085276,
(F)0.166309, (F)-0.021882, (F)0.042676, (F)-0.198637, (F)0.006927, (F)-0.013510,
(F)0.062883, (F)0.016136,
(F)0.012939, (F)0.487610, (F)0.578064, (F)-0.204102, (F)0.122620, (F)-0.000167,
(F)-0.237763, (F)-0.334158, (F)-0.041657, (F)-0.015036, (F)-0.006309, (F)-0.007480,
(F)-0.281870, (F)0.002641, (F)0.099522, (F)0.117984, (F)-0.001587, (F)-0.059791,
(F)-0.070882, (F)0.025027,
(F)0.052246, (F)0.140015, (F)-0.038269, (F)0.422974, (F)0.422913, (F)-0.002730,
(F)-0.019604, (F)-0.001465, (F)-0.178907, (F)-0.178855, (F)-0.007315, (F)0.001999,
(F)0.005358, (F)-0.022099, (F)-0.059223, (F)0.016187, (F)-0.022096, (F)-0.059214,
(F)0.016184, (F)-0.178881,
(F)0.143860, (F)-0.255554, (F)0.437134, (F)0.468933, (F)0.205750, (F)-0.020696,
(F)-0.065308, (F)-0.191086, (F)-0.219898, (F)-0.042333, (F)0.036764, (F)-0.062886,
(F)0.111711, (F)-0.067461, (F)0.119838, (F)-0.204987, (F)-0.029599, (F)0.052580,
(F)-0.089940, (F)-0.096483,
(F)0.021362, (F)0.279846, (F)0.857727, (F)-0.233093, (F)0.074341, (F)-0.000456,
(F)-0.078314, (F)-0.735696, (F)-0.054332, (F)-0.005527, (F)-0.005978, (F)-0.018323,
(F)-0.240032, (F)0.004979, (F)0.065230, (F)0.199930, (F)-0.001588, (F)-0.020804,
(F)-0.063764, (F)0.017328,
(F)-0.198242, (F)0.215515, (F)0.028992, (F)0.130432, (F)0.714783, (F)-0.039300,
(F)-0.046447, (F)-0.000841, (F)-0.017013, (F)-0.510914, (F)0.042724, (F)0.005747,
(F)-0.006248, (F)0.025857, (F)-0.028110, (F)-0.003781, (F)0.141700, (F)-0.154046,
(F)-0.020723, (F)-0.093231,
(F)-0.184143, (F)0.235107, (F)0.105286, (F)0.515137, (F)0.320862, (F)-0.033909,
(F)-0.055275, (F)-0.011085, (F)-0.265366, (F)-0.102952, (F)0.043293, (F)0.019388,
(F)-0.024753, (F)0.094859, (F)-0.121112, (F)-0.054237, (F)0.059084, (F)-0.075437,
(F)-0.033782, (F)-0.165288,
(F)-0.055481, (F)0.195068, (F)0.946777, (F)-0.154297, (F)0.065063, (F)-0.003078,
(F)-0.038052, (F)-0.896387, (F)-0.023808, (F)-0.004233, (F)0.010823, (F)0.052528,
(F)-0.184686, (F)-0.008561, (F)0.030098, (F)0.146085, (F)0.003610, (F)-0.012692,
(F)-0.061601, (F)0.010039,
(F)0.058533, (F)-0.205688, (F)0.586975, (F)0.582581, (F)-0.107483, (F)-0.003426,
(F)-0.042308, (F)-0.344540, (F)-0.339400, (F)-0.011553, (F)0.012040, (F)-0.034357,
(F)0.120734, (F)-0.034100, (F)0.119830, (F)-0.341960, (F)0.006291, (F)-0.022108,
(F)0.063090, (F)0.062617,
(F)0.462341, (F)0.719971, (F)-0.295715, (F)0.198486, (F)-0.103943, (F)-0.213759,
(F)-0.518358, (F)-0.087448, (F)-0.039397, (F)-0.010804, (F)-0.332872, (F)0.136721,
(F)0.212906, (F)-0.091768, (F)-0.142904, (F)0.058695, (F)0.048057, (F)0.074836,
(F)-0.030738, (F)0.020631,
(F)0.391174, (F)0.105103, (F)0.107666, (F)-0.255798, (F)0.367126, (F)-0.153017,
(F)-0.011047, (F)-0.011592, (F)-0.065433, (F)-0.134782, (F)-0.041113, (F)-0.042116,
(F)-0.011316, (F)0.100062, (F)0.026885, (F)0.027541, (F)-0.143610, (F)-0.038586,
(F)-0.039527, (F)0.093910,
(F)-0.147705, (F)0.742249, (F)0.307495, (F)0.078491, (F)-0.128052, (F)-0.021817,
(F)-0.550933, (F)-0.094553, (F)-0.006161, (F)-0.016397, (F)0.109634, (F)0.045419,
(F)-0.228238, (F)0.011594, (F)-0.058260, (F)-0.024136, (F)-0.018914, (F)0.095046,
(F)0.039375, (F)0.010051,
(F)-0.136230, (F)-0.081848, (F)0.442261, (F)0.578003, (F)-0.120667, (F)-0.018559,
(F)-0.006699, (F)-0.195595, (F)-0.334087, (F)-0.014560, (F)-0.011150, (F)0.060249,
(F)0.036198, (F)0.078742, (F)0.047308, (F)-0.255628, (F)-0.016438, (F)-0.009876,
(F)0.053366, (F)0.069746,
(F)0.062866, (F)0.429321, (F)0.258240, (F)0.094666, (F)0.187805, (F)-0.003952,
(F)-0.184317, (F)-0.066688, (F)-0.008962, (F)-0.035271, (F)-0.026990, (F)-0.016235,
(F)-0.110868, (F)-0.005951, (F)-0.040642, (F)-0.024446, (F)-0.011807, (F)-0.080629,
(F)-0.048499, (F)-0.017779,
(F)0.312561, (F)0.722351, (F)-0.029114, (F)-0.106750, (F)0.140259, (F)-0.097694,
(F)-0.521791, (F)-0.000848, (F)-0.011396, (F)-0.019673, (F)-0.225779, (F)0.009100,
(F)0.021030, (F)0.033366, (F)0.077111, (F)-0.003108, (F)-0.043839, (F)-0.101316,
(F)0.004083, (F)0.014973,
(F)-0.203125, (F)0.233582, (F)0.361389, (F)0.608887, (F)-0.063782, (F)-0.041260,
(F)-0.054560, (F)-0.130602, (F)-0.370743, (F)-0.004068, (F)0.047446, (F)0.073407,
(F)-0.084414, (F)0.123680, (F)-0.142225, (F)-0.220045, (F)-0.012956, (F)0.014898,
(F)0.023050, (F)0.038836,
(F)0.232727, (F)0.348999, (F)-0.284790, (F)-0.208252, (F)0.346313, (F)-0.054162,
(F)-0.121800, (F)-0.081105, (F)-0.043369, (F)-0.119933, (F)-0.081222, (F)0.066278,
(F)0.099391, (F)0.048466, (F)0.072680, (F)-0.059308, (F)-0.080597, (F)-0.120863,
(F)0.098627, (F)0.072120,
(F)0.082275, (F)-0.224121, (F)0.802856, (F)0.423462, (F)-0.103149, (F)-0.006769,
(F)-0.050230, (F)-0.644578, (F)-0.179320, (F)-0.010640, (F)0.018440, (F)-0.066055,
(F)0.179937, (F)-0.034840, (F)0.094907, (F)-0.339979, (F)0.008487, (F)-0.023118,
(F)0.082814, (F)0.043680,
(F)0.131287, (F)-0.218872, (F)0.424133, (F)0.740417, (F)-0.074707, (F)-0.017236,
(F)-0.047905, (F)-0.179889, (F)-0.548218, (F)-0.005581, (F)0.028735, (F)-0.055683,
(F)0.092831, (F)-0.097207, (F)0.162057, (F)-0.314036, (F)0.009808, (F)-0.016351,
(F)0.031686, (F)0.055314,
(F)-0.176331, (F)0.588806, (F)0.627197, (F)-0.166504, (F)0.060730, (F)-0.031092,
(F)-0.346693, (F)-0.393376, (F)-0.027724, (F)-0.003688, (F)0.103825, (F)0.110594,
(F)-0.369298, (F)-0.029360, (F)0.098039, (F)0.104431, (F)0.010709, (F)-0.035758,
(F)-0.038090, (F)0.010112,
(F)0.377014, (F)0.133301, (F)0.033875, (F)0.121155, (F)0.402161, (F)-0.142140,
(F)-0.017769, (F)-0.001147, (F)-0.014678, (F)-0.161733, (F)-0.050256, (F)-0.012771,
(F)-0.004515, (F)-0.045677, (F)-0.016150, (F)-0.004104, (F)-0.151620, (F)-0.053608,
(F)-0.013623, (F)-0.048724,
(F)-0.030029, (F)0.023865, (F)1.047729, (F)-0.041565, (F)0.014648, (F)-0.000902,
(F)-0.000570, (F)-1.097737, (F)-0.001728, (F)-0.000215, (F)0.000717, (F)0.031463,
(F)-0.025004, (F)-0.001248, (F)0.000992, (F)0.043549, (F)0.000440, (F)-0.000350,
(F)-0.015348, (F)0.000609,
(F)0.770752, (F)0.332520, (F)-0.160522, (F)0.183777, (F)-0.164490, (F)-0.594059,
(F)-0.110569, (F)-0.025767, (F)-0.033774, (F)-0.027057, (F)-0.256290, (F)0.123723,
(F)0.053377, (F)-0.141646, (F)-0.061109, (F)0.029500, (F)0.126781, (F)0.054696,
(F)-0.026404, (F)0.030229,
(F)-0.221436, (F)-0.032593, (F)0.210388, (F)0.427368, (F)0.412048, (F)-0.049034,
(F)-0.001062, (F)-0.044263, (F)-0.182644, (F)-0.169784, (F)-0.007217, (F)0.046587,
(F)0.006857, (F)0.094635, (F)0.013929, (F)-0.089913, (F)0.091242, (F)0.013430,
(F)-0.086690, (F)-0.176096,
(F)-0.319763, (F)0.360168, (F)0.494812, (F)0.222778, (F)0.295776, (F)-0.102248,
(F)-0.129721, (F)-0.244839, (F)-0.049630, (F)-0.087484, (F)0.115169, (F)0.158223,
(F)-0.178216, (F)0.071236, (F)-0.080238, (F)-0.110233, (F)0.094578, (F)-0.106529,
(F)-0.146354, (F)-0.065893,
(F)0.375793, (F)0.407593, (F)0.250183, (F)-0.065552, (F)0.143311, (F)-0.141221,
(F)-0.166132, (F)-0.062592, (F)-0.004297, (F)-0.020538, (F)-0.153171, (F)-0.094017,
(F)-0.101973, (F)0.024634, (F)0.026718, (F)0.016400, (F)-0.053855, (F)-0.058412,
(F)-0.035854, (F)0.009394,
(F)0.065857, (F)0.982605, (F)0.014771, (F)-0.053772, (F)0.103149, (F)-0.004337,
(F)-0.965513, (F)-0.000218, (F)-0.002891, (F)-0.010640, (F)-0.064711, (F)-0.000973,
(F)-0.014514, (F)0.003541, (F)0.052837, (F)0.000794, (F)-0.006793, (F)-0.101355,
(F)-0.001524, (F)0.005547,
(F)-0.016968, (F)0.013855, (F)-0.063416, (F)0.099854, (F)1.034241, (F)-0.000288,
(F)-0.000192, (F)-0.004022, (F)-0.009971, (F)-1.069654, (F)0.000235, (F)-0.001076,
(F)0.000879, (F)0.001694, (F)-0.001383, (F)0.006332, (F)0.017549, (F)-0.014329,
(F)0.065587, (F)-0.103273,
(F)0.963013, (F)-0.088745, (F)0.035034, (F)-0.036804, (F)-0.006531, (F)-0.927393,
(F)-0.007876, (F)-0.001227, (F)-0.001355, (F)-0.000043, (F)0.085463, (F)-0.033738,
(F)0.003109, (F)0.035443, (F)-0.003266, (F)0.001289, (F)0.006289, (F)-0.000580,
(F)0.000229, (F)-0.000240,
(F)0.146851, (F)-0.051025, (F)0.807129, (F)0.487854, (F)-0.260376, (F)-0.021565,
(F)-0.002604, (F)-0.651457, (F)-0.238002, (F)-0.067796, (F)0.007493, (F)-0.118527,
(F)0.041184, (F)-0.071642, (F)0.024893, (F)-0.393761, (F)0.038236, (F)-0.013286,
(F)0.210157, (F)0.127025,
(F)0.194336, (F)0.876953, (F)-0.203613, (F)0.137634, (F)-0.109924, (F)-0.037766,
(F)-0.769047, (F)-0.041458, (F)-0.018943, (F)-0.012083, (F)-0.170424, (F)0.039569,
(F)0.178559, (F)-0.026747, (F)-0.120699, (F)0.028024, (F)0.021362, (F)0.096398,
(F)-0.022382, (F)0.015129,
(F)-0.103638, (F)1.042236, (F)0.152832, (F)-0.032898, (F)-0.039429, (F)-0.010741,
(F)-1.086257, (F)-0.023358, (F)-0.001082, (F)-0.001555, (F)0.108015, (F)0.015839,
(F)-0.159287, (F)-0.003409, (F)0.034287, (F)0.005028, (F)-0.004086, (F)0.041094,
(F)0.006026, (F)-0.001297,
(F)0.144958, (F)-0.048645, (F)-0.164551, (F)0.883972, (F)0.328552, (F)-0.021013,
(F)-0.002366, (F)-0.027077, (F)-0.781407, (F)-0.107947, (F)0.007052, (F)0.023853,
(F)-0.008005, (F)-0.128139, (F)0.043001, (F)0.145458, (F)-0.047626, (F)0.015982,
(F)0.054064, (F)-0.290431,
(F)-0.164246, (F)0.155884, (F)-0.275879, (F)0.584290, (F)0.650330, (F)-0.026977,
(F)-0.024300, (F)-0.076109, (F)-0.341394, (F)-0.422929, (F)0.025603, (F)-0.045312,
(F)0.043005, (F)0.095967, (F)-0.091081, (F)0.161193, (F)0.106814, (F)-0.101376,
(F)0.179412, (F)-0.379981,
(F)-0.264404, (F)-0.268494, (F)-0.101135, (F)0.297852, (F)0.450134, (F)-0.069910,
(F)-0.072089, (F)-0.010228, (F)-0.088716, (F)-0.202621, (F)-0.070991, (F)-0.026741,
(F)-0.027154, (F)0.078753, (F)0.079971, (F)0.030123, (F)0.119017, (F)0.120858,
(F)0.045524, (F)-0.134073,
(F)-0.213501, (F)0.451965, (F)0.607605, (F)0.164368, (F)-0.181335, (F)-0.045583,
(F)-0.204273, (F)-0.369184, (F)-0.027017, (F)-0.032883, (F)0.096495, (F)0.129724,
(F)-0.274616, (F)0.035093, (F)-0.074288, (F)-0.099871, (F)-0.038715, (F)0.081957,
(F)0.110180, (F)0.029806,
(F)0.409973, (F)-0.231445, (F)0.472351, (F)0.170776, (F)0.212952, (F)-0.168078,
(F)-0.053567, (F)-0.223116, (F)-0.029165, (F)-0.045348, (F)0.094886, (F)-0.193651,
(F)0.109323, (F)-0.070014, (F)0.039525, (F)-0.080666, (F)-0.087304, (F)0.049287,
(F)-0.100588, (F)-0.036367,
(F)0.321228, (F)0.596313, (F)0.211365, (F)0.065247, (F)-0.242371, (F)-0.103187,
(F)-0.355590, (F)-0.044675, (F)-0.004257, (F)-0.058744, (F)-0.191553, (F)-0.067896,
(F)-0.126040, (F)-0.020959, (F)-0.038907, (F)-0.013791, (F)0.077856, (F)0.144529,
(F)0.051229, (F)0.015814,
(F)0.075867, (F)-0.160767, (F)1.023682, (F)0.114197, (F)0.020264, (F)-0.005756,
(F)-0.025846, (F)-1.047924, (F)-0.013041, (F)-0.000411, (F)0.012197, (F)-0.077663,
(F)0.164574, (F)-0.008664, (F)0.018359, (F)-0.116901, (F)-0.001537, (F)0.003258,
(F)-0.020744, (F)-0.002314,
(F)0.164246, (F)0.173096, (F)0.189514, (F)0.348572, (F)0.294006, (F)-0.026977,
(F)-0.029962, (F)-0.035916, (F)-0.121502, (F)-0.086440, (F)-0.028430, (F)-0.031127,
(F)-0.032804, (F)-0.057251, (F)-0.060336, (F)-0.066059, (F)-0.048289, (F)-0.050891,
(F)-0.055718, (F)-0.102482,
(F)0.266479, (F)0.179688, (F)0.440063, (F)0.221375, (F)0.070862, (F)-0.071011,
(F)-0.032288, (F)-0.193656, (F)-0.049007, (F)-0.005021, (F)-0.047883, (F)-0.117268,
(F)-0.079074, (F)-0.058992, (F)-0.039778, (F)-0.097419, (F)-0.018883, (F)-0.012733,
(F)-0.031184, (F)-0.015687,
(F)0.847656, (F)0.241150, (F)-0.040955, (F)-0.140686, (F)0.204712, (F)-0.718521,
(F)-0.058153, (F)-0.001677, (F)-0.019793, (F)-0.041907, (F)-0.204412, (F)0.034715,
(F)0.009876, (F)0.119253, (F)0.033926, (F)-0.005762, (F)-0.173525, (F)-0.049366,
(F)0.008384, (F)0.028800,
(F)0.430481, (F)0.356873, (F)0.178772, (F)0.511353, (F)-0.292603, (F)-0.185314,
(F)-0.127358, (F)-0.031959, (F)-0.261481, (F)-0.085616, (F)-0.153627, (F)-0.076958,
(F)-0.063799, (F)-0.220128, (F)-0.182488, (F)-0.091416, (F)0.125960, (F)0.104422,
(F)0.052309, (F)0.149623,
(F)-0.133728, (F)0.783569, (F)0.560425, (F)-0.238953, (F)0.098694, (F)-0.017883,
(F)-0.613981, (F)-0.314076, (F)-0.057098, (F)-0.009740, (F)0.104785, (F)0.074945,
(F)-0.439132, (F)-0.031955, (F)0.187236, (F)0.133915, (F)0.013198, (F)-0.077333,
(F)-0.055310, (F)0.023583,
(F)-0.297913, (F)0.800415, (F)0.351990, (F)-0.026550, (F)0.253601, (F)-0.088752,
(F)-0.640664, (F)-0.123897, (F)-0.000705, (F)-0.064314, (F)0.238454, (F)0.104862,
(F)-0.281738, (F)-0.007910, (F)0.021251, (F)0.009345, (F)0.075551, (F)-0.202986,
(F)-0.089265, (F)0.006733,
(F)0.478699, (F)-0.076294, (F)0.012817, (F)0.433716, (F)-0.317566, (F)-0.229152,
(F)-0.005821, (F)-0.000164, (F)-0.188109, (F)-0.100848, (F)0.036522, (F)-0.006136,
(F)0.000978, (F)-0.207619, (F)0.033090, (F)-0.005559, (F)0.152018, (F)-0.024228,
(F)0.004070, (F)0.137733,
(F)-0.150330, (F)0.498535, (F)0.888123, (F)-0.238525, (F)0.111572, (F)-0.022599,
(F)-0.248537, (F)-0.788762, (F)-0.056894, (F)-0.012448, (F)0.074945, (F)0.133511,
(F)-0.442760, (F)-0.035857, (F)0.118913, (F)0.211840, (F)0.016773, (F)-0.055623,
(F)-0.099090, (F)0.026613,
(F)-0.096375, (F)0.021179, (F)-0.016602, (F)-0.166931, (F)0.978455, (F)-0.009288,
(F)-0.000449, (F)-0.000276, (F)-0.027866, (F)-0.957373, (F)0.002041, (F)-0.001600,
(F)0.000352, (F)-0.016088, (F)0.003535, (F)-0.002771, (F)0.094298, (F)-0.020723,
(F)0.016244, (F)0.163335,
(F)-0.386169, (F)0.081055, (F)0.310852, (F)-0.309998, (F)0.464905, (F)-0.149127,
(F)-0.006570, (F)-0.096629, (F)-0.096098, (F)-0.216136, (F)0.031301, (F)0.120042,
(F)-0.025196, (F)-0.119712, (F)0.025127, (F)0.096363, (F)0.179532, (F)-0.037683,
(F)-0.144517, (F)0.144119,
(F)0.200562, (F)-0.275208, (F)0.690063, (F)0.672913, (F)-0.160095, (F)-0.040225,
(F)-0.075739, (F)-0.476188, (F)-0.452811, (F)-0.025630, (F)0.055196, (F)-0.138400,
(F)0.189911, (F)-0.134960, (F)0.185191, (F)-0.464352, (F)0.032109, (F)-0.044059,
(F)0.110476, (F)0.107730,
(F)0.339783, (F)1.089661, (F)-0.229126, (F)0.071167, (F)-0.031677, (F)-0.115452,
(F)-1.187360, (F)-0.052499, (F)-0.005065, (F)-0.001003, (F)-0.370248, (F)0.077853,
(F)0.249670, (F)-0.024181, (F)-0.077548, (F)0.016306, (F)0.010763, (F)0.034517,
(F)-0.007258, (F)0.002254,
(F)-0.130371, (F)-0.025879, (F)0.933350, (F)0.311768, (F)-0.100586, (F)-0.016997,
(F)-0.000670, (F)-0.871141, (F)-0.097199, (F)-0.010118, (F)-0.003374, (F)0.121682,
(F)0.024154, (F)0.040645, (F)0.008068, (F)-0.290988, (F)-0.013113, (F)-0.002603,
(F)0.093882, (F)0.031359,
(F)0.138367, (F)-0.201233, (F)0.155579, (F)1.010925, (F)-0.048279, (F)-0.019145,
(F)-0.040495, (F)-0.024205, (F)-1.021970, (F)-0.002331, (F)0.027844, (F)-0.021527,
(F)0.031308, (F)-0.139878, (F)0.203431, (F)-0.157278, (F)0.006680, (F)-0.009715,
(F)0.007511, (F)0.048806,
(F)0.223083, (F)0.115906, (F)-0.205322, (F)0.383240, (F)0.763550, (F)-0.049766,
(F)-0.013434, (F)-0.042157, (F)-0.146873, (F)-0.583008, (F)-0.025857, (F)0.045804,
(F)0.023798, (F)-0.085494, (F)-0.044420, (F)0.078688, (F)-0.170335, (F)-0.088500,
(F)0.156774, (F)-0.292623,
(F)0.491455, (F)0.139465, (F)-0.377991, (F)0.313599, (F)0.366394, (F)-0.241528,
(F)-0.019451, (F)-0.142877, (F)-0.098344, (F)-0.134245, (F)-0.068541, (F)0.185765,
(F)0.052717, (F)-0.154120, (F)-0.043736, (F)0.118537, (F)-0.180066, (F)-0.051099,
(F)0.138494, (F)-0.114901,
(F)-0.023560, (F)-0.139832, (F)0.468689, (F)0.939148, (F)-0.166199, (F)-0.000555,
(F)-0.019553, (F)-0.219669, (F)-0.881999, (F)-0.027622, (F)-0.003294, (F)0.011042,
(F)0.065537, (F)0.022126, (F)0.131323, (F)-0.440168, (F)-0.003916, (F)-0.023240,
(F)0.077896, (F)0.156085,
(F)0.169495, (F)-0.071594, (F)0.243164, (F)0.798279, (F)0.153076, (F)-0.028728,
(F)-0.005126, (F)-0.059129, (F)-0.637249, (F)-0.023432, (F)0.012135, (F)-0.041215,
(F)0.017409, (F)-0.135304, (F)0.057152, (F)-0.194113, (F)-0.025946, (F)0.010959,
(F)-0.037223, (F)-0.122197,
(F)-0.114685, (F)0.108093, (F)-0.163818, (F)1.019592, (F)0.111877, (F)-0.013153,
(F)-0.011684, (F)-0.026836, (F)-1.039568, (F)-0.012517, (F)0.012397, (F)-0.018788,
(F)0.017708, (F)0.116932, (F)-0.110211, (F)0.167028, (F)0.012831, (F)-0.012093,
(F)0.018328, (F)-0.114069,
(F)0.064209, (F)0.274353, (F)0.947205, (F)0.089539, (F)-0.246094, (F)-0.004123,
(F)-0.075270, (F)-0.897197, (F)-0.008017, (F)-0.060562, (F)-0.017616, (F)-0.060819,
(F)-0.259868, (F)-0.005749, (F)-0.024565, (F)-0.084811, (F)0.015801, (F)0.067517,
(F)0.233101, (F)0.022035,
(F)0.183716, (F)0.155273, (F)0.425354, (F)0.461365, (F)0.121826, (F)-0.033752,
(F)-0.024110, (F)-0.180926, (F)-0.212857, (F)-0.014842, (F)-0.028526, (F)-0.078144,
(F)-0.066046, (F)-0.084760, (F)-0.071638, (F)-0.196243, (F)-0.022381, (F)-0.018916,
(F)-0.051819, (F)-0.056206,
(F)-0.317932, (F)-0.113953, (F)0.531799, (F)0.631775, (F)0.094543, (F)-0.101081,
(F)-0.012985, (F)-0.282811, (F)-0.399140, (F)-0.008938, (F)-0.036229, (F)0.169076,
(F)0.060600, (F)0.200862, (F)0.071992, (F)-0.335977, (F)0.030058, (F)0.010773,
(F)-0.050278, (F)-0.059730,
(F)-0.263306, (F)0.519592, (F)0.055725, (F)0.460632, (F)-0.166199, (F)-0.069330,
(F)-0.269976, (F)-0.003105, (F)-0.212182, (F)-0.027622, (F)0.136812, (F)0.014673,
(F)-0.028954, (F)0.121287, (F)-0.239341, (F)-0.025669, (F)-0.043761, (F)0.086356,
(F)0.009261, (F)0.076557,
(F)0.789124, (F)-0.074402, (F)0.149414, (F)0.107239, (F)0.384705, (F)-0.622716,
(F)-0.005536, (F)-0.022325, (F)-0.011500, (F)-0.147998, (F)0.058712, (F)-0.117906,
(F)0.011117, (F)-0.084625, (F)0.007979, (F)-0.016023, (F)-0.303579, (F)0.028623,
(F)-0.057480, (F)-0.041255,
(F)0.394592, (F)0.252197, (F)0.193298, (F)0.192871, (F)0.347717, (F)-0.155703,
(F)-0.063603, (F)-0.037364, (F)-0.037199, (F)-0.120907, (F)-0.099515, (F)-0.076274,
(F)-0.048749, (F)-0.076105, (F)-0.048642, (F)-0.037282, (F)-0.137207, (F)-0.087693,
(F)-0.067213, (F)-0.067065,
(F)-0.221924, (F)0.296570, (F)1.154419, (F)-0.081482, (F)0.049438, (F)-0.049250,
(F)-0.087954, (F)-1.332683, (F)-0.006639, (F)-0.002444, (F)0.065816, (F)0.256193,
(F)-0.342366, (F)-0.018083, (F)0.024165, (F)0.094064, (F)0.010972, (F)-0.014662,
(F)-0.057073, (F)0.004028,
(F)0.539795, (F)0.479980, (F)0.039917, (F)-0.247986, (F)-0.346680, (F)-0.291379,
(F)-0.230381, (F)-0.001593, (F)-0.061497, (F)-0.120187, (F)-0.259091, (F)-0.021547,
(F)-0.019159, (F)0.133861, (F)0.119028, (F)0.009899, (F)0.187136, (F)0.166399,
(F)0.013838, (F)-0.085972,
(F)0.113464, (F)0.160767, (F)0.563232, (F)0.060791, (F)0.577637, (F)-0.012874,
(F)-0.025846, (F)-0.317231, (F)-0.003696, (F)-0.333664, (F)-0.018241, (F)-0.063907,
(F)-0.090549, (F)-0.006898, (F)-0.009773, (F)-0.034239, (F)-0.065541, (F)-0.092865,
(F)-0.325344, (F)-0.035115,
(F)0.179993, (F)0.748291, (F)0.628052, (F)-0.030334, (F)-0.240662, (F)-0.032397,
(F)-0.559939, (F)-0.394449, (F)-0.000920, (F)-0.057918, (F)-0.134687, (F)-0.113045,
(F)-0.469965, (F)0.005460, (F)0.022699, (F)0.019052, (F)0.043317, (F)0.180085,
(F)0.151148, (F)-0.007300,
(F)-0.177185, (F)0.094727, (F)0.907410, (F)0.608521, (F)-0.030273, (F)-0.031395,
(F)-0.008973, (F)-0.823392, (F)-0.370297, (F)-0.000916, (F)0.016784, (F)0.160779,
(F)-0.085956, (F)0.107821, (F)-0.057643, (F)-0.552177, (F)-0.005364, (F)0.002868,
(F)0.027470, (F)0.018422,
(F)0.197937, (F)0.502563, (F)0.463013, (F)0.205872, (F)0.131287, (F)-0.039179,
(F)-0.252570, (F)-0.214381, (F)-0.042383, (F)-0.017236, (F)-0.099476, (F)-0.091647,
(F)-0.232693, (F)-0.040750, (F)-0.103464, (F)-0.095321, (F)-0.025986, (F)-0.065980,
(F)-0.060787, (F)-0.027028,
(F)-0.587830, (F)0.003662, (F)0.213684, (F)0.327087, (F)0.619507, (F)-0.345544,
(F)-0.000013, (F)-0.045661, (F)-0.106986, (F)-0.383789, (F)0.002153, (F)0.125610,
(F)-0.000783, (F)0.192272, (F)-0.001198, (F)-0.069893, (F)0.364164, (F)-0.002269,
(F)-0.132379, (F)-0.202633,
(F)-0.419556, (F)-0.155823, (F)-0.332397, (F)-0.133972, (F)-0.478577, (F)-0.176027,
(F)-0.024281, (F)-0.110488, (F)-0.017949, (F)-0.229036, (F)-0.065376, (F)-0.139459,
(F)-0.051795, (F)-0.056209, (F)-0.020876, (F)-0.044532, (F)-0.200790, (F)-0.074573,
(F)-0.159078, (F)-0.064116,
(F)-0.208313, (F)-0.069641, (F)0.282593, (F)0.830811, (F)0.481995, (F)-0.043394,
(F)-0.004850, (F)-0.079859, (F)-0.690246, (F)-0.232319, (F)-0.014507, (F)0.058868,
(F)0.019680, (F)0.173069, (F)0.057859, (F)-0.234781, (F)0.100406, (F)0.033567,
(F)-0.136208, (F)-0.400446,
(F)0.269165, (F)-0.346558, (F)0.488647, (F)-0.243652, (F)0.232605, (F)-0.072450,
(F)-0.120102, (F)-0.238776, (F)-0.059366, (F)-0.054105, (F)0.093281, (F)-0.131527,
(F)0.169344, (F)0.065583, (F)-0.084440, (F)0.119060, (F)-0.062609, (F)0.080611,
(F)-0.113662, (F)0.056675,
(F)0.345398, (F)0.704041, (F)0.134460, (F)-0.027588, (F)0.437561, (F)-0.119300,
(F)-0.495673, (F)-0.018080, (F)-0.000761, (F)-0.191460, (F)-0.243174, (F)-0.046442,
(F)-0.094666, (F)0.009529, (F)0.019423, (F)0.003709, (F)-0.151133, (F)-0.308061,
(F)-0.058835, (F)0.012071,
(F)0.177856, (F)-0.177856, (F)0.212708, (F)-0.242004, (F)0.834656, (F)-0.031633,
(F)-0.031633, (F)-0.045244, (F)-0.058566, (F)-0.696650, (F)0.031633, (F)-0.037831,
(F)0.037831, (F)0.043042, (F)-0.043042, (F)0.051476, (F)-0.148449, (F)0.148449,
(F)-0.177538, (F)0.201990,
(F)0.478699, (F)0.116394, (F)0.062378, (F)0.542114, (F)0.486572, (F)-0.229152,
(F)-0.013548, (F)-0.003891, (F)-0.293888, (F)-0.236753, (F)-0.055718, (F)-0.029860,
(F)-0.007260, (F)-0.259509, (F)-0.063099, (F)-0.033816, (F)-0.232922, (F)-0.056634,
(F)-0.030351, (F)-0.263778,
(F)0.842712, (F)0.581726, (F)0.087646, (F)0.098389, (F)0.108582, (F)-0.710164,
(F)-0.338405, (F)-0.007682, (F)-0.009680, (F)-0.011790, (F)-0.490228, (F)-0.073861,
(F)-0.050986, (F)-0.082913, (F)-0.057235, (F)-0.008623, (F)-0.091503, (F)-0.063165,
(F)-0.009517, (F)-0.010683,
(F)0.831299, (F)-0.325745, (F)0.332642, (F)-0.138123, (F)0.105164, (F)-0.691058,
(F)-0.106110, (F)-0.110650, (F)-0.019078, (F)-0.011059, (F)0.270791, (F)-0.276525,
(F)0.108356, (F)0.114821, (F)-0.044993, (F)0.045945, (F)-0.087422, (F)0.034256,
(F)-0.034982, (F)0.014525,
(F)0.323303, (F)0.511108, (F)0.541504, (F)0.469604, (F)0.399048, (F)-0.104525,
(F)-0.261232, (F)-0.293226, (F)-0.220528, (F)-0.159239, (F)-0.165243, (F)-0.175070,
(F)-0.276767, (F)-0.151825, (F)-0.240019, (F)-0.254293, (F)-0.129013, (F)-0.203957,
(F)-0.216086, (F)-0.187395 };


/*
**  AcbkGainTablePtr:
**
**  Purpose:
**      Contains pointers to 85 and 170 element codebooks
**
*/

float *AcbkGainTablePtr[2] = {
   AcbkGainTable085,
   AcbkGainTable170,
   };

/*
**  LpfConstTable:
**
**  Purpose:
**      Sets the postfilter gain weighting factor.
**
**  Table Structure:
**      (0.1875 , 0.25) in Q15 ( i.e. scale by 32768 ).

*/

float LpfConstTable[2] = {
 (F)0.1875,
   (F)0.25,
   } ;

/*
**  epsi170:
**
**  Purpose:
**      At the lower bitrate, the pitch contribution is added
**      into the output vector of ACELP when the pitch period is
**      less than 60 samples (one subframe). The pitch contribution
**      is estimated by a 1 tap long term predictor (LTP) instead of
**      the 5 tap LTP used in pitch prediction. The values in epsi170
**      effectively choose one of the 5 vectors used in the 5 tap LTP.
**
**  Table Structure:
**      The table is indexed by the index into the AcbkGainTable170
**      table (determined in Find_Acbk). The value, 60, is used only
**      as a place holder. They correspond to zeros in the gain170
**      table, which is the coefficient of the 1 tap long term
**      preditor (LTP).  The rest of the values range from -2 to +2.
**      These values pick one vector among the 5 vectors centered one
**      pitch period behind the current vector. (In contrast, the 5
**      tap LTP uses all five vectors centered one pitch period back.)
*/

int epsi170[170] = {
    60,      0,     60,      0,      1,      0,      0,      1,
    -1,      1,      0,     -1,      2,     -2,      0,      1,
     0,      0,     -1,      0,      0,      0,      1,      0,
    -1,     -1,      1,     -1,      1,     -2,      1,     -1,
    60,      0,      0,      1,      1,      0,      1,      1,
    -1,      1,     -1,     -1,     -1,      0,     60,     -2,
     0,      1,      0,     -1,      1,      1,      0,      1,
     2,     -1,      0,      1,      0,      0,      0,     60,
    -1,      1,      1,      2,     -1,      1,     -1,     60,
    -1,      0,      1,      0,     -1,      0,      0,      0,
     1,     -1,      0,      1,     -1,      0,     -1,      0,
     1,     60,      0,      0,      1,      1,      0,      2,
     1,      0,      1,     -2,      0,     -1,      1,      0,
    -1,      1,      0,      0,      1,      0,      0,      0,
    60,      1,      1,     -1,     -1,      2,     -2,      0,
    -1,     -1,     60,      2,     60,      0,      0,     60,
     0,      0,      0,     -2,     60,     -1,      0,     60,
     0,      2,      0,      0,     -1,      0,      1,      2,
    60,      1,      1,      1,      0,      0,     60,      0,
    60,      0,      0,     60,     60,     -1,      0,      0,
    60,     60,      1,      0,     60,      2,     60,     -2,
    -2,      0 };

/*
**  gain170:
*/

 float gain170[170] = {
(F)0.000000,
(F)0.075958,
(F)0.000000,
(F)0.159210,
(F)0.188324,
(F)0.120636,
(F)0.316284,
(F)0.285553,
(F)0.269867,
(F)0.286743,
(F)0.176819,
(F)0.330078,
(F)0.354187,
(F)0.368408,
(F)0.262939,
(F)0.371399,
(F)0.440674,
(F)0.237640,
(F)0.418732,
(F)0.555573,
(F)0.441620,
(F)0.482391,
(F)0.466156,
(F)0.411377,
(F)0.560760,
(F)0.000000,
(F)0.341614,
(F)0.397034,
(F)0.574829,
(F)0.621155,
(F)0.495392,
(F)0.000000,
(F)0.000000,
(F)0.370178,
(F)0.408478,
(F)0.544250,
(F)0.637054,
(F)0.671265,
(F)0.000000,
(F)0.557770,
(F)0.650665,
(F)0.419250,
(F)0.582703,
(F)0.622162,
(F)0.000000,
(F)0.641113,
(F)0.000000,
(F)0.696014,
(F)0.485229,
(F)0.000000,
(F)0.548981,
(F)0.679291,
(F)0.744476,
(F)0.706116,
(F)0.730835,
(F)0.701813,
(F)0.689819,
(F)0.791687,
(F)0.800964,
(F)0.772736,
(F)0.806366,
(F)0.734283,
(F)0.831512,
(F)0.000000,
(F)0.780396,
(F)0.729919,
(F)0.791321,
(F)0.805908,
(F)0.581329,
(F)0.834869,
(F)0.748840,
(F)0.000000,
(F)0.765778,
(F)0.871246,
(F)0.000000,
(F)0.695587,
(F)0.783051,
(F)0.896515,
(F)0.923950,
(F)0.799500,
(F)0.687286,
(F)0.882538,
(F)0.835693,
(F)0.920471,
(F)0.000000,
(F)0.739655,
(F)0.917419,
(F)0.664154,
(F)0.943512,
(F)0.000000,
(F)0.954712,
(F)0.898224,
(F)0.818512,
(F)0.874481,
(F)0.956024,
(F)0.939911,
(F)0.957916,
(F)0.986389,
(F)0.969238,
(F)0.971375,
(F)0.822021,
(F)0.951538,
(F)0.942230,
(F)0.850616,
(F)0.928619,
(F)0.947571,
(F)0.000000,
(F)0.973877,
(F)0.964691,
(F)0.963287,
(F)0.779938,
(F)0.956940,
(F)0.000000,
(F)0.901367,
(F)0.884552,
(F)0.823486,
(F)0.963959,
(F)0.941040,
(F)0.950104,
(F)0.922943,
(F)0.938171,
(F)0.979309,
(F)0.000000,
(F)0.943054,
(F)0.000000,
(F)0.916351,
(F)0.886292,
(F)0.000000,
(F)0.969116,
(F)0.749298,
(F)0.782349,
(F)0.930817,
(F)0.000000,
(F)0.903839,
(F)0.935333,
(F)0.000000,
(F)0.893372,
(F)0.928192,
(F)0.838623,
(F)0.952545,
(F)0.858978,
(F)0.933838,
(F)0.965942,
(F)0.887085,
(F)0.000000,
(F)0.871918,
(F)0.876770,
(F)0.958923,
(F)0.862335,
(F)0.756744,
(F)0.000000,
(F)0.000000,
(F)0.000000,
(F)0.674591,
(F)0.849976,
(F)0.000000,
(F)0.000000,
(F)0.738953,
(F)0.752014,
(F)0.711212,
(F)0.000000,
(F)0.000000,
(F)0.698334,
(F)0.659210,
(F)0.000000,
(F)0.782776,
(F)0.000000,
(F)0.953766,
(F)0.767334,
(F)0.549255 };


/*
**  tabgain170:
*/

float tabgain170[170] = {
(F)0.125000,
(F)0.194214,
(F)0.204834,
(F)0.230835,
(F)0.258789,
(F)0.292847,
(F)0.362061,
(F)0.372192,
(F)0.388794,
(F)0.404907,
(F)0.419067,
(F)0.430054,
(F)0.455200,
(F)0.461304,
(F)0.462524,
(F)0.520264,
(F)0.543213,
(F)0.545532,
(F)0.575317,
(F)0.603516,
(F)0.604248,
(F)0.607910,
(F)0.611572,
(F)0.614258,
(F)0.646851,
(F)0.657837,
(F)0.657837,
(F)0.657837,
(F)0.689209,
(F)0.695923,
(F)0.699829,
(F)0.703735,
(F)0.732056,
(F)0.732056,
(F)0.750732,
(F)0.758179,
(F)0.773438,
(F)0.776367,
(F)0.783081,
(F)0.783081,
(F)0.784912,
(F)0.786133,
(F)0.788696,
(F)0.788696,
(F)0.794922,
(F)0.805786,
(F)0.828491,
(F)0.838867,
(F)0.846069,
(F)0.851074,
(F)0.852539,
(F)0.861328,
(F)0.861328,
(F)0.867310,
(F)0.868774,
(F)0.869507,
(F)0.871094,
(F)0.874146,
(F)0.874878,
(F)0.876465,
(F)0.876465,
(F)0.886475,
(F)0.892090,
(F)0.895264,
(F)0.895264,
(F)0.901733,
(F)0.904175,
(F)0.907471,
(F)0.908325,
(F)0.908325,
(F)0.913208,
(F)0.919922,
(F)0.923340,
(F)0.926758,
(F)0.938110,
(F)0.941650,
(F)0.947021,
(F)0.948730,
(F)0.951416,
(F)0.952393,
(F)0.954224,
(F)0.956909,
(F)0.960571,
(F)0.962524,
(F)0.965210,
(F)0.969971,
(F)0.975586,
(F)0.981323,
(F)0.984253,
(F)0.987183,
(F)0.987183,
(F)0.996948,
(F)0.999023,
(F)1.000977,
(F)1.000977,
(F)1.005981,
(F)1.009033,
(F)1.011108,
(F)1.014160,
(F)1.014160,
(F)1.017334,
(F)1.022461,
(F)1.025635,
(F)1.033081,
(F)1.039551,
(F)1.040527,
(F)1.041626,
(F)1.054810,
(F)1.058228,
(F)1.061523,
(F)1.068359,
(F)1.069458,
(F)1.074097,
(F)1.077637,
(F)1.091675,
(F)1.112305,
(F)1.113525,
(F)1.114868,
(F)1.117310,
(F)1.133789,
(F)1.135132,
(F)1.144165,
(F)1.145508,
(F)1.145508,
(F)1.148071,
(F)1.149414,
(F)1.156128,
(F)1.160034,
(F)1.166870,
(F)1.169556,
(F)1.179199,
(F)1.179199,
(F)1.186279,
(F)1.196167,
(F)1.199097,
(F)1.201904,
(F)1.201904,
(F)1.212158,
(F)1.225464,
(F)1.240723,
(F)1.248413,
(F)1.256226,
(F)1.273926,
(F)1.282104,
(F)1.283691,
(F)1.285400,
(F)1.293701,
(F)1.295288,
(F)1.296997,
(F)1.347656,
(F)1.351318,
(F)1.354980,
(F)1.356812,
(F)1.381226,
(F)1.383179,
(F)1.440918,
(F)1.477051,
(F)1.496948,
(F)1.496948,
(F)1.501465,
(F)1.505981,
(F)1.517456,
(F)1.562500,
(F)1.582275,
(F)1.594849,
(F)1.647461,
(F)1.686401,
(F)1.721191,
(F)1.733154,
(F)2.247192 };

/*
**  tabgain85:
*/
float tabgain85[85] = {
(F)0.125000,
(F)0.159668,
(F)0.232666,
(F)0.279663,
(F)0.306519,
(F)0.333984,
(F)0.402588,
(F)0.425903,
(F)0.431030,
(F)0.469238,
(F)0.532227,
(F)0.554321,
(F)0.571777,
(F)0.587524,
(F)0.618774,
(F)0.674805,
(F)0.680786,
(F)0.697388,
(F)0.723022,
(F)0.727295,
(F)0.727295,
(F)0.740234,
(F)0.748535,
(F)0.772827,
(F)0.777588,
(F)0.796753,
(F)0.797485,
(F)0.802612,
(F)0.809692,
(F)0.814331,
(F)0.833984,
(F)0.833984,
(F)0.851074,
(F)0.854004,
(F)0.878784,
(F)0.879517,
(F)0.905029,
(F)0.919067,
(F)0.920776,
(F)0.920776,
(F)0.938965,
(F)0.947021,
(F)0.956909,
(F)0.956909,
(F)0.960571,
(F)0.975586,
(F)0.976563,
(F)0.978516,
(F)0.983276,
(F)0.986206,
(F)0.991089,
(F)1.001953,
(F)1.007080,
(F)1.009033,
(F)1.012085,
(F)1.013184,
(F)1.016235,
(F)1.025635,
(F)1.030884,
(F)1.050415,
(F)1.052612,
(F)1.060425,
(F)1.068359,
(F)1.078735,
(F)1.079956,
(F)1.095337,
(F)1.098877,
(F)1.100098,
(F)1.121094,
(F)1.171021,
(F)1.180664,
(F)1.190430,
(F)1.201904,
(F)1.218018,
(F)1.237671,
(F)1.245361,
(F)1.259399,
(F)1.278809,
(F)1.293701,
(F)1.293701,
(F)1.305542,
(F)1.394653,
(F)1.424561,
(F)1.785767,
(F)1.862183 } ;

/*
**  fact   :
**  bseg   :
**  base   :
*/
float   fact[4] = {(F)0.008333, (F)61.6815, (F)30.84075, (F)20.6145};
float   bseg[3] = {(F)1024., (F)9216., (F)115617.};
float   base[3] = {(F)0.0, (F)32.0, (F)96.0};


//---------------------------------------------------------------------------
//========================= Start Class Body... ============//
//---------------------------------------------------------------------------

CCODEC::CCODEC()
{
}
//---------------------------------------------------------------------------
CCODEC::~CCODEC()
{
}
//-----------------------------------------------------------------------------

void CCODEC::Init_Cod_Cng(void)
{
    int i;

    CodCng.CurGain = (float)0.0;

    for (i=0; i< SizAcf; i++)
        CodCng.Acf[i] = (float)0.0;

    for (i=0; i < LpcOrder; i++)
        CodCng.SidLpc[i] = (float)0.0;

    CodCng.PastFtyp = 1;

    CodCng.RandSeed = 12345;

    return;
}
//---------------------------------------------------------------------------
void CCODEC::Cod_Cng(float *DataExc, Word16 *Ftyp, LINEDEF *Line, float *QntLpc)
{
    float   curCoeff[LpcOrder];
    Word16  curQGain;
    float   temp;
    int     i;

    for (i=NbAvGain-1; i>=1; i--) {
        CodCng.Ener[i] = CodCng.Ener[i-1];
    }

    /*
     *   LPC filter .
     */
    CodCng.Ener[0] = Durbin(curCoeff, &CodCng.Acf[1], CodCng.Acf[0], &temp);

    /*
     *   silence  => SID frame
     */
    if (CodCng.PastFtyp == 1) {
        *Ftyp = 2;
        CodCng.NbEner = 1;
        curQGain = Qua_SidGain(CodCng.Ener, CodCng.NbEner);
    }

    else {
        CodCng.NbEner++;
        if (CodCng.NbEner > NbAvGain)
            CodCng.NbEner = NbAvGain;
        curQGain = Qua_SidGain(CodCng.Ener, CodCng.NbEner);

        if (LpcDiff(CodCng.RC, CodCng.Acf, *CodCng.Ener) == 0) {
            *Ftyp = 2;  /*  SID frame */
        }
        else {
            i = abs((int)(curQGain - CodCng.IRef));
            if (i > ThreshGain) {
                *Ftyp = 2;
            }
            else {
                /* no transmission */
                *Ftyp = 0;
            }
        }
    }

    /*
     * If SID frame : Compute SID filter
     */
    if (*Ftyp == 2) {


        /* Compute past average filter */
        ComputePastAvFilter(CodCng.SidLpc) ;

        /* If adaptation enabled, fill noise filter */
        if ( !VadStat.Aen ) {
            for (i = 0; i < LpcOrder; i++)
                VadStat.NLpc[i] = CodCng.SidLpc[i];
        }

        /* Compute autocorr. of past average filter coefficients */
        CalcRC(CodCng.SidLpc , CodCng.RC);

        if (LpcDiff(CodCng.RC, CodCng.Acf, *CodCng.Ener) == 0) {
            for (i=0; i<LpcOrder; i++) {
                CodCng.SidLpc[i] = curCoeff[i];
            }
            CalcRC(curCoeff, CodCng.RC);
        }

        /*
         * Compute SID frame codes
         */

        /* Compute LspSid */
        AtoLsp(CodCng.LspSid, CodCng.SidLpc, CodStat.PrevLsp);
        Line->LspId = Lsp_Qnt(CodCng.LspSid, CodStat.PrevLsp);
        Lsp_Inq(CodCng.LspSid, CodStat.PrevLsp, Line->LspId, 0);

        Line->Sfs[0].Mamp = curQGain;
        CodCng.IRef = curQGain;
        CodCng.SidGain = Dec_SidGain(CodCng.IRef);

    } /* end of Ftyp=2 case (SID frame) */

    /*
     * Compute new excitation
     */
    if (CodCng.PastFtyp == 1) {
        CodCng.CurGain = CodCng.SidGain;
    }
    else {
        CodCng.CurGain = (float)0.875 * CodCng.CurGain + (float)0.125 * CodCng.SidGain;
    }
    Calc_Exc_Rand(CodCng.CurGain, CodStat.PrevExc, DataExc,
                                                &CodCng.RandSeed, Line);

    /*
     * Interpolate LSPs and update PrevLsp
     */
    Lsp_Int(QntLpc, CodCng.LspSid, CodStat.PrevLsp);
    for (i=0; i < LpcOrder ; i++) {
        CodStat.PrevLsp[i] = CodCng.LspSid[i];
    }

    /*
     * Output & save frame type info
     */
    CodCng.PastFtyp = *Ftyp;
    return;
}
//---------------------------------------------------------------------------
void CCODEC::Update_Acf(float *Acf_sf)
{
    int i, i_subfr;
    float *ptr1, *ptr2;

    /* Update Acf */
    ptr2 = CodCng.Acf + SizAcf;
    ptr1 = ptr2 - LpcOrderP1;
    for (i=LpcOrderP1; i<SizAcf; i++)
        *(--ptr2) = *(--ptr1);

    /* Compute current sum of acfs */
    for (i=0; i<= LpcOrder; i++)
        CodCng.Acf[i] = (float) 0.0;

    ptr2 = Acf_sf;
    for (i_subfr=0; i_subfr<SubFrames; i_subfr++) {
        for (i=0; i <= LpcOrder; i++) {
            CodCng.Acf[i] += *ptr2++;
        }
    }
}
//---------------------------------------------------------------------------
 void CCODEC::ComputePastAvFilter(float *Coeff)
{
    int i, j;
    float *ptr_Acf;
    float sumAcf[LpcOrderP1];
    float temp;

    /* Compute sum of NbAvAcf frame-Acfs  */
    for (j=0; j <= LpcOrder; j++)
        sumAcf[j] = (float) 0.0;

    ptr_Acf = CodCng.Acf + LpcOrderP1;
    for (i=1; i <= NbAvAcf; i++) {
        for (j=0; j <= LpcOrder; j++) {
            sumAcf[j] += *ptr_Acf++;
        }
    }

    Durbin(Coeff, &sumAcf[1], sumAcf[0], &temp);

    return;
}
//---------------------------------------------------------------------------
 void CCODEC::CalcRC(float *Coeff, float *RC)
{
    int i, j;
    float temp;

    temp = (float) 1.0 + DotProd(Coeff, Coeff, LpcOrder);
    RC[0] = temp;

    for (i=1; i<=LpcOrder; i++) {
        temp = -Coeff[i-1];
        for (j=0; j<LpcOrder-i; j++) {
            temp += Coeff[j] * Coeff[j+i];
        }
        RC[i] = (float)2.0 * temp;
    }
    return;
}
//---------------------------------------------------------------------------
Flag CCODEC::LpcDiff(float *RC, float *ptrAcf, float alpha)
{
    float temp0, temp1;
    Flag diff;

    temp0 = DotProd(RC, ptrAcf, LpcOrderP1);
    temp1 = alpha * FracThreshP1;

    if (temp0 < temp1)
        diff = 1;
    else
        diff = 0;
    return(diff);
}

//---------------------------------------------------------------------------
void  CCODEC::Init_Coder(void)
{
    int i;

    /* Initialize encoder data structure with zeros */
    memset(&CodStat,0,sizeof(CODSTATDEF));

    /* Initialize the previously decoded LSP vector to the DC vector */

    for (i=0; i < LpcOrder; i++)
        CodStat.PrevLsp[i] = LspDcTable[i];

    /* Initialize the taming procedure */
    for(i=0; i<SizErr; i++)
        CodStat.Err[i] = Err0;

    return;
}
//---------------------------------------------------------------------------
Flag  CCODEC::Coder(float *DataBuff, char *Vout)
{
    int i,j;

    /*
     *  Local variables
     */
    float   UnqLpc[SubFrames*LpcOrder];
    float   QntLpc[SubFrames*LpcOrder];
    float   PerLpc[2*SubFrames*LpcOrder];

    float   LspVect[LpcOrder];
    LINEDEF Line;
    PWDEF   Pw[SubFrames];

    float   ImpResp[SubFrLen];
    float   *Dpnt;

    Word16  Ftyp = 1;

    /*  Coder Start  */

    Line.Crc = 0;

    Rem_Dc(DataBuff);

    /* Compute the Unquantized Lpc set for whole frame */
    Comp_Lpc(UnqLpc, CodStat.PrevDat, DataBuff);

    /* Convert to Lsp */
    AtoLsp(LspVect, &UnqLpc[LpcOrder*(SubFrames-1)], CodStat.PrevLsp);

    /* Compute the Vad */
    Ftyp = (Word16) Comp_Vad(DataBuff);

    /* VQ Lsp vector */
    Line.LspId = Lsp_Qnt(LspVect, CodStat.PrevLsp);

    Mem_Shift(CodStat.PrevDat, DataBuff);

    /* Compute Percetual filter Lpc coefficeints */
    Wght_Lpc(PerLpc, UnqLpc);

    /* Apply the perceptual weighting filter */
    Error_Wght(DataBuff, PerLpc);

    /*  Compute Open loop pitch estimates  */

    Dpnt = (float *) malloc(sizeof(float)*(PitchMax+Frame));

    /* Construct the buffer */
    for (i=0; i < PitchMax;i++)
        Dpnt[i] = CodStat.PrevWgt[i];

    for (i=0;i < Frame;i++)
        Dpnt[PitchMax+i] = DataBuff[i];

    j = PitchMax;
    for (i=0; i < SubFrames/2; i++) {
        Line.Olp[i] = Estim_Pitch(Dpnt, j);
        VadStat.Polp[i+2] = (Word16) Line.Olp[i];
        j += 2*SubFrLen;
    }

    if (Ftyp != 1) {

        /*
        // Case of inactive signal
        */
        free((char *) Dpnt);

        /* Save PrevWgt */
        for ( i = 0 ; i < PitchMax ; i ++ )
            CodStat.PrevWgt[i] = DataBuff[i+Frame-PitchMax];

        /* CodCng => Ftyp = 0 (untransmitted) or 2 (SID) */
        Cod_Cng(DataBuff, &Ftyp, &Line, QntLpc);

        /* Update the ringing delays */
        Dpnt = DataBuff;
        for ( i = 0 ; i < SubFrames; i++ ) {

            /* Update exc_err */
            Update_Err(Line.Olp[i>>1], Line.Sfs[i].AcLg, Line.Sfs[i].AcGn);

            Upd_Ring( Dpnt, &QntLpc[i*LpcOrder], &PerLpc[i*2*LpcOrder],
                                                        CodStat.PrevErr);
            Dpnt += SubFrLen;
        }
    }
    else {

        /* Compute the Hmw */
        j = PitchMax;
        for (i=0; i < SubFrames; i++) {
            Pw[i] = Comp_Pw(Dpnt, j, Line.Olp[i>>1]);
            j += SubFrLen;
        }

        /* Reload the buffer */
        for (i=0; i < PitchMax; i++)
            Dpnt[i] = CodStat.PrevWgt[i];
        for (i=0; i < Frame; i++)
            Dpnt[PitchMax+i] = DataBuff[i];

        /* Save PrevWgt */
        for (i=0; i < PitchMax; i++)
          CodStat.PrevWgt[i] = Dpnt[Frame+i];

        /* Apply the Harmonic filter */
        j = 0;
        for (i=0; i < SubFrames; i++) {
            Filt_Pw(DataBuff, Dpnt, j , Pw[i]);
            j += SubFrLen;
        }

        free((char *) Dpnt);

        /* Inverse quantization of the LSP */
        Lsp_Inq(LspVect, CodStat.PrevLsp, Line.LspId, Line.Crc);

        /* Interpolate the Lsp vectors */
        Lsp_Int(QntLpc, LspVect, CodStat.PrevLsp);

        /* Copy the LSP vector for the next frame */
        for ( i = 0 ; i < LpcOrder ; i ++ )
            CodStat.PrevLsp[i] = LspVect[i];

        /*  Start the sub frame processing loop  */

        Dpnt = DataBuff;

        for (i=0; i < SubFrames; i++) {

            /* Compute full impulse response */
            Comp_Ir(ImpResp, &QntLpc[i*LpcOrder], &PerLpc[i*2*LpcOrder], Pw[i]);

            /* Subtruct the ringing of previos sub-frame */
            Sub_Ring(Dpnt, &QntLpc[i*LpcOrder], &PerLpc[i*2*LpcOrder],
                     CodStat.PrevErr, Pw[i]);

            /* Compute adaptive code book contribution */
            Find_Acbk(Dpnt, ImpResp, CodStat.PrevExc, &Line, i);

            /* Compute fixed code book contribution */
            Find_Fcbk(Dpnt, ImpResp, &Line, i);

            /* Reconstruct the excitation */
            Decod_Acbk(ImpResp, CodStat.PrevExc, Line.Olp[i>>1],
                       Line.Sfs[i].AcLg, Line.Sfs[i].AcGn);

            for (j=SubFrLen; j < PitchMax; j++)
                CodStat.PrevExc[j-SubFrLen] = CodStat.PrevExc[j];

            for (j=0; j < SubFrLen; j++) {
                Dpnt[j] = Dpnt[j] + ImpResp[j];
                CodStat.PrevExc[PitchMax-SubFrLen+j] = Dpnt[j];

                /* Clip the new samples */
                if (CodStat.PrevExc[PitchMax-SubFrLen+j] < (float)-32767.5)
                    CodStat.PrevExc[PitchMax-SubFrLen+j] = (float)-32768.0;
                else if (CodStat.PrevExc[PitchMax-SubFrLen+j] > (float)32766.5)
                    CodStat.PrevExc[PitchMax-SubFrLen+j] = (float)32767.0;
            }

            /* Update exc_err */
            Update_Err(Line.Olp[i>>1], Line.Sfs[i].AcLg, Line.Sfs[i].AcGn);

            /* Update the ringing delays  */
            Upd_Ring(Dpnt, &QntLpc[i*LpcOrder], &PerLpc[i*2*LpcOrder],
                     CodStat.PrevErr);

            Dpnt += SubFrLen;
        }  /* end of subframes loop */

        /*
        // Save Vad information and reset CNG random generator
        */
        CodCng.PastFtyp = 1;
        CodCng.RandSeed = 12345;

    } /* End of active frame case */

    /* Pack the Line structure */
    Line_Pack(&Line, Vout, Ftyp);

    return (Flag) True;
}

//---------------------------------------------------------------------------

void CCODEC::Init_Dec_Cng(void)
{
    int i;

    DecCng.PastFtyp = 1;
    DecCng.SidGain = (float)0.0;
    for (i=0; i<LpcOrder; i++)
        DecCng.LspSid[i] = LspDcTable[i];
    DecCng.RandSeed = 12345;
    return;
}
//---------------------------------------------------------------------------

void CCODEC::Dec_Cng(Word16 Ftyp, LINEDEF *Line, float *DataExc, float *QntLpc)
{
    Word16 temp;
    int i;

    if (Ftyp == 2) {
        /*
         * SID Frame decoding
         */

        DecCng.SidGain = Dec_SidGain((Word16) Line->Sfs[0].Mamp);

        /* Inverse quantization of the LSP */
        Lsp_Inq(DecCng.LspSid, DecStat.PrevLsp, Line->LspId, 0);
    }
    else {

        /*
         * non SID Frame
         */
        if (DecCng.PastFtyp == 1) {
            temp = Qua_SidGain(&DecCng.SidGain, 0);
            DecCng.SidGain = Dec_SidGain(temp);
        }
    }

    if (DecCng.PastFtyp == 1) {
        DecCng.CurGain = DecCng.SidGain;
    }
    else {
        DecCng.CurGain =   (float) 0.875 * DecCng.CurGain
                         + (float) 0.125 * DecCng.SidGain;
    }
    Calc_Exc_Rand(DecCng.CurGain, DecStat.PrevExc, DataExc,
                    &DecCng.RandSeed, Line);

    /* Interpolate the Lsp vectors */
    Lsp_Int( QntLpc, DecCng.LspSid, DecStat.PrevLsp );

    /* Copy the LSP vector for the next frame */
    for ( i = 0 ; i < LpcOrder ; i ++ )
        DecStat.PrevLsp[i] = DecCng.LspSid[i];

    return;
}

//---------------------------------------------------------------------------
void  CCODEC::Init_Decod(void)
{
    int i;

    /* Initialize decoder data structure with zeros */
    memset(&DecStat,0,sizeof(DECSTATDEF));

    /* Initialize the previously decoded LSP vector to the DC vector */
    for (i = 0; i < LpcOrder; i++)
        DecStat.PrevLsp[i] = LspDcTable[i];

    DecStat.Gain = (float)1.0;
}
//---------------------------------------------------------------------------
Flag  CCODEC::Decod(float *DataBuff, char *Vinp, Word16 Crc)
{
    int      i, j, g;

    float    Senr;
    float    QntLpc[SubFrames*LpcOrder];
    float    AcbkCont[SubFrLen];

    float    LspVect[LpcOrder];
    float    Temp[PitchMax+Frame];
    float   *Dpnt;

    LINEDEF  Line;
    PFDEF    Pf[SubFrames];

    Word16   Ftyp;

    /*
     * Decode the packed bitstream for the frame.  (Text: Section 4;
     * pars of sectio,d 2.17, 2.18)
     */
    Line = Line_Unpk(Vinp, &Ftyp, Crc);

    if (Line.Crc != (Word16) 0) {
        if(DecCng.PastFtyp == 1)
            Ftyp = 1;  /* active */
        else
            Ftyp = 0;  /* untransmitted */
    }

    if (Ftyp != 1) {

        /* Silence frame : do noise generation */
        Dec_Cng(Ftyp, &Line, DataBuff, QntLpc);
    }
    else {

        /*
         * Update the frame erasure count (Text: Section 3.10)
         */
        if (Line.Crc != 0)
            DecStat.Ecount++;
        else
            DecStat.Ecount = 0;

        if (DecStat.Ecount >  ErrMaxNum)
            DecStat.Ecount = ErrMaxNum;

        /*
         * Decode the LSP vector for subframe 3.  (Text: Section 3.2)
         */
        Lsp_Inq(LspVect, DecStat.PrevLsp, Line.LspId, Line.Crc);

        /*
         * Interpolate the LSP vectors for subframes 0--2.  Convert the
         * LSP vectors to LPC coefficients.  (Text: Section 3.3)
         */
        Lsp_Int(QntLpc, LspVect, DecStat.PrevLsp);

        /* Copy the LSP vector for the next frame */
        for ( i = 0 ; i < LpcOrder ; i ++ )
            DecStat.PrevLsp[i] = LspVect[i];

        /*
         * In case of no erasure, update the interpolation gain memory.
         * Otherwise compute the interpolation gain (Text: Section 3.10)
         */
        if (DecStat.Ecount == 0) {
            g = (Line.Sfs[SubFrames-2].Mamp + Line.Sfs[SubFrames-1].Mamp) >> 1;
            DecStat.InterGain = FcbkGainTable[g];
        }
        else
            DecStat.InterGain = DecStat.InterGain*(float)0.75;

        /*
         * Generate the excitation for the frame
         */
        for (i = 0; i < PitchMax; i++)
            Temp[i] = DecStat.PrevExc[i];

        Dpnt = &Temp[PitchMax];

        if (DecStat.Ecount == 0) {

            for (i = 0; i < SubFrames; i++) {

                /* Generate the fixed codebook excitation for a
                   subframe. (Text: Section 3.5) */
                Fcbk_Unpk(Dpnt, Line.Sfs[i], Line.Olp[i>>1], i);

                /* Generate the adaptive codebook excitation for a
                   subframe. (Text: Section 3.4) */
                Decod_Acbk(AcbkCont, &Temp[SubFrLen*i], Line.Olp[i>>1],
                           Line.Sfs[i].AcLg, Line.Sfs[i].AcGn);

                /* Add the adaptive and fixed codebook contributions to
                   generate the total excitation. */

                for (j = 0; j < SubFrLen; j++)
                    Dpnt[j] = Dpnt[j] + AcbkCont[j];

                Dpnt += SubFrLen;
            }

            /* Save the excitation */
            for (j = 0; j < Frame; j++)
                DataBuff[j] = Temp[PitchMax+j];

            /* Compute interpolation index. (Text: Section 3.10) */
            /* Use DecCng.SidGain to store                       */
            /* excitation energy estimation                      */
            DecStat.InterIndx = Comp_Info(Temp, Line.Olp[SubFrames/2-1],
                                          &DecCng.SidGain);

            /* Compute pitch post filter coefficients.  (Text: Section 3.6) */
            if (UsePf)
                for (i = 0; i < SubFrames; i++)
                    Pf[i] = Comp_Lpf(Temp, Line.Olp[i>>1], i);

            /* Reload the original excitation */
            for (j = 0; j < PitchMax; j++)
                Temp[j] = DecStat.PrevExc[j];
            for (j = 0; j < Frame; j++)
                Temp[PitchMax+j] = DataBuff[j];

            /* Clip newly generated samples in Temp array */
            for (j = 0; j < Frame; j++) {
                if (Temp[PitchMax+j] < (float)-32767.5)
                    Temp[PitchMax+j] = (float)-32768.0;
                else if (Temp[PitchMax+j] > (float)32766.5)
                    Temp[PitchMax+j] = (float)32767.0;
            }

            /* Perform pitch post filtering for the frame.  (Text: Section
               3.6) */
            if (UsePf)
                for (i = 0; i < SubFrames; i++)
                    Filt_Lpf(DataBuff, Temp, Pf[i], i);

            /* Save Lsps --> LspSid */
            for (i=0; i < LpcOrder; i++)
                DecCng.LspSid[i] = DecStat.PrevLsp[i];
        }
        else {
            /* If a frame erasure has occurred, regenerate the
               signal for the frame. (Text: Section 3.10) */
            Regen(DataBuff, Temp, DecStat.InterIndx, DecStat.InterGain,
                  DecStat.Ecount, &DecStat.Rseed);
        }

        /* Update the previous excitation for the next frame */
        for (j = 0; j < PitchMax; j++)
            DecStat.PrevExc[j] = Temp[Frame+j];

        /* Resets random generator for CNG */
        DecCng.RandSeed = 12345;
    }

    /* Save Ftyp information for next frame */
    DecCng.PastFtyp = Ftyp;

    /*
     * Synthesize the speech for the frame
     */
    Dpnt = DataBuff;
    for (i = 0; i < SubFrames; i++) {

        /* Compute the synthesized speech signal for a subframe.
         * (Text: Section 3.7)
         */
        Synt(Dpnt, &QntLpc[i*LpcOrder]);

        if (UsePf) {

            /* Do the formant post filter. (Text: Section 3.8) */
            Senr = Spf( Dpnt, &QntLpc[i*LpcOrder] ) ;

            /* Do the gain scaling unit.  (Text: Section 3.9) */
            Scale(Dpnt, Senr);
        }

        Dpnt += SubFrLen;
    }

    return (Flag) True;
}

//---------------------------------------------------------------------------
int CCODEC::Estim_Pitch(float *Dpnt, int Start)
{
    int     i;

    int     Pr,Indx = PitchMin;
    float   MaxE = (float)1.0;
    float   MaxC = (float)0.0;
    float   E,C,C2,Diff;

    Pr = Start - PitchMin + 1;

    /* Init the energy estimate */

    E = DotProd(&Dpnt[Pr],&Dpnt[Pr],2*SubFrLen);

    /* Main Open loop pitch search loop */

    for (i=PitchMin; i <= PitchMax-3; i++)
    {
        Pr--;

        /* Update energy, compute cross */

        E = E - Dpnt[Pr+2*SubFrLen]*Dpnt[Pr+2*SubFrLen] + Dpnt[Pr]*Dpnt[Pr];
        C = DotProd(&Dpnt[Start],&Dpnt[Pr],2*SubFrLen);
        C2 = C*C;

        /* Check for new maximum */

        Diff = C2*MaxE - E*MaxC;
        if (E > (float)0.0 && C > (float)0.0)
        {
            if ((Diff > (float)0.0 && ((i - Indx) < PitchMin))
                 || (Diff > (float)0.25*C2*MaxE))
            {
                Indx = i;
                MaxE = E;
                MaxC = C2;
            }
        }
    }
    return Indx;
}
//---------------------------------------------------------------------------

PWDEF CCODEC::Comp_Pw(float *Dpnt, int Start, int Olp)
{

    int     i, k;
    float   Energy,C,E,C2,MaxE,MaxC2,MaxC,Gopt;
    PWDEF   Pw;

    /* Compute target energy */

    Energy = DotProd(&Dpnt[Start],&Dpnt[Start],SubFrLen);

    /* Find position with maximum C2/E value */

    MaxE = (float)1.0;
    MaxC = (float)0.0;
    MaxC2 = (float)0.0;
    Pw.Indx = -1;
    Pw.Gain = (float)0.0;
    k = Start - (Olp-PwRange);

    for (i=0; i <= 2*PwRange; i++)
    {
        C = DotProd(&Dpnt[Start],&Dpnt[k],SubFrLen);
        E = DotProd(&Dpnt[k],&Dpnt[k],SubFrLen);
        k--;

        if (E > (float)0.0 && C > (float)0.0)
        {
            C2 = C*C;
            if (C2*MaxE > E*MaxC2)
            {
                Pw.Indx = i;
                MaxE = E;
                MaxC = C;
                MaxC2 = C2;
            }
        }
    }

    if ( Pw.Indx == -1 )
    {
        Pw.Indx = Olp ;
        return Pw ;
    }

    Pw.Gain = (float)0.0;
    if (MaxC2 > MaxE*Energy*(float)0.375)
    {
        if (MaxC > MaxE || MaxE == (float)0.0)
            Gopt = (float)1.0;
        else
            Gopt = MaxC/MaxE;

        Pw.Gain = (float)0.3125*Gopt;
    }
    Pw.Indx = Olp - PwRange + Pw.Indx;
    return Pw;
}
//---------------------------------------------------------------------------

void  CCODEC::Filt_Pw(float *DataBuff, float *Dpnt, int Start, PWDEF Pw)
{
    int i;

    /* Perform the harmonic weighting */

    for (i=0; i < SubFrLen; i++)
        DataBuff[Start+i] = Dpnt[PitchMax+Start+i] -
                            Pw.Gain*Dpnt[PitchMax+Start-Pw.Indx+i];
    return;
}

//---------------------------------------------------------------------------

void  CCODEC::Find_Fcbk(float *Dpnt, float *ImpResp, LINEDEF *Line, int Sfc)
{
    int      i;
    int      Srate, T0_acelp;
    float    gain_T0;

    BESTDEF  Best;

    switch(WrkRate)
    {
    case 0:
        Srate = Nb_puls[Sfc];
        Best.MaxErr = (float)(-99999999.9);

        Find_Best(&Best, Dpnt, ImpResp, Srate, SubFrLen);

        if ((*Line).Olp[Sfc>>1] < SubFrLen-2)
            Find_Best(&Best, Dpnt, ImpResp, Srate, (*Line).Olp[Sfc>>1]);

        /* Reconstruct the excitation */

        for (i=0; i <  SubFrLen; i++)
            Dpnt[i] = (float)0.0;

        for (i=0; i < Srate; i++)
            Dpnt[Best.Ploc[i]] = Best.Pamp[i];

        /* Code the excitation */

        Fcbk_Pack(Dpnt, &((*Line).Sfs[Sfc]), &Best, Srate);

        if (Best.UseTrn == 1)
            Gen_Trn(Dpnt, Dpnt, (*Line).Olp[Sfc>>1]);
        break;

    case 1:
        T0_acelp = search_T0 ( (Word16) ((*Line).Olp[Sfc>>1]-1+(*Line).Sfs[Sfc].AcLg),
                            (*Line).Sfs[Sfc].AcGn, &gain_T0);

        (*Line).Sfs[Sfc].Ppos = ACELP_LBC_code(Dpnt, ImpResp, T0_acelp, Dpnt,
                                   &(*Line).Sfs[Sfc].Mamp,
                                   &(*Line).Sfs[Sfc].Grid,
                                   &(*Line).Sfs[Sfc].Pamp, gain_T0);

        (*Line).Sfs[Sfc].Tran = 0;
        break;
    }

    return;
}
//---------------------------------------------------------------------------

void  CCODEC::Gen_Trn(float *Dst, float *Src, int Olp)
{
    int    i;
    int    Tmp0;
    float  Tmp[SubFrLen];

    Tmp0 = Olp;

    for (i=0; i < SubFrLen; i++) {
        Tmp[i] = Src[i];
        Dst[i] = Src[i];
    }

    while (Tmp0 < SubFrLen) {
        for (i=Tmp0; i < SubFrLen; i++)
            Dst[i] += Tmp[i-Tmp0];

        Tmp0 += Olp;
    }
    return;
}

//---------------------------------------------------------------------------

void  CCODEC::Find_Best(BESTDEF *Best, float *Tv, float *ImpResp,int Np,int Olp)
{

    int     i,j,k,l;
    BESTDEF  Temp;

    int     MaxAmpId;
    float   MaxAmp;
    float   Acc0,Acc1,Acc2;

    float   Imr[SubFrLen];
    float   OccPos[SubFrLen];
    float   ImrCorr[SubFrLen];
    float   ErrBlk[SubFrLen];
    float   WrkBlk[SubFrLen];


    /* Update Impulse responce */

    if (Olp < (SubFrLen-2)) {
        Temp.UseTrn = 1;
        Gen_Trn(Imr, ImpResp, Olp);
    }
    else {
        Temp.UseTrn = 0;
        for (i = 0; i < SubFrLen; i++)
            Imr[i] = ImpResp[i];
    }

    /* Copy Imr */

    for (i=0; i < SubFrLen; i++)
        OccPos[i] = Imr[i];

    /* Compute Imr AutoCorr function */

    for (i=0;i<SubFrLen;i++)
        ImrCorr[i] = DotProd(&Imr[i],Imr,SubFrLen-i);

    /* Cross correlation with the signal */

    for (i=0;i<SubFrLen;i++)
        ErrBlk[i] = DotProd(&Tv[i],Imr,SubFrLen-i);

    /* Search for the best sequence */

    for (k=0; k < Sgrid; k++)
    {
        Temp.GridId = k;

        /*Find maximum amplitude */

        Acc1 = (float)0.0;
        for (i=k; i < SubFrLen; i +=Sgrid)
        {
            Acc0 = (float) fabs(ErrBlk[i]);
            if (Acc0 >= Acc1)
            {
                Acc1 = Acc0;
                Temp.Ploc[0] = i;
            }
        }

        /* Quantize the maximum amplitude */
        Acc2 = Acc1;
        Acc1 = (float)32767.0;
        MaxAmpId = (NumOfGainLev - MlqSteps);

        for (i=MaxAmpId; i >= MlqSteps; i--)
        {
            Acc0 = (float) fabs(FcbkGainTable[i]*ImrCorr[0] - Acc2);
            if (Acc0 < Acc1)
            {
                Acc1 = Acc0;
                MaxAmpId = i;
            }
        }
        MaxAmpId --;

        for (i=1; i <=2*MlqSteps; i++)
        {
            for (j=k; j < SubFrLen; j +=Sgrid)
            {
                WrkBlk[j] = ErrBlk[j];
                OccPos[j] = (float)0.0;
            }
            Temp.MampId = MaxAmpId - MlqSteps + i;

            MaxAmp = FcbkGainTable[Temp.MampId];

            if (WrkBlk[Temp.Ploc[0]] >= (float)0.0)
                Temp.Pamp[0] = MaxAmp;
            else
                Temp.Pamp[0] = -MaxAmp;

            OccPos[Temp.Ploc[0]] = (float)1.0;

            for (j=1; j < Np; j++)
            {
                Acc1 = (float)-32768.0;

                for (l=k; l < SubFrLen; l +=Sgrid)
                {
                    if (OccPos[l] != (float)0.0)
                        continue;

                    Acc0 = WrkBlk[l] - Temp.Pamp[j-1]*
                                        ImrCorr[abs(l-Temp.Ploc[j-1])];
                    WrkBlk[l] = Acc0;

                    Acc0 = (float) fabs(Acc0);
                    if (Acc0 > Acc1)
                    {
                        Acc1 = Acc0;
                        Temp.Ploc[j] = l;
                    }
                }

                if (WrkBlk[Temp.Ploc[j]] >= (float)0.0)
                    Temp.Pamp[j] = MaxAmp;
                else
                    Temp.Pamp[j] = -MaxAmp;

                OccPos[Temp.Ploc[j]] = (float)1.0;
            }

            /* Compute error vector */

            for (j=0; j < SubFrLen; j++)
                OccPos[j] = (float)0.0;

            for (j=0; j < Np; j++)
                OccPos[Temp.Ploc[j]] = Temp.Pamp[j];

            for (l=SubFrLen-1; l >= 0; l--)
            {
                Acc0 = (float)0.0;
                for (j=0; j <= l; j++)
                    Acc0 += OccPos[j]*Imr[l-j];
                OccPos[l] = Acc0;
            }

            /* Evaluate error */

            Acc2 = ((float)2.0)*DotProd(Tv,OccPos,SubFrLen)
                   - DotProd(OccPos,OccPos,SubFrLen);

            if (Acc2 > (*Best).MaxErr)
            {
                (*Best).MaxErr = Acc2;
                (*Best).GridId = Temp.GridId;
                (*Best).MampId = Temp.MampId;
                (*Best).UseTrn = Temp.UseTrn;
                for (j = 0; j < Np; j++)
                {
                    (*Best).Pamp[j] = Temp.Pamp[j];
                    (*Best).Ploc[j] = Temp.Ploc[j];
                }
            }
        }
    }
    return;
}

//---------------------------------------------------------------------------

void  CCODEC::Fcbk_Pack(float *Dpnt, SFSDEF *Sfs, BESTDEF *Best, int Np)
{
    int i,j;

    /* Code the amplitudes and positions */

    j = MaxPulseNum - Np;

    (*Sfs).Pamp = 0;
    (*Sfs).Ppos = 0;

    for (i=0; i < SubFrLen/Sgrid; i++)
    {
        if (Dpnt[(*Best).GridId + Sgrid*i] == 0)
            (*Sfs).Ppos = (*Sfs).Ppos + CombinatorialTable[j][i];
        else
        {
            (*Sfs).Pamp = (*Sfs).Pamp << 1;
            if (Dpnt[(*Best).GridId + Sgrid*i] < 0)
                (*Sfs).Pamp++;
            j++;

            /* Check for end  */

            if (j == MaxPulseNum)
                break;
        }
    }

    (*Sfs).Mamp = (*Best).MampId;
    (*Sfs).Grid = (*Best).GridId;
    (*Sfs).Tran = (*Best).UseTrn;
    return;
}
//---------------------------------------------------------------------------

void  CCODEC::Fcbk_Unpk(float *Tv, SFSDEF Sfs, int Olp, int Sfc)
{
    int    i,j,Np;
    float  Tv_tmp[SubFrLen+4];
    float  acelp_gain,gain_T0;
    int    acelp_sign, acelp_shift, acelp_pos;
    int    offset, ipos, T0_acelp;
    Word32 Acc0;

    switch(WrkRate)
    {
        case 0:
        {
            Np = Nb_puls[Sfc];

            for (i=0; i < SubFrLen; i++)
                Tv[i] = (float)0.0;

            if (Sfs.Ppos >= MaxPosTable[Sfc])
                return;

            /*  Decode the amplitudes and positions */

            j = MaxPulseNum - Np;
            Acc0 = Sfs.Ppos;

            for (i = 0; i < SubFrLen/Sgrid; i++)
            {
                Acc0 -= CombinatorialTable[j][i];

                if (Acc0 < (Word32) 0)
                {
                    Acc0 += CombinatorialTable[j][i];
                    j++;

                    if ((Sfs.Pamp & (1 << (MaxPulseNum-j))) != 0)
                        Tv[Sfs.Grid + Sgrid*i] = -FcbkGainTable[Sfs.Mamp];
                    else
                        Tv[Sfs.Grid + Sgrid*i] =  FcbkGainTable[Sfs.Mamp];

                    if (j == MaxPulseNum)
                        break;
                }
            }

            if (Sfs.Tran == 1)
                Gen_Trn(Tv, Tv, Olp);
            break;
        }

        case 1:
        {
            for (i = 0; i < SubFrLen+4; i++)
                Tv_tmp[i] = (float)0.0;

            acelp_gain = FcbkGainTable[Sfs.Mamp];
            acelp_shift = Sfs.Grid;
            acelp_sign = Sfs.Pamp;
            acelp_pos = (int)Sfs.Ppos;

            offset  = 0;
            for (i=0; i<4; i++)
            {
                ipos = (acelp_pos & 7);
                ipos = (ipos << 3) + acelp_shift + offset;

                if ((acelp_sign & 1)== 1)
                    Tv_tmp[ipos] = acelp_gain;
                else
                    Tv_tmp[ipos] = -acelp_gain;

                offset += 2;
                acelp_pos = acelp_pos >> 3;
                acelp_sign = acelp_sign >> 1;
            }
            for (i = 0; i < SubFrLen; i++)
                Tv[i] = Tv_tmp[i];

            T0_acelp = search_T0( (Olp-1+Sfs.AcLg), Sfs.AcGn, &gain_T0);
            if (T0_acelp < SubFrLen-2)
            {
                for (i = T0_acelp; i < SubFrLen; i++)
                    Tv[i] += Tv[i-T0_acelp]*gain_T0;
            }
            break;
        }
    }
    return;
}
//---------------------------------------------------------------------------

int CCODEC::ACELP_LBC_code(float X[], float h[], int T0, float code[],
    int *ind_gain, int *shift, int *sign, float gain_T0)
{
    int i, index;
    float gain_q;
    float Dn[SubFrLen2], tmp_code[SubFrLen2];
    float rr[DIM_RR];

    /*  Include fixed-gain pitch contribution into impulse resp. h[] */

    if (T0 < SubFrLen-2)
        for (i = T0; i < SubFrLen; i++)
            h[i] += gain_T0*h[i-T0];

    /*  Compute correlations of h[] needed for the codebook search */

    Cor_h(h, rr);

    /*  Compute correlation of target vector with impulse response. */

    Cor_h_X(h, X, Dn);

    /*  Find codebook index */

    index = D4i64_LBC(Dn, rr, h, tmp_code, rr, shift, sign);

    /*  Compute innovation vector gain. */
    /*  Include fixed-gain pitch contribution into code[]. */

    *ind_gain = G_code(X, rr, &gain_q);

    for (i=0; i < SubFrLen; i++)
        code[i] = tmp_code[i]*gain_q;

    if (T0 < SubFrLen-2)
        for (i=T0; i < SubFrLen; i++)
            code[i] += code[i-T0]*gain_T0;

    return index;
}

//---------------------------------------------------------------------------

void CCODEC::Cor_h(float *H, float *rr)
{

    /*   Compute  correlations of h[]  needed for the codebook search. */
    /*     h[]              :Impulse response. */
    /*     rr[]             :Correlations. */

    float *rri0i0, *rri1i1, *rri2i2, *rri3i3;
    float *rri0i1, *rri0i2, *rri0i3;
    float *rri1i2, *rri1i3, *rri2i3;

    float *p0, *p1, *p2, *p3;
    float cor, *h2;
    int   i, k, m, t;
    float h[SubFrLen2];

    for (i=0; i<SubFrLen; i++)
        h[i+4] = H[i];

    for (i=0; i<4; i++)
        h[i] = (float)0.0;

    /*  Init pointers */

    rri0i0 = rr;
    rri1i1 = rri0i0 + NB_POS;
    rri2i2 = rri1i1 + NB_POS;
    rri3i3 = rri2i2 + NB_POS;

    rri0i1 = rri3i3 + NB_POS;
    rri0i2 = rri0i1 + MSIZE;
    rri0i3 = rri0i2 + MSIZE;
    rri1i2 = rri0i3 + MSIZE;
    rri1i3 = rri1i2 + MSIZE;
    rri2i3 = rri1i3 + MSIZE;

    /*  Compute rri0i0[], rri1i1[], rri2i2[] and rri3i3[] */

    cor = (float)0.0;
    m = 0;
    for (i=NB_POS-1; i>=0; i--)
    {
        cor += h[m+0]*h[m+0] + h[m+1]*h[m+1];   rri3i3[i] = cor;
        cor += h[m+2]*h[m+2] + h[m+3]*h[m+3];   rri2i2[i] = cor;
        cor += h[m+4]*h[m+4] + h[m+5]*h[m+5];   rri1i1[i] = cor;
        cor += h[m+6]*h[m+6] + h[m+7]*h[m+7];   rri0i0[i] = cor;

        m += 8;
    }

    /*  Compute elements of: rri0i1[], rri0i3[], rri1i2[] and rri2i3[] */

    h2 = h+2;
    p3 = rri2i3 + MSIZE-1;
    p2 = rri1i2 + MSIZE-1;
    p1 = rri0i1 + MSIZE-1;
    p0 = rri0i3 + MSIZE-2;

    for (k=0; k<NB_POS; k++)
    {
        cor = (float)0.0;
        m = 0;
        t = 0;

        for (i=k+1; i<NB_POS; i++)
        {
            cor += h[m+0]*h2[m+0] + h[m+1]*h2[m+1];   p3[t] = cor;
            cor += h[m+2]*h2[m+2] + h[m+3]*h2[m+3];   p2[t] = cor;
            cor += h[m+4]*h2[m+4] + h[m+5]*h2[m+5];   p1[t] = cor;
            cor += h[m+6]*h2[m+6] + h[m+7]*h2[m+7];   p0[t] = cor;

            t -= (NB_POS+1);
            m += 8;
        }
        cor += h[m+0]*h2[m+0] + h[m+1]*h2[m+1];   p3[t] = cor;
        cor += h[m+2]*h2[m+2] + h[m+3]*h2[m+3];   p2[t] = cor;
        cor += h[m+4]*h2[m+4] + h[m+5]*h2[m+5];   p1[t] = cor;

        h2 += STEP;
        p3 -= NB_POS;
        p2 -= NB_POS;
        p1 -= NB_POS;
        p0 -= 1;
    }


    /*  Compute elements of: rri0i2[], rri1i3[]  */

    h2 = h+4;
    p3 = rri1i3 + MSIZE-1;
    p2 = rri0i2 + MSIZE-1;
    p1 = rri1i3 + MSIZE-2;
    p0 = rri0i2 + MSIZE-2;

    for (k=0; k<NB_POS; k++)
    {
        cor = (float)0.0;
        m = 0;
        t = 0;

        for (i=k+1; i<NB_POS; i++)
        {
            cor += h[m+0]*h2[m+0] + h[m+1]*h2[m+1];   p3[t] = cor;
            cor += h[m+2]*h2[m+2] + h[m+3]*h2[m+3];   p2[t] = cor;
            cor += h[m+4]*h2[m+4] + h[m+5]*h2[m+5];   p1[t] = cor;
            cor += h[m+6]*h2[m+6] + h[m+7]*h2[m+7];   p0[t] = cor;

            t -= (NB_POS+1);
            m += 8;
        }
        cor += h[m+0]*h2[m+0] + h[m+1]*h2[m+1];   p3[t] = cor;
        cor += h[m+2]*h2[m+2] + h[m+3]*h2[m+3];   p2[t] = cor;

        h2 += STEP;
        p3 -= NB_POS;
        p2 -= NB_POS;
        p1 -= 1;
        p0 -= 1;
    }

    /*  Compute elements of: rri0i1[], rri0i3[], rri1i2[] and rri2i3[] */

    h2 = h+6;
    p3 = rri0i3 + MSIZE-1;
    p2 = rri2i3 + MSIZE-2;
    p1 = rri1i2 + MSIZE-2;
    p0 = rri0i1 + MSIZE-2;

    for (k=0; k<NB_POS; k++)
    {
        cor = (float)0.0;
        m = 0;
        t = 0;

        for (i=k+1; i<NB_POS; i++)
        {
            cor += h[m+0]*h2[m+0] + h[m+1]*h2[m+1];   p3[t] = cor;
            cor += h[m+2]*h2[m+2] + h[m+3]*h2[m+3];   p2[t] = cor;
            cor += h[m+4]*h2[m+4] + h[m+5]*h2[m+5];   p1[t] = cor;
            cor += h[m+6]*h2[m+6] + h[m+7]*h2[m+7];   p0[t] = cor;

            t -= (NB_POS+1);
            m += 8;
        }
        cor += h[m+0]*h2[m+0] + h[m+1]*h2[m+1];   p3[t] = cor;

        h2 += STEP;
        p3 -= NB_POS;
        p2 -= 1;
        p1 -= 1;
        p0 -= 1;
    }

    return;
}

//---------------------------------------------------------------------------

void CCODEC::Cor_h_X(float h[],float X[],float D[])
{
    int i;

    for (i=0; i < SubFrLen; i++)
        D[i] = DotProd(&X[i],h,(SubFrLen-i));

    return;
}
//---------------------------------------------------------------------------

void CCODEC::reset_max_time(void)
{
    extra = 120;
    return;
}
//---------------------------------------------------------------------------

int CCODEC::D4i64_LBC(float Dn[], float rr[], float h[], float cod[],
        float y[], int *code_shift, int *sign)
{
    int  i0, i1, i2, i3, ip0, ip1, ip2, ip3;
    int  i, j, time;
    int  shif, shift;

    float  ps0, ps1, ps2, ps3;
    float  alp0, alp1, alp2, alp3;
    float  ps0a, ps1a, ps2a;
    float  ps3c, psc, alpha;
    float  means, max0, max1, max2, thres;

    float *rri0i0,*rri1i1,*rri2i2,*rri3i3;
    float *rri0i1,*rri0i2,*rri0i3;
    float *rri1i2,*rri1i3,*rri2i3;

    float *ptr_ri0i0,*ptr_ri1i1,*ptr_ri2i2,*ptr_ri3i3;
    float *ptr_ri0i1,*ptr_ri0i2,*ptr_ri0i3;
    float *ptr_ri1i2,*ptr_ri1i3,*ptr_ri2i3;

    int  p_sign[SubFrLen2/2],p_sign2[SubFrLen2/2];

    /*  Init pointers  */

    rri0i0 = rr;
    rri1i1 = rri0i0 + NB_POS;
    rri2i2 = rri1i1 + NB_POS;
    rri3i3 = rri2i2 + NB_POS;

    rri0i1 = rri3i3 + NB_POS;
    rri0i2 = rri0i1 + MSIZE;
    rri0i3 = rri0i2 + MSIZE;
    rri1i2 = rri0i3 + MSIZE;
    rri1i3 = rri1i2 + MSIZE;
    rri2i3 = rri1i3 + MSIZE;

    /*  Extend the backward filtered target vector by zeros                 */

    for (i=SubFrLen; i < SubFrLen2; i++)
        Dn[i] = (float)0.0;

    /*  Chose the sign of the impulse.                                      */

    for (i=0; i<SubFrLen; i+=2)
    {
        if ((Dn[i] + Dn[i+1]) >= (float)0.0)
        {
            p_sign[i/2] = 1;
            p_sign2[i/2] = 2;
        }
        else
        {
            p_sign[i/2] = -1;
            p_sign2[i/2] = -2;
            Dn[i] = -Dn[i];
            Dn[i+1] = -Dn[i+1];
        }
    }
    p_sign[30] = p_sign[31] = 1;
    p_sign2[30] = p_sign2[31] = 2;

    /*  - Compute the search threshold after three pulses                  */
    /*  odd positions  */
    /*  Find maximum of Dn[i0]+Dn[i1]+Dn[i2] */

    max0 = Dn[0];
    max1 = Dn[2];
    max2 = Dn[4];
    for (i=8; i < SubFrLen; i+=STEP)
    {
        if (Dn[i] > max0)
            max0 = Dn[i];
        if (Dn[i+2] > max1)
            max1 = Dn[i+2];
        if (Dn[i+4] > max2)
            max2 = Dn[i+4];
    }
    max0 = max0 + max1 + max2;

    /*  Find means of Dn[i0]+Dn[i1]+Dn[i] */

    means = (float)0.0;
    for (i=0; i < SubFrLen; i+=STEP)
        means += Dn[i+4] + Dn[i+2] + Dn[i];

    means *= (float)0.125;
    thres = means + (max0-means)*(float)0.5;


    /*  even positions */
    /*  Find maximum of Dn[i0]+Dn[i1]+Dn[i2] */

    max0 = Dn[1];
    max1 = Dn[3];
    max2 = Dn[5];
    for (i=9; i < SubFrLen; i+=STEP)
    {
        if (Dn[i] > max0)
            max0 = Dn[i];
        if (Dn[i+2] > max1)
            max1 = Dn[i+2];
        if (Dn[i+4] > max2)
            max2 = Dn[i+4];
    }
    max0 = max0 + max1 + max2;

    /*  Find means of Dn[i0]+Dn[i1]+Dn[i2]  */

    means = (float)0.0;
    for (i=1; i < SubFrLen; i+=STEP)
        means += Dn[i+4] + Dn[i+2] + Dn[i];

    means *= (float)0.125;
    max1 = means + (max0-means)*(float)0.5;

    /*  Keep maximum threshold between odd and even position  */

    if (max1 > thres)
        thres = max1;

    /*  Modification of rrixiy[] to take signs into account. */

    ptr_ri0i1 = rri0i1;
    ptr_ri0i2 = rri0i2;
    ptr_ri0i3 = rri0i3;

    for (i0=0; i0<SubFrLen/2; i0+=STEP/2)
    {
        for (i1=2/2; i1<SubFrLen/2; i1+=STEP/2)
        {
            *ptr_ri0i1++ *= p_sign[i0] * p_sign2[i1];
            *ptr_ri0i2++ *= p_sign[i0] * p_sign2[i1+1];
            *ptr_ri0i3++ *= p_sign[i0] * p_sign2[i1+2];
        }
    }

    ptr_ri1i2 = rri1i2;
    ptr_ri1i3 = rri1i3;
    for (i1=2/2; i1<SubFrLen/2; i1+=STEP/2)
    {
        for (i2=4/2; i2<SubFrLen2/2; i2+=STEP/2)
        {
            *ptr_ri1i2++ *= p_sign[i1] * p_sign2[i2];
            *ptr_ri1i3++ *= p_sign[i1] * p_sign2[i2+1];
        }
    }

    ptr_ri2i3 = rri2i3;
    for (i2=4/2; i2<SubFrLen2/2; i2+=STEP/2)
    {
        for (i3=6/2; i3<SubFrLen2/2; i3+=STEP/2)
            *ptr_ri2i3++ *= p_sign[i2] * p_sign2[i3];
    }

    /*  Default values  */

    ip0    = 0;
    ip1    = 2;
    ip2    = 4;
    ip3    = 6;
    shif   = 0;
    psc    = (float)0.0;
    alpha  = (float)1.0;
    time   = max_time + extra;

    /*  Four loops to search innovation code. */
    /*  Init. pointers that depend on first loop  */

    ptr_ri0i0 = rri0i0;
    ptr_ri0i1 = rri0i1;
    ptr_ri0i2 = rri0i2;
    ptr_ri0i3 = rri0i3;

    /*  first pulse loop   */

    for (i0=0; i0 < SubFrLen; i0 +=STEP)
    {
        ps0  = Dn[i0];
        ps0a = Dn[i0+1];
        alp0 = *ptr_ri0i0++;

        /*  Init. pointers that depend on second loop */

        ptr_ri1i1 = rri1i1;
        ptr_ri1i2 = rri1i2;
        ptr_ri1i3 = rri1i3;

        /*  second pulse loop */

        for (i1=2; i1 < SubFrLen; i1 +=STEP)
        {
            ps1  = ps0 + Dn[i1];
            ps1a = ps0a + Dn[i1+1];

            alp1 = alp0 + *ptr_ri1i1++ + *ptr_ri0i1++;

            /*  Init. pointers that depend on third loop */

            ptr_ri2i2 = rri2i2;
            ptr_ri2i3 = rri2i3;

            /*  third pulse loop */

            for (i2 = 4; i2 < SubFrLen2; i2 +=STEP)
            {
                ps2  = ps1 + Dn[i2];
                ps2a = ps1a + Dn[i2+1];

                alp2 = alp1 + *ptr_ri2i2++ + *ptr_ri0i2++ + *ptr_ri1i2++;

                /*  Decide the shift */

                shift = 0;
                if (ps2a > ps2)
                {
                    shift = 1;
                    ps2   = ps2a;
                }

                /*  Test threshold  */

                if (ps2 > thres)
                {

                    /*  Init. pointers that depend on 4th loop */

                    ptr_ri3i3 = rri3i3;

                    /*  4th pulse loop */

                    for (i3 = 6; i3 < SubFrLen2; i3 +=STEP)
                    {
                        ps3 = ps2 + Dn[i3+shift];
                        alp3 = alp2 + *ptr_ri3i3++ +
                        *ptr_ri0i3++ + *ptr_ri1i3++ + *ptr_ri2i3++;

                        ps3c = ps3 * ps3;
                        if ((ps3c * alpha) > (psc * alp3))
                        {
                            psc = ps3c;
                            alpha = alp3;
                            ip0 = i0;
                            ip1 = i1;
                            ip2 = i2;
                            ip3 = i3;
                            shif = shift;
                        }
                    }

                    time--;

                    /*  Maximum time finish  */

                    if (time <= 0)
                        goto end_search;
                    ptr_ri0i3 -= NB_POS;
                    ptr_ri1i3 -= NB_POS;
                }

                else
                    ptr_ri2i3 += NB_POS;
            }

            ptr_ri0i2 -= NB_POS;
            ptr_ri1i3 += NB_POS;
        }

        ptr_ri0i2 += NB_POS;
        ptr_ri0i3 += NB_POS;
    }

end_search:

    extra = time;

    /*  Set the sign of impulses  */

    i0 = p_sign[(ip0 >> 1)];
    i1 = p_sign[(ip1 >> 1)];
    i2 = p_sign[(ip2 >> 1)];
    i3 = p_sign[(ip3 >> 1)];

    /*  Find the codeword corresponding to the selected positions  */

    for (i=0; i<SubFrLen; i++)
        cod[i] = (float)0.0;

    if (shif > 0)
    {
        ip0++;
        ip1++;
        ip2++;
        ip3++;
    }

    cod[ip0] =  (float)i0;
    cod[ip1] =  (float)i1;
    if (ip2<SubFrLen)
        cod[ip2] = (float)i2;
    if (ip3<SubFrLen)
        cod[ip3] = (float)i3;

/*  find the filtered codeword  */

    for (i=0; i < SubFrLen; i++)
        y[i] = (float)0.0;

    if (i0 > 0)
        for (i=ip0, j=0; i<SubFrLen; i++, j++)
            y[i] = y[i] + h[j];
    else
        for (i=ip0, j=0; i<SubFrLen; i++, j++)
            y[i] = y[i] - h[j];

    if (i1 > 0)
        for (i=ip1, j=0; i<SubFrLen; i++, j++)
            y[i] = y[i] + h[j];
    else
        for (i=ip1, j=0; i<SubFrLen; i++, j++)
            y[i] = y[i] - h[j];

    if (ip2<SubFrLen)
    {
        if (i2 > 0)
            for (i=ip2, j=0; i<SubFrLen; i++, j++)
                y[i] = y[i] + h[j];
        else
            for (i=ip2, j=0; i<SubFrLen; i++, j++)
                y[i] = y[i] - h[j];
    }

    if (ip3<SubFrLen)
    {
        if (i3 > 0)
            for (i=ip3, j=0; i<SubFrLen; i++, j++)
                y[i] = y[i] + h[j];
        else
            for (i=ip3, j=0; i<SubFrLen; i++, j++)
                y[i] = y[i] - h[j];
    }

    *code_shift = shif;

    *sign = 0;
    if (i0 > 0)
        *sign += 1;
    if (i1 > 0)
        *sign += 2;
    if (i2 > 0)
        *sign += 4;
    if (i3 > 0)
        *sign += 8;

    i = ((ip3 >> 3) << 9) + ((ip2 >> 3) << 6) + ((ip1 >> 3) << 3) + (ip0 >> 3);

    return i;
}

//---------------------------------------------------------------------------

int CCODEC::G_code(float X[], float Y[], float *gain_q)
{
    int     i;
    float   xy, yy, gain_nq;
    int     gain;
    float   dist, dist_min;

    /*  Compute scalar product <X[],Y[]> */

    xy = DotProd(X,Y,SubFrLen);

    if (xy <= 0)
    {
        gain = 0;
        *gain_q =FcbkGainTable[gain];
        return(gain);
    }

    /*  Compute scalar product <Y[],Y[]>  */

    yy = DotProd(Y,Y,SubFrLen);

    if (yy > (float) FLT_MIN)
        gain_nq = xy/yy;
    else
        gain_nq = (float)0.0;

    gain = 0;
    dist_min = (float)fabs(gain_nq - FcbkGainTable[0]);

    for (i=1; i <NumOfGainLev; i++)
    {
        dist = (float)fabs(gain_nq - FcbkGainTable[i]);
        if (dist < dist_min)
        {
            dist_min = dist;
            gain = i;
        }
    }
    *gain_q = FcbkGainTable[gain];
    return(gain);
}

//---------------------------------------------------------------------------

int CCODEC::search_T0 (int T0, int Gid, float *gain_T0)
{
    int T0_mod;

    T0_mod = T0+epsi170[Gid];
    *gain_T0 = gain170[Gid];

    return(T0_mod);
}

//---------------------------------------------------------------------------

void CCODEC::Update_Err(int Olp, int AcLg, int AcGn)
{
    int     i,iz, temp2;
    int     Lag;
    float   Worst1, Worst0, wtemp;
    float   beta,*ptr_tab;

    Lag = Olp - Pstep + AcLg;

    /* Select Quantization tables */
    i = 0 ;
    ptr_tab = tabgain85;
    if ( WrkRate == Rate63 ) {
        if ( Olp >= (SubFrLen-2) )
            ptr_tab = tabgain170;
    }
    else {
        ptr_tab = tabgain170;
    }
    beta = ptr_tab[(int)AcGn];


    if (Lag <= (SubFrLen/2))
    {
        Worst0 = CodStat.Err[0]*beta + Err0;
        Worst1 = Worst0;
    }
    else
    {
        iz = (int)(((Word32)Lag*1092L) >> 15);
        temp2 = 30*(iz+1);

        if (temp2 != Lag)
        {
            if (iz == 1)
            {
                Worst0 = CodStat.Err[0]*beta + Err0;
                Worst1 = CodStat.Err[1]*beta + Err0;

                if (Worst0 > Worst1)
                    Worst1 = Worst0;
                else
                    Worst0 = Worst1;
            }
            else
            {
                wtemp = CodStat.Err[iz-1]*beta + Err0;
                Worst0 = CodStat.Err[iz-2]*beta + Err0;
                if (wtemp > Worst0)
                    Worst0 = wtemp;
                Worst1 = CodStat.Err[iz]*beta + Err0;
                if (wtemp > Worst1)
                    Worst1 = wtemp;
            }
        }
        else
        {
            Worst0 = CodStat.Err[iz-1]*beta + Err0;
            Worst1 = CodStat.Err[iz]*beta + Err0;
        }
    }

    if (Worst0 > MAXV)
        Worst0 = MAXV;
    if (Worst1 > MAXV)
        Worst1 = MAXV;

    for (i=4; i>=2; i--)
        CodStat.Err[i] = CodStat.Err[i-2];

    CodStat.Err[0] = Worst0;
    CodStat.Err[1] = Worst1;

    return;
}

//---------------------------------------------------------------------------

int CCODEC::Test_Err(int Lag1, int Lag2)
{
    int     i, i1, i2;
    int     zone1, zone2, iTest;
    float   Err_max;

    i2 = Lag2 + ClPitchOrd/2;
    zone2 = i2/30;

    i1 = - SubFrLen + 1 + Lag1 - ClPitchOrd/2;
    if (i1 <= 0)
        i1 = 1;
    zone1 = i1/30;

    Err_max = (float)-1.0;
    for (i=zone2; i>=zone1; i--)
    {
        if (CodStat.Err[i] > Err_max)
            Err_max = CodStat.Err[i];
    }
    if ((Err_max > ThreshErr) || (CodStat.SinDet < 0 ) )
    {
        iTest = 0;
    }
    else
    {
        iTest = (Word16)(ThreshErr - Err_max);
    }

    return(iTest);
}

//---------------------------------------------------------------------------

void  CCODEC::Find_Acbk(float *Tv, float *ImpResp, float *PrevExc,
                LINEDEF *Line, int Sfc)
{
    int i,j,k,l;

    float Acc0,Max;

    float RezBuf[SubFrLen+ClPitchOrd-1];
    float FltBuf[ClPitchOrd][SubFrLen];
    float CorVct[4*(2*ClPitchOrd + ClPitchOrd*(ClPitchOrd-1)/2)];
    float *lPnt;
    float *sPnt;

    int   Olp,Lid,Gid,Hb;
    int   Bound[2];
    int   Lag1, Lag2;
    int   off_filt;

    Olp = (*Line).Olp[Sfc>>1];
    Lid = Pstep;
    Gid = 0;
    Hb  = 3 + (Sfc & 1);

    /*  For even frames only */

    if ((Sfc & 1) == 0)
    {
        if (Olp == PitchMin)
            Olp++;
        if (Olp > (PitchMax-5))
            Olp = PitchMax-5;
    }

    lPnt = CorVct;
    for (k=0; k < Hb; k++)
    {

        /*  Get residual from the exitation buffer */

        Get_Rez(RezBuf, PrevExc, Olp-Pstep+k);

        /*  Filter the last one (ClPitchOrd-1) using the impulse responce */

        for (i=0; i < SubFrLen; i++)
        {
            Acc0 = (float)0.0;
            for (j=0; j <= i; j++)
                Acc0 += RezBuf[ClPitchOrd-1+j]*ImpResp[i-j];

            FltBuf[ClPitchOrd-1][i] = Acc0;
        }

        /*  Update the others (ClPitchOrd-2 down to 0) */

        for (i=ClPitchOrd-2; i >= 0; i --)
        {
            FltBuf[i][0] = RezBuf[i];
            for (j = 1; j < SubFrLen; j++)
                FltBuf[i][j] = RezBuf[i]*ImpResp[j] + FltBuf[i+1][j-1];
        }

        /*  Compute the cross products with the signal */

        for (i=0; i < ClPitchOrd; i++)
            *lPnt++ = DotProd(Tv, FltBuf[i], SubFrLen);

        /*  Compute the energies */

        for (i=0; i < ClPitchOrd; i++)
            *lPnt++ = ((float)0.5)*DotProd(FltBuf[i], FltBuf[i], SubFrLen);

        /*  Compute the between crosses */

        for (i=1; i < ClPitchOrd; i++)
            for (j = 0; j < i; j++)
                *lPnt++ = DotProd(FltBuf[i], FltBuf[j], SubFrLen);
    }

    /* Test potential error */
    Lag1 = Olp - Pstep;
    Lag2 = Olp - Pstep + Hb - 1;

    off_filt = Test_Err(Lag1, Lag2);

    Bound[0] =  NbFilt085_min + (off_filt << 2);
    if (Bound[0] > NbFilt085)
        Bound[0] = NbFilt085;
    Bound[1] =  NbFilt170_min + (off_filt << 3);
    if (Bound[1] > NbFilt170)
        Bound[1] = NbFilt170;

    Max = (float)0.0;
    for (k=0; k < Hb; k++)
    {

        /*  Select Quantization table */
        l = 0;
        if (WrkRate == Rate63)
        {
            if ((Sfc & 1) == 0)
            {
                if (Olp-Pstep+k >= SubFrLen-2)
                    l = 1;
            }
            else
            {
                if (Olp >= SubFrLen-2)
                    l = 1;
            }
        }
        else
            l = 1;

        /*  Search for maximum */

        sPnt = AcbkGainTablePtr[l];

        for (i=0; i < Bound[l]; i++)
        {
            Acc0 = DotProd(&CorVct[k*20],sPnt,20);
            sPnt += 20;

            if (Acc0 > Max)
            {
                Max = Acc0;
                Gid = i;
                Lid = k;
            }
        }
    }

    /*  Modify Olp for even sub frames */

    if ((Sfc & 1) == 0)
    {
        Olp = Olp - Pstep + Lid;
        Lid = Pstep;
    }


    /*  Save Lag, Gain and Olp */

    (*Line).Sfs[Sfc].AcLg = Lid;
    (*Line).Sfs[Sfc].AcGn = Gid;
    (*Line).Olp[Sfc>>1] = Olp;

    /*  Decode the Acbk contribution and subtract it */

    Decod_Acbk(RezBuf, PrevExc, Olp, Lid, Gid);

    for (i=0; i < SubFrLen; i++)
    {
        Acc0 = Tv[i];

        for (j=0; j <= i; j++)
            Acc0 -= RezBuf[j]*ImpResp[i-j];

        Tv[i] = Acc0;
    }
}

//---------------------------------------------------------------------------

void  CCODEC::Get_Rez(float *Tv, float *PrevExc, int Lag)
{
    int i;

    for (i=0; i < ClPitchOrd/2; i++)
        Tv[i] = PrevExc[PitchMax - Lag - ClPitchOrd/2 + i];

    for (i=0; i < SubFrLen+ClPitchOrd/2; i++)
        Tv[ClPitchOrd/2+i] = PrevExc[PitchMax - Lag + i%Lag];
}

//---------------------------------------------------------------------------

void  CCODEC::Decod_Acbk(float *Tv, float *PrevExc, int Olp, int Lid, int Gid)
{
    int      i;
    float    RezBuf[SubFrLen+ClPitchOrd-1];
    float   *sPnt;

    Get_Rez(RezBuf, PrevExc, (Olp + Lid) - Pstep);


    i = 0;
    if (WrkRate == Rate63)
    {
        if (Olp >= (SubFrLen-2))
            i++;
    }
    else
        i=1;

    sPnt = AcbkGainTablePtr[i] + Gid*20;

    /*  Compute output vector */

    for (i=0; i < SubFrLen; i++)
        Tv[i] = DotProd(&RezBuf[i], sPnt, ClPitchOrd);
}

//---------------------------------------------------------------------------

PFDEF CCODEC::Comp_Lpf(float *Buff, int Olp, int Sfc)
{
    PFDEF  Pf;
    float  Lcr[5];
    int    Bindx, Findx;
    float  Acc0,Acc1;

    /*  Initialize  */

    Pf.Indx = 0;
    Pf.Gain = (float)0.0;
    Pf.ScGn = (float)1.0;

    /*  Find both indices */

    Bindx = Find_B(Buff, Olp, Sfc);
    Findx = Find_F(Buff, Olp, Sfc);

    /*  Combine the results */

    if ((Bindx==0) && (Findx==0))
        return Pf;

    /*  Compute target energy  */

    Lcr[0] = DotProd(&Buff[PitchMax+Sfc*SubFrLen],
                    &Buff[PitchMax+Sfc*SubFrLen],SubFrLen);

    if (Bindx != 0)
    {
        Lcr[1] = DotProd(&Buff[PitchMax+Sfc*SubFrLen],
                        &Buff[PitchMax+Sfc*SubFrLen+Bindx],SubFrLen);
        Lcr[2] = DotProd(&Buff[PitchMax+Sfc*SubFrLen+Bindx],
                        &Buff[PitchMax+Sfc*SubFrLen+Bindx],SubFrLen);
    }

    if (Findx != 0)
    {
        Lcr[3] = DotProd(&Buff[PitchMax+Sfc*SubFrLen],
                        &Buff[PitchMax+Sfc*SubFrLen+Findx],SubFrLen);
        Lcr[4] = DotProd(&Buff[PitchMax+Sfc*SubFrLen+Findx],
                        &Buff[PitchMax+Sfc*SubFrLen+Findx],SubFrLen);
    }

    /*  Select the best pair  */

    if ((Bindx != 0) && (Findx == 0))
        Pf = Get_Ind(Bindx, Lcr[0], Lcr[1], Lcr[2]);

    if ((Bindx == 0) && (Findx != 0))
        Pf = Get_Ind(Findx, Lcr[0], Lcr[3], Lcr[4]);

    if ((Bindx != 0) && (Findx != 0))
    {
        Acc0 = Lcr[4] * Lcr[1] * Lcr[1];
        Acc1 = Lcr[2] * Lcr[3] * Lcr[3];
        if (Acc0 > Acc1)
            Pf = Get_Ind(Bindx, Lcr[0], Lcr[1], Lcr[2]);
        else
            Pf = Get_Ind(Findx, Lcr[0], Lcr[3], Lcr[4]);
    }

    return Pf;
}

//---------------------------------------------------------------------------

int  CCODEC::Find_B(float *Buff, int Olp, int Sfc)
{
    int  i;

    int  Indx = 0;

    float  Acc0,Acc1;

    if (Olp > (PitchMax-3))
        Olp = (PitchMax-3);

    Acc1 = (float)0.0;

    for (i=Olp-3; i<=Olp+3; i++)
    {
        Acc0 = DotProd(&Buff[PitchMax+Sfc*SubFrLen],
                    &Buff[PitchMax+Sfc*SubFrLen-i],SubFrLen);

        /* return index of largest cross correlation */

        if (Acc0 > Acc1)
        {
            Acc1 = Acc0;
            Indx = i;
        }
    }
    return -Indx;
}

//---------------------------------------------------------------------------

int  CCODEC::Find_F(float *Buff, int Olp, int Sfc)
{
    int    i;
    int    Indx = 0;
    float  Acc0,Acc1;

    if (Olp > (PitchMax-3))
        Olp = (PitchMax-3);

    Acc1 = (float)0.0;

    for (i=Olp-3; i<=Olp+3; i++)
    {
        if (!((Sfc*SubFrLen+SubFrLen+i) > Frame))
        {
            Acc0 = DotProd(&Buff[PitchMax+Sfc*SubFrLen],
                            &Buff[PitchMax+Sfc*SubFrLen+i],SubFrLen);

            /* return index of largest cross correlation */

            if (Acc0 > Acc1)
            {
                Acc1 = Acc0;
                Indx = i;
            }
        }
    }

    return Indx;
}

//---------------------------------------------------------------------------

void  CCODEC::Filt_Lpf(float *Tv, float *Buff, PFDEF Pf, int Sfc)
{
    int  i;

    for (i = 0; i < SubFrLen; i++)
        Tv[Sfc*SubFrLen+i]= Buff[PitchMax+Sfc*SubFrLen+i]*Pf.ScGn +
                            Buff[PitchMax+Sfc*SubFrLen+Pf.Indx+i]*Pf.Gain;
}

//---------------------------------------------------------------------------

PFDEF CCODEC::Get_Ind(int Ind, float Ten, float Ccr, float Enr)
{
    float  Acc0,Acc1;
    float  Exp;

    PFDEF Pf;


    Pf.Indx = Ind;

    /*  Check valid gain > 2db */

    Acc0 = (Ten * Enr)/(float)4.0;
    Acc1 = Ccr * Ccr;

    if (Acc1 > Acc0)
    {
        if (Ccr >= Enr)
            Pf.Gain = LpfConstTable[WrkRate];
        else
            Pf.Gain = (Ccr/Enr) * LpfConstTable[WrkRate];

        /*  Compute scaling gain  */

        Exp  = Ten + 2*Ccr*Pf.Gain + Pf.Gain*Pf.Gain*Enr;

        if (fabs(Exp) < (float) FLT_MIN)
            Pf.ScGn = (float)0.0;
        else
            Pf.ScGn = (float)sqrt(Ten/Exp);
    }
    else
    {
        Pf.Gain = (float)0.0;
        Pf.ScGn = (float)1.0;
    }

    Pf.Gain = Pf.Gain * Pf.ScGn;

    return Pf;
}

//---------------------------------------------------------------------------

Word16  CCODEC::Comp_Info(float *Buff, int Olp, float *Gain)
{
    int    i;
    float  Acc0;
    float  Tenr;
    float  Ccr,Enr;
    int    Indx;

    if (Olp > (PitchMax-3))
        Olp = (PitchMax-3);

    Indx = Olp;
    Ccr =  (float)0.0;

    for (i=Olp-3; i <= Olp+3; i++)
    {
        Acc0 = DotProd(&Buff[PitchMax+Frame-2*SubFrLen],
                        &Buff[PitchMax+Frame-2*SubFrLen-i],2*SubFrLen);

        if (Acc0 > Ccr)
        {
            Ccr = Acc0;
            Indx = i;
        }
    }

    /*  Compute target energy  */

    Tenr = DotProd(&Buff[PitchMax+Frame-2*SubFrLen],
                    &Buff[PitchMax+Frame-2*SubFrLen],2*SubFrLen);
    *Gain = Tenr;

    /*  Compute best energy */

    Enr = DotProd(&Buff[PitchMax+Frame-2*SubFrLen-Indx],
                    &Buff[PitchMax+Frame-2*SubFrLen-Indx],2*SubFrLen);

    if (Ccr <= (float)0.0)
        return 0;

    if (((((float)0.125)*Enr*Tenr) - (Ccr*Ccr)) < (float)0.0)
        return (Word16) Indx;

    return 0;
}

//---------------------------------------------------------------------------

void  CCODEC::Regen(float *DataBuff, float *Buff, Word16 Lag, float Gain,
              int Ecount, Word16 *Sd)
{
    int  i;

    /*  Test for clearing */

    if (Ecount >= ErrMaxNum)
    {
        for (i = 0; i < Frame; i++)
            DataBuff[i] = (float)0.0;
        for (i = 0; i < Frame+PitchMax; i++)
            Buff[i] = (float)0.0;
    }
    else
    {

        /*  Interpolate accordingly to the voicing estimation */

        if (Lag != 0)
        {
            /*  Voiced case */
            for (i = 0; i < Frame; i++)
                Buff[PitchMax+i] = Buff[PitchMax-Lag+i];
            for (i = 0; i < Frame; i++)
                DataBuff[i] = Buff[PitchMax+i] = Buff[PitchMax+i] * (float)0.75;
        }
        else
        {

            /* Unvoiced case */

            for (i = 0; i < Frame; i++)
                DataBuff[i] = Gain*(float)Rand_lbc(Sd)*((float)1.0/(float)32768.0);

            /* Clear buffer to reset memory */

            for (i = 0; i < Frame+PitchMax; i++)
                Buff[i] = (float)0.0;
        }
    }
}

//---------------------------------------------------------------------------

void  CCODEC::Comp_Lpc(float *UnqLpc, float *PrevDat, float *DataBuff)
{
    int   i,j,k;

    float  Dpnt[Frame+LpcFrame-SubFrLen];
    float  Vect[LpcFrame];
    float  Acf_sf[LpcOrderP1*SubFrames];
    float  *curAcf;
    float  Pk2;

    /*
     * Generate a buffer of 360 samples.
     */

    for (i=0; i < LpcFrame-SubFrLen; i++)
        Dpnt[i] = PrevDat[i];
    for (i=0; i < Frame; i++)
        Dpnt[i+LpcFrame-SubFrLen] = DataBuff[i];

    /*
     * Repeat for all subframes
     */

    curAcf = Acf_sf;
    for (k=0; k < SubFrames; k++)
    {
        /*  Apply the Hamming window */

        for (i = 0; i < LpcFrame; i++)
            Vect[i] = Dpnt[k*SubFrLen+i]*HammingWindowTable[i];

        /*  Compute the autocorrelation coefficients  */

        curAcf[0] = DotProd(Vect, Vect, LpcFrame)/(LpcFrame*LpcFrame);

        /*  Do Ridge regression  */

        curAcf[0] *= ((float)1025.0/(float)1024.0);
        if (curAcf[0] == (float)0.0) {
            for (i = 1; i <= LpcOrder; i++)
                curAcf[i] = (float) 0.0;
        }
        else {
            for (i = 1; i <= LpcOrder; i++)
                curAcf[i] = DotProd(Vect, &Vect[i], LpcFrame-i)
                            / (LpcFrame*LpcFrame) * BinomialWindowTable[i-1];
        }

        /*
         * Apply the Levinson-Durbin algorithm to generate the LPC
         * coefficients
         */

        Durbin(&UnqLpc[k*LpcOrder], &curAcf[1], curAcf[0], &Pk2);
        CodStat.SinDet <<= 1;
        if (Pk2 > (float) 0.95) {
            CodStat.SinDet++;
        }
        curAcf += LpcOrderP1;
    }

    /* Update sine detector */
    CodStat.SinDet &= 0x7fff ;

    j = CodStat.SinDet ;
    k = 0 ;
    for ( i = 0 ; i < 15 ; i ++ ) {
        k += j & 1 ;
        j >>= 1 ;
    }
    if ( k >= 14 )
        CodStat.SinDet |= 0x8000 ;

    Update_Acf(Acf_sf);
}

//---------------------------------------------------------------------------

float  CCODEC::Durbin(float *Lpc, float *Corr, float Err, float *Pk2)
{
    int    i,j;
    float  Temp[LpcOrder];
    float  Pk,Tmp0;

    /*  Initialize the LPC vector  */

    for (i=0; i < LpcOrder; i++)
        Lpc[i] = (float)0.0;

    /*  Compute the partial correlation (parcor) coefficient  */

    for (i=0; i < LpcOrder; i++)
    {
        Tmp0 = Corr[i];
        for (j=0; j<i; j++)
            Tmp0 -= Lpc[j]*Corr[i-j-1];

        if (fabs(Tmp0) >= Err) {
            *Pk2 = (float)0.99;
            break;
        }

        Lpc[i] = Pk = Tmp0/Err;
        Err -= Tmp0*Pk;

        /*
         * Sine detector
         */
        if ( i == 1 )
            *Pk2 = -Pk;

        for (j=0; j < i; j++)
            Temp[j] = Lpc[j];

        for (j=0; j < i; j++)
            Lpc[j] = Lpc[j] - Pk*Temp[i-j-1];
    }
    return Err;
}

//---------------------------------------------------------------------------

void  CCODEC::Wght_Lpc(float *PerLpc, float *UnqLpc)
{
    int  i,j;

    for (i=0; i < SubFrames; i++)
    {
        for (j=0; j < LpcOrder; j++)
        {
            PerLpc[j]          = UnqLpc[j]*PerFiltZeroTable[j];
            PerLpc[j+LpcOrder] = UnqLpc[j]*PerFiltPoleTable[j];
        }
        PerLpc += 2*LpcOrder;
        UnqLpc += LpcOrder;
    }
}

//---------------------------------------------------------------------------

void  CCODEC::Error_Wght(float *Dpnt, float *PerLpc)
{
    int  i,j,k;

    float Acc0;


    for (k=0; k < SubFrames; k++)
    {
        for (i=0; i < SubFrLen; i++)
        {
            /*  FIR part  */

            Acc0 = *Dpnt - DotProd(PerLpc,CodStat.WghtFirDl,LpcOrder);

            for (j=LpcOrder-1; j > 0; j --)
                CodStat.WghtFirDl[j] = CodStat.WghtFirDl[j-1];

            CodStat.WghtFirDl[0] = *Dpnt;

            /*  IIR part  */

            Acc0 += DotProd(&PerLpc[LpcOrder],CodStat.WghtIirDl,LpcOrder);

            for (j = LpcOrder-1; j > 0; j --)
                CodStat.WghtIirDl[j] = CodStat.WghtIirDl[j-1];

            *Dpnt++ = CodStat.WghtIirDl[0] = Acc0;

        }
        PerLpc += 2*LpcOrder;
    }
}

//---------------------------------------------------------------------------

void  CCODEC::Comp_Ir(float *ImpResp, float *QntLpc, float *PerLpc, PWDEF Pw)
{
    int    i,j;

    float  FirDl[LpcOrder];
    float  IirDl[LpcOrder];
    float  Temp[PitchMax+SubFrLen];
    float  Acc0,Acc1;

    /*
     * Clear all memory.  Impulse response calculation requires
     * an all-zero initial state.
     */

    /* Perceptual weighting filter */

    for (i=0; i < LpcOrder; i++)
        FirDl[i] = IirDl[i] = (float)0.0;

    /* Harmonic noise shaping filter */

    for (i=0; i < PitchMax+SubFrLen; i++)
        Temp[i] = (float)0.0;

    /*  Input a single impulse  */

    Acc0 = (float)1.0;

    /*  Do for all elements in a subframe  */

    for (i=0; i < SubFrLen; i++)
    {
        /*  Synthesis filter  */

        Acc1 = Acc0 = Acc0 + DotProd(QntLpc,FirDl,LpcOrder);

        /*  Perceptual weighting filter  */

        /*  FIR part */

        Acc0 -= DotProd(PerLpc,FirDl,LpcOrder);
        for (j=LpcOrder-1; j > 0; j--)
            FirDl[j] = FirDl[j-1];

        FirDl[0] = Acc1;

        /*  IIR part */

        Acc0 += DotProd(&PerLpc[LpcOrder],IirDl,LpcOrder);
        for (j=LpcOrder-1; j > 0; j--)
            IirDl[j] = IirDl[j-1];

        Temp[PitchMax+i] = IirDl[0] = Acc0;

        /*  Harmonic noise shaping filter  */

        ImpResp[i] = Acc0 - Pw.Gain*Temp[PitchMax-Pw.Indx+i];

        Acc0 = (float)0.0;
    }
}

//---------------------------------------------------------------------------

void  CCODEC::Sub_Ring(float *Dpnt, float *QntLpc, float *PerLpc, float *PrevErr,
               PWDEF Pw)
{
    int    i,j;
    float  Acc0,Acc1;

    float  FirDl[LpcOrder];
    float  IirDl[LpcOrder];
    float  Temp[PitchMax+SubFrLen];

    /*  Initialize the memory  */

    for (i=0; i < PitchMax; i++)
        Temp[i] = PrevErr[i];

    for (i=0; i < LpcOrder; i++)
    {
        FirDl[i] = CodStat.RingFirDl[i];
        IirDl[i] = CodStat.RingIirDl[i];
    }

    /*  Do for all elements in a subframe  */

    for (i=0; i < SubFrLen; i++)
    {
        /*  Synthesis filter  */

        Acc1 = Acc0 = DotProd(QntLpc,FirDl,LpcOrder);

        /*  Perceptual weighting filter  */

        /*  FIR part */

        Acc0 -= DotProd(PerLpc,FirDl,LpcOrder);

        for (j=LpcOrder-1; j > 0; j--)
            FirDl[j] = FirDl[j-1];

        FirDl[0] = Acc1;

        /*  IIR part */

        Acc0 += DotProd(&PerLpc[LpcOrder],IirDl,LpcOrder);

        for (j=LpcOrder-1; j > 0; j--)
            IirDl[j] = IirDl[j-1];

        Temp[PitchMax+i] = IirDl[0] = Acc0;
        /*
         * Do the harmonic noise shaping filter and subtract the result
         * from the harmonic noise weighted vector.
         */
        Dpnt[i] -= Acc0 - Pw.Gain*Temp[PitchMax-Pw.Indx+i];
    }
}

//---------------------------------------------------------------------------

void  CCODEC::Upd_Ring(float *Dpnt, float *QntLpc, float *PerLpc, float *PrevErr)
{
    int    i,j;
    float  Acc0,Acc1;

    /*  Shift the harmonic noise shaping filter memory  */

    for (i=SubFrLen; i < PitchMax; i++)
        PrevErr[i-SubFrLen] = PrevErr[i];

    /*  Do for all elements in the subframe  */

    for (i=0; i < SubFrLen; i++)
    {
        /*  Synthesis filter  */

        Acc0 = Dpnt[i] + DotProd(QntLpc,CodStat.RingFirDl,LpcOrder);

        Dpnt[i] = Acc0;
        Acc1 = Acc0;

        /*  Perceptual weighting filter  */
        /*  FIR part */

        Acc0 -= DotProd(PerLpc,CodStat.RingFirDl,LpcOrder);

        for (j=LpcOrder-1; j > 0; j--)
            CodStat.RingFirDl[j] = CodStat.RingFirDl[j-1];
        CodStat.RingFirDl[0] = Acc1;

        /*  IIR part */

        Acc0 += DotProd(&PerLpc[LpcOrder],CodStat.RingIirDl,LpcOrder);

        /* Update IIR memory */
        for (j=LpcOrder-1; j > 0; j--)
            CodStat.RingIirDl[j] = CodStat.RingIirDl[j-1];

        CodStat.RingIirDl[0] = Acc0;
        PrevErr[PitchMax-SubFrLen+i] = CodStat.RingIirDl[0];
    }
}

//---------------------------------------------------------------------------

void CCODEC::Synt(float *Dpnt, float *Lpc)
{
    int     i,j;
    float   Acc0;

    for (i=0 ; i < SubFrLen ; i++)
    {
        Acc0 = Dpnt[i] + DotProd(Lpc,DecStat.SyntIirDl,LpcOrder);

        for (j=LpcOrder-1 ; j > 0 ; j--)
            DecStat.SyntIirDl[j] = DecStat.SyntIirDl[j-1];

        Dpnt[i] = DecStat.SyntIirDl[0] = Acc0;
    }
}

//---------------------------------------------------------------------------

float  CCODEC::Spf(float *Tv, float *Lpc)
{
    int    i,j;

    float  Acc0, Acc1;
    float  Sen;
    float  Tmp;
    float  FirCoef[LpcOrder];
    float  IirCoef[LpcOrder];

    for (i=0; i < LpcOrder; i++)
    {
        FirCoef[i] = Lpc[i]*PostFiltZeroTable[i];
        IirCoef[i] = Lpc[i]*PostFiltPoleTable[i];
    }

    /* Compute the first two autocorrelation coefficients R[0] and R[1] */

    Acc0 = DotProd(Tv,&Tv[1],SubFrLen-1);
    Acc1 = DotProd(Tv,Tv,SubFrLen);

    /* energy */
    Sen = Acc1;

    /*
     * Compute the first-order partial correlation coefficient of the
     * input speech vector.
     */

    if (Acc1 > (float) FLT_MIN)
        Tmp = Acc0/Acc1;
    else
        Tmp = (float)0.0;

    /* Update the parkor memory */

    DecStat.Park = (((float)0.75)*DecStat.Park + ((float)0.25)*Tmp);
    Tmp = DecStat.Park*PreCoef;

    /* Do the formant post filter */

    for (i=0; i<SubFrLen; i++)
    {
        /* FIR Filter */

        Acc0 = Tv[i] - DotProd(FirCoef,DecStat.PostFirDl,LpcOrder);

        for (j=LpcOrder-1; j > 0; j--)
            DecStat.PostFirDl[j] = DecStat.PostFirDl[j-1];

        DecStat.PostFirDl[0] = Tv[i];

        /* IIR Filter */

        Acc0 += DotProd(IirCoef,DecStat.PostIirDl,LpcOrder);

        for (j=LpcOrder-1; j > 0; j--)
            DecStat.PostIirDl[j] = DecStat.PostIirDl[j-1];

        DecStat.PostIirDl[0] = Acc0;

        /* Preemphasis */

        Tv[i] = Acc0 + DecStat.PostIirDl[1] * Tmp;

    }
    return Sen;
}

//---------------------------------------------------------------------------

float CCODEC::Polynomial(float *Lpq, int CosPtr)
{
    float  Ret;
    int    j;

    Ret = (float)0.0;
    for (j=0; j<=LpcOrder/2; j++)
        Ret += Lpq[LpcOrder-2*j]*CosineTable[(CosPtr*j) % CosineTableSize];

    return(Ret);
}

//---------------------------------------------------------------------------

void  CCODEC::AtoLsp(float *LspVect, float *Lpc, float *PrevLsp)
{
    int    i,j,k;
    int    LspCnt;
    float  Lpq[LpcOrder+2];
    float  PrevVal,CurrVal,AbsPrev,AbsCurr;

    /*
     * Perform a bandwidth expansion on the LPC coefficients.
     */

    for (i=0; i < LpcOrder; i++)
        LspVect[i] = Lpc[i]*BandExpTable[i];

    /*
     * This loop computes the coefficients of P(z) and Q(z).
     */

    Lpq[0] = Lpq[1] = (float)1.0;

    for (i=0; i < LpcOrder/2; i++)
    {
        Lpq[2*i+2] = -Lpq[2*i+0] - LspVect[i] - LspVect[LpcOrder-1-i];
        Lpq[2*i+3] =  Lpq[2*i+1] - LspVect[i] + LspVect[LpcOrder-1-i];
    }
    Lpq[LpcOrder+0] *= (float)0.5;
    Lpq[LpcOrder+1] *= (float)0.5;

    /* Do first evaluation */

    k = 0;
    LspCnt = 0;
    PrevVal = Polynomial(Lpq,0);


    for (i=1; i < CosineTableSize/2; i++)
    {
        /* Evaluate the polynomial */

        CurrVal = Polynomial(&Lpq[k],i);

        /* Test for sign change indicating a zero crossing */

        if (CurrVal*PrevVal < 0)
        {
            AbsPrev = (float)fabs(PrevVal);
            AbsCurr = (float)fabs(CurrVal);

            LspVect[LspCnt++] = (i-1 + AbsPrev/(AbsPrev+AbsCurr));

            /* Check if all found */

            if (LspCnt == LpcOrder)
                break;

            /* Switch the pointer, evaluate again */

            k ^= 1;
            CurrVal = Polynomial(&Lpq[k],i);
        }
        PrevVal = CurrVal;
    }

    /*
     *  Check if all 10 zeros were found.  If not, ignore the results of
     *  the search and use the previous frame's LSP frequencies instead.
     */

    if (LspCnt != LpcOrder)
    {
        for (j=0; j < LpcOrder; j++)
            LspVect[j] = PrevLsp[j];
    }
    return;
}

//---------------------------------------------------------------------------

Word32 CCODEC::Lsp_Qnt(float *CurrLsp, float *PrevLsp)
{
    int   i;

    float Wvect[LpcOrder];
    float Min,Tmp;

    /*
     * Compute the VQ weighting vector.  The weights assign greater
     * precision to those frequencies that are closer together.
     */

    /* Compute the end differences */

    Wvect[0] = ((float)1.0)/(CurrLsp[1] - CurrLsp[0]);
    Wvect[LpcOrder-1] = ((float)1.0)/(CurrLsp[LpcOrder-1] - CurrLsp[LpcOrder-2]);

    /* Compute the rest of the differences */

    for (i=1; i < LpcOrder-1; i++)
    {
        Min = CurrLsp[i+1] - CurrLsp[i];
        Tmp = CurrLsp[i] - CurrLsp[i-1];

        if (Tmp < Min)
            Min = Tmp;

        if (Min > (float)0.0)
            Wvect[i] = ((float)1.0)/Min;
        else
            Wvect[i] = (float)1.0;
    }

    /* Generate the prediction vector and subtract it.  Use a constant
     * first-order predictor based on the previous (DC-free) LSP vector.
     */

    for (i=0; i < LpcOrder; i++)
        CurrLsp[i] = (CurrLsp[i] - LspDcTable[i]) -
                        LspPred0*(PrevLsp[i] - LspDcTable[i]);

    /* Do the vector quantization for all three bands */

    return Lsp_Svq(CurrLsp, Wvect);
}

//---------------------------------------------------------------------------

Word32  CCODEC::Lsp_Svq(float *Lsp, float *Wvect)
{
    int  i,j,k;

    Word32 Rez;
    Word32 Indx;
    int    Start,Dim;
    float  Tmp[LpcOrder];
    float *LspQntPnt;
    float  Max,Err;

    /*  Initialize the return value  */

    Rez = (Word32) 0;

    /*  Quantize each band separately  */

    for (k=0; k < LspQntBands; k++)
    {

        /* Initialize the search */

        Max = (float)-1.0;
        Indx = 0;
        LspQntPnt = BandQntTable[k];
        Start = BandInfoTable[k][0];
        Dim = BandInfoTable[k][1];

        for (i=0; i < LspCbSize; i++)
        {
            /* Generate weighted vector */

            for (j=0; j<Dim; j++)
                Tmp[j] = Wvect[Start+j]*LspQntPnt[j];

            /* Compute the Error */

            Err = ((float)2.0)*DotProd(&Lsp[Start],Tmp,Dim) -
                    DotProd(LspQntPnt,Tmp,Dim);
            LspQntPnt += BandInfoTable[k][1];

            if (Err > Max)
            {
                Max = Err;
                Indx = (Word32) i;
            }
        }
        Rez = (Rez << 8) | Indx;
    }

    return Rez;
}

//---------------------------------------------------------------------------

void  CCODEC::Lsp_Inq(float *Lsp, float *PrevLsp, Word32 LspId, Word16 Crc)
{
    int    i,j;

    float *LspQntPnt;
    float  Lprd,Scon,Tmpf;
    int    Tmp;
    Flag   Test;

    /*
     * Check for frame erasure.
     */
    if (Crc == 0)
    {
        Scon = (float)2.0;
        Lprd = LspPred0;
    }
    else
    {
        LspId = (Word32) 0;
        Scon = (float)4.0;
        Lprd = LspPred1;
    }

    /*
     * Inverse quantize the 10th-order LSP vector.  Each band is done
     * separately.
     */

    for (i=LspQntBands-1; i >= 0; i--)
    {
        /* Get the VQ table entry corresponding to the transmitted index */
        Tmp = (int)(LspId & (Word32) 0x000000ff);
        LspId >>= 8;

        LspQntPnt = BandQntTable[i];

        for (j=0; j < BandInfoTable[i][1]; j++)
            Lsp[BandInfoTable[i][0] + j] = LspQntPnt[Tmp*BandInfoTable[i][1] + j];
    }

    /* Add predicted vector and DC to decoded vector */

    for (j=0; j < LpcOrder; j++)
        Lsp[j] = Lsp[j] + (PrevLsp[j] - LspDcTable[j])*Lprd + LspDcTable[j];


    /*
     * Perform a stability test on the quantized LSP frequencies.
     */

    for (i=0; i < LpcOrder; i++)
    {

        /* Check the first frequency */
        if (Lsp[0] < (float)3.0)
            Lsp[0] = (float)3.0;

        /* Check the last frequency */
        if (Lsp[LpcOrder-1] > (float)252.0)
            Lsp[LpcOrder-1] = (float)252.0;

        /* Perform the modification */
        for (j=1; j < LpcOrder; j++)
        {
            Tmpf = Scon + Lsp[j-1] - Lsp[j];
            if (Tmpf > 0)
            {
                Tmpf *= (float)0.5;
                Lsp[j-1] -= Tmpf;
                Lsp[j] += Tmpf;
            }
        }

        /* Test the modified frequencies for stability.  Break out of
         * the loop if the frequencies are stable.
         */

        Test = False;
        for (j=1; j < LpcOrder; j++)
            if ((Lsp[j] - Lsp[j-1]) < (Scon - (float)0.03125))
                Test = True;

        if (Test == False)
            break;
    }

    /*
     * If the result of the stability check is True (not stable),
     * set Lsp to PrevLsp
     */

    if (Test == True)
    {
        for ( j = 0 ; j < LpcOrder ; j ++ )
            Lsp[j] = PrevLsp[j] ;
    }

    return;
}

//---------------------------------------------------------------------------

void  CCODEC::Lsp_Int(float *QntLpc, float *CurrLsp, float *PrevLsp)
{
    int    i,j;

    float  *Dpnt;
    float  Fac[4] = {(float)0.25, (float)0.5, (float)0.75, (float)1.0};

    Dpnt = QntLpc;
    for (i=0; i < SubFrames; i++) {

        /* Compute the quantized LSP frequencies by linear interpolation
         * of the frequencies from subframe 3 of the current and
         * previous frames
         */

        for (j=0; j < LpcOrder; j++)
            Dpnt[j] = ((float)1.0 - Fac[i])*PrevLsp[j] + Fac[i]*CurrLsp[j];

        /* Convert the quantized LSP frequencies to quantized LPC
         * coefficients
         */

        LsptoA(Dpnt);
        Dpnt += LpcOrder;
    }
}

//---------------------------------------------------------------------------

void  CCODEC::LsptoA(float *Lsp)
{
    int   i,j;

    float P[LpcOrder/2+1];
    float Q[LpcOrder/2+1];
    float Floor;
    float Fac[(LpcOrder/2)-2] = {(float)1.0,(float)0.5,(float)0.25};

    /*
     * Compute the cosines of the LSP frequencies by table lookup and
     * linear interpolation
     */

    for (i=0; i < LpcOrder; i++)
    {
        Floor = (float)floor(Lsp[i]);
        j = (int) Floor;
        Lsp[i] = -(CosineTable[j] +
        (CosineTable[j+1]-CosineTable[j])*(Lsp[i]-Floor));
    }

    /*
     * Compute the sum and difference polynomials with the real roots
     * removed.
     */

    /* Init P and Q. */

    P[0] = (float)0.5;
    P[1] = Lsp[0] + Lsp[2];
    P[2] = (float)1.0 + ((float)2.0)*Lsp[0]*Lsp[2];

    Q[0] = (float)0.5;
    Q[1] = Lsp[1] + Lsp[3];
    Q[2] = (float)1.0 + ((float)2.0)*Lsp[1]*Lsp[3];


    for (i=2; i < LpcOrder/2; i++)
    {
        /* Compute coefficient (i+1) */

        P[i+1] = P[i-1] + P[i]*Lsp[2*i+0];
        Q[i+1] = Q[i-1] + Q[i]*Lsp[2*i+1];

        /* Compute coefficients i, i-1, ..., 2 */

        for (j=i; j >= 2; j--)
        {
            P[j] = P[j-1]*Lsp[2*i+0] + ((float)0.5)*(P[j]+P[j-2]);
            Q[j] = Q[j-1]*Lsp[2*i+1] + ((float)0.5)*(Q[j]+Q[j-2]);
        }

        /* Compute coefficients 1, 0 */

        P[0] = P[0]*((float)0.5);
        Q[0] = Q[0]*((float)0.5);

        P[1] = (P[1] + Lsp[2*i+0]*Fac[i-2])*((float)0.5);
        Q[1] = (Q[1] + Lsp[2*i+1]*Fac[i-2])*((float)0.5);
    }

    /*
     * Convert the sum and difference polynomials to LPC coefficients.
     */

    for (i=0; i < LpcOrder/2; i++)
    {
        Lsp[i] =            (-P[i] - P[i+1] + Q[i] - Q[i+1])*((float)8.0);
        Lsp[LpcOrder-1-i] = (-P[i] - P[i+1] - Q[i] + Q[i+1])*((float)8.0);
    }
}

//---------------------------------------------------------------------------

void  CCODEC::Rem_Dc(float *Dpnt)
{
    int   i;
    float acc0;

    if (UseHp)
    {
        for (i=0; i < Frame; i++)
        {
            acc0 = Dpnt[i] - CodStat.HpfZdl;
            CodStat.HpfZdl = Dpnt[i];

            Dpnt[i] = CodStat.HpfPdl =
                            acc0 + CodStat.HpfPdl*((float)127.0/(float)128.0);
        }
    }
}

//---------------------------------------------------------------------------

void  CCODEC::Mem_Shift(float *PrevDat, float *DataBuff)
{
    int  i;

    float Dpnt[Frame+LpcFrame-SubFrLen];

    /*  Form Buffer  */

    for (i=0; i < LpcFrame-SubFrLen; i++)
        Dpnt[i] = PrevDat[i];
    for (i=0; i < Frame; i++)
        Dpnt[i+LpcFrame-SubFrLen] = DataBuff[i];

    /*  Update PrevDat  */

    for (i=0; i < LpcFrame-SubFrLen; i++)
        PrevDat[i] = Dpnt[Frame+i];

    /*  Update DataBuff  */

    for (i=0; i < Frame; i++)
        DataBuff[i] = Dpnt[(LpcFrame-SubFrLen)/2+i];
}

//---------------------------------------------------------------------------

void  CCODEC::Line_Pack(LINEDEF *Line, char *Vout, Word16 Ftyp)
{
    int       i;
    int       BitCount;

    Word16    BitStream[192];
    Word16    *Bsp = BitStream;
    Word32    Temp;

    /* Clear the output vector */
    for ( i = 0 ; i < 24 ; i ++ )
        Vout[i] = 0 ;

 /*
  * Add the coder rate info and frame type info to the 2 msb
  * of the first word of the frame.
  */
    switch (Ftyp) {

        case 0 : {
            Temp = 0x00000003L;
            break;
        }

        case 2 : {
            Temp = 0x00000002L;
            break;
        }

        default : {
            if ( WrkRate == Rate63 )
                Temp = 0x00000000L;
            else
                Temp = 0x00000001L;
            break;
        }
    }

    /* Serialize Control info */
    Bsp = Par2Ser( Temp, Bsp, 2 ) ;

    /* Check for Speech/NonSpeech case */
    if ( Ftyp == 1 ) {

        /* 24 bit LspId */
        Temp = (*Line).LspId ;
        Bsp = Par2Ser( Temp, Bsp, 24 ) ;

        /*
         *  Do the part common to both rates
         */

        /* Adaptive code book lags */
        Temp = (Word32) (*Line).Olp[0] - (Word32) PitchMin ;
        Bsp = Par2Ser( Temp, Bsp, 7 ) ;

        Temp = (Word32) (*Line).Sfs[1].AcLg ;
        Bsp = Par2Ser( Temp, Bsp, 2 ) ;

        Temp = (Word32) (*Line).Olp[1] - (Word32) PitchMin ;
        Bsp = Par2Ser( Temp, Bsp, 7 ) ;

        Temp = (Word32) (*Line).Sfs[3].AcLg ;
        Bsp = Par2Ser( Temp, Bsp, 2 ) ;

        /* Write combined 12 bit index of all the gains */
        for ( i = 0 ; i < SubFrames ; i ++ ) {
            Temp = (*Line).Sfs[i].AcGn*NumOfGainLev + (*Line).Sfs[i].Mamp ;
            if ( WrkRate == Rate63 )
                Temp += (Word32) (*Line).Sfs[i].Tran << 11 ;
            Bsp = Par2Ser( Temp, Bsp, 12 ) ;
        }

        /* Write all the Grid indices */
        for ( i = 0 ; i < SubFrames ; i ++ )
            *Bsp ++ = (Word16)(*Line).Sfs[i].Grid ;

        /* High rate only part */
        if ( WrkRate == Rate63 ) {

            /* Write the reserved bit as 0 */
            *Bsp ++ = (Word16) 0 ;

            /* Write 13 bit combined position index */
            Temp = (*Line).Sfs[0].Ppos >> 16 ;
            Temp = Temp * 9 + ( (*Line).Sfs[1].Ppos >> 14) ;
            Temp *= 90 ;
            Temp += ((*Line).Sfs[2].Ppos >> 16) * 9 + ( (*Line).Sfs[3].Ppos >> 14 ) ;
            Bsp = Par2Ser( Temp, Bsp, 13 ) ;

            /* Write all the pulse positions */
            Temp = (*Line).Sfs[0].Ppos & 0x0000ffffL ;
            Bsp = Par2Ser( Temp, Bsp, 16 ) ;

            Temp = (*Line).Sfs[1].Ppos & 0x00003fffL ;
            Bsp = Par2Ser( Temp, Bsp, 14 ) ;

            Temp = (*Line).Sfs[2].Ppos & 0x0000ffffL ;
            Bsp = Par2Ser( Temp, Bsp, 16 ) ;

            Temp = (*Line).Sfs[3].Ppos & 0x00003fffL ;
            Bsp = Par2Ser( Temp, Bsp, 14 ) ;

            /* Write pulse amplitudes */
            Temp = (Word32) (*Line).Sfs[0].Pamp ;
            Bsp = Par2Ser( Temp, Bsp, 6 ) ;

            Temp = (Word32) (*Line).Sfs[1].Pamp ;
            Bsp = Par2Ser( Temp, Bsp, 5 ) ;

            Temp = (Word32) (*Line).Sfs[2].Pamp ;
            Bsp = Par2Ser( Temp, Bsp, 6 ) ;

            Temp = (Word32) (*Line).Sfs[3].Pamp ;
            Bsp = Par2Ser( Temp, Bsp, 5 ) ;
        }
        /* Low rate only part */
        else {

            /* Write 12 bits of positions */
            for ( i = 0 ; i < SubFrames ; i ++ ) {
                Temp = (*Line).Sfs[i].Ppos ;
                Bsp = Par2Ser( Temp, Bsp, 12 ) ;
            }

            /* Write 4 bit Pamps */
            for ( i = 0 ; i < SubFrames ; i ++ ) {
                Temp = (*Line).Sfs[i].Pamp ;
                Bsp = Par2Ser( Temp, Bsp, 4 ) ;
            }
        }

    }
    else if (Ftyp == 2) {    /* SID frame */

        /* 24 bit LspId */
        Temp = (*Line).LspId ;
        Bsp = Par2Ser( Temp, Bsp, 24 ) ;

        /* Do Sid frame gain */
        Temp = (Word32)(*Line).Sfs[0].Mamp ;
        Bsp = Par2Ser( Temp, Bsp, 6 ) ;
    }

    /* Write out active frames */
    if (Ftyp == 1) {
        if ( WrkRate == Rate63 )
            BitCount = 192;
        else
            BitCount = 160;
    }
    /* Non active frames */
    else if (Ftyp == 2)
        BitCount = 32;
    else
        BitCount = 2;

    for ( i = 0 ; i < BitCount ; i ++ )
        Vout[i>>3] ^= BitStream[i] << (i & 0x0007) ;
}

//---------------------------------------------------------------------------

Word16* CCODEC::Par2Ser( Word32 Inp, Word16 *Pnt, int BitNum )
{
    int     i;
    Word16  Temp ;

    for ( i = 0 ; i < BitNum ; i ++ ) {
        Temp = (Word16)(Inp & 0x0001);
        Inp >>= 1 ;
        *Pnt ++ = Temp ;
    }

    return Pnt ;
}

//---------------------------------------------------------------------------

LINEDEF  CCODEC::Line_Unpk(char *Vinp, Word16 *Ftyp, Word16 Crc)
{
    int     i  ;
    Word16  BitStream[192] ;
    Word16  *Bsp = BitStream ;
    LINEDEF Line ;
    Word32  Temp ;
    Word16  Info ;
    Word16  Bound_AcGn ;

    Line.Crc = Crc;
    if (Crc != 0)
        return Line;

    /* Unpack the byte info to BitStream vector */
    for ( i = 0 ; i < 192 ; i ++ )
        BitStream[i] = (Word16) (( Vinp[i>>3] >> (i & (Word16)0x0007) ) & 1);

    /* Decode the first two bits */
    Info = (Word16)Ser2Par( &Bsp, 2 ) ;

    if (Info == 3) {
        *Ftyp = 0;
        Line.LspId = 0L;    /* Dummy : to avoid Borland C3.1 warning */
        return Line;
    }

    /* Decode the LspId */
    Line.LspId = Ser2Par( &Bsp, 24 ) ;

    if (Info == 2) {
        /* Decode the Noise Gain */
        Line.Sfs[0].Mamp = (Word16)Ser2Par( &Bsp, 6);
        *Ftyp = 2;
        return Line ;
    }

    /*
     * Decode the common information to both rates
     */

    *Ftyp = 1;

    /* Decode the bit-rate */

    Info = 0;

    WrkRate = (Info == 0) ? 0 : 1;

    /* Decode the adaptive codebook lags */
    Temp = Ser2Par( &Bsp, 7 ) ;
    /* Test if forbidden code */
    if (Temp <= 123) {
        Line.Olp[0] = (Word16) Temp + (Word16)PitchMin ;
    }
    else {
        /* transmission error */
        Line.Crc = 1;
        return Line;
    }

    Line.Sfs[1].AcLg = (Word16) Ser2Par( &Bsp, 2 ) ;

    Temp = Ser2Par( &Bsp, 7 ) ;
    /* Test if forbidden code */
    if (Temp <= 123) {
        Line.Olp[1] = (Word16) Temp + (Word16)PitchMin ;
    }
    else {
        /* transmission error */
        Line.Crc = 1;
        return Line ;
    }

    Line.Sfs[3].AcLg = (Word16) Ser2Par( &Bsp, 2 ) ;

    Line.Sfs[0].AcLg = 1 ;
    Line.Sfs[2].AcLg = 1 ;

    /* Decode the combined gains accordingly to the rate */
    for ( i = 0 ; i < SubFrames ; i ++ ) {

        Temp = Ser2Par( &Bsp, 12 ) ;

        Line.Sfs[i].Tran = 0 ;

        Bound_AcGn = NbFilt170 ;
        if ( (WrkRate == Rate63) && (Line.Olp[i>>1] < (SubFrLen-2) ) ) {
            Line.Sfs[i].Tran = (Word16)(Temp >> 11) ;
            Temp &= 0x000007ffL ;
            Bound_AcGn = NbFilt085 ;
        }
        Line.Sfs[i].AcGn = (Word16)(Temp / (Word16)NumOfGainLev) ;

        if (Line.Sfs[i].AcGn < Bound_AcGn ) {
            Line.Sfs[i].Mamp = (Word16)(Temp % (Word16)NumOfGainLev) ;
        }
        else {
            /* error detected */
            Line.Crc = 1;
            return Line ;
        }
    }

    /* Decode the grids */
    for ( i = 0 ; i < SubFrames ; i ++ )
        Line.Sfs[i].Grid = *Bsp ++ ;

    if (Info == 0) {

        /* Skip the reserved bit */
        Bsp ++ ;

        /* Decode 13 bit combined position index */
        Temp = Ser2Par( &Bsp, 13 ) ;
        Line.Sfs[0].Ppos = ( Temp/90 ) / 9 ;
        Line.Sfs[1].Ppos = ( Temp/90 ) % 9 ;
        Line.Sfs[2].Ppos = ( Temp%90 ) / 9 ;
        Line.Sfs[3].Ppos = ( Temp%90 ) % 9 ;

        /* Decode all the pulse positions */
        Line.Sfs[0].Ppos = ( Line.Sfs[0].Ppos << 16 ) + Ser2Par( &Bsp, 16 ) ;
        Line.Sfs[1].Ppos = ( Line.Sfs[1].Ppos << 14 ) + Ser2Par( &Bsp, 14 ) ;
        Line.Sfs[2].Ppos = ( Line.Sfs[2].Ppos << 16 ) + Ser2Par( &Bsp, 16 ) ;
        Line.Sfs[3].Ppos = ( Line.Sfs[3].Ppos << 14 ) + Ser2Par( &Bsp, 14 ) ;

        /* Decode pulse amplitudes */
        Line.Sfs[0].Pamp = (Word16)Ser2Par( &Bsp, 6 ) ;
        Line.Sfs[1].Pamp = (Word16)Ser2Par( &Bsp, 5 ) ;
        Line.Sfs[2].Pamp = (Word16)Ser2Par( &Bsp, 6 ) ;
        Line.Sfs[3].Pamp = (Word16)Ser2Par( &Bsp, 5 ) ;
    }
    else {

        /* Decode the positions */
        for ( i = 0 ; i < SubFrames ; i ++ )
            Line.Sfs[i].Ppos = Ser2Par( &Bsp, 12 ) ;

        /* Decode the amplitudes */
        for ( i = 0 ; i < SubFrames ; i ++ )
            Line.Sfs[i].Pamp = (Word16)Ser2Par( &Bsp, 4 ) ;
    }
    return Line;
}

//---------------------------------------------------------------------------

Word32 CCODEC::Ser2Par( Word16 **Pnt, int Count )
{
    int     i;
    Word32  Rez = 0L;

    for ( i = 0 ; i < Count ; i ++ ) {
        Rez += (Word32) **Pnt << i ;
        (*Pnt) ++ ;
    }
    return Rez ;
}

//---------------------------------------------------------------------------

Word16 CCODEC::Rand_lbc(Word16 *p)
{
    *p = (Word16)(((*p)*521L + 259) & 0x0000ffff);
    return(*p);
}

//---------------------------------------------------------------------------

void  CCODEC::Scale(float *Tv, float Sen)
{
    int  i;

    float Acc1;
    float SfGain;

    Acc1 = DotProd(Tv,Tv,SubFrLen);

    if (Acc1 > (float) FLT_MIN)
        SfGain = (float) sqrt(Sen/Acc1) * (float)0.0625;
    else
        SfGain = (float)0.0625;

    /*
     * Update gain and scale the Postfiltered Signal
     */
    for (i=0; i < SubFrLen; i++)
    {
        DecStat.Gain = (float)0.9375*DecStat.Gain + SfGain;
        Tv[i] = (float)1.0625*Tv[i]*DecStat.Gain;
    }
}


//---------------------------------------------------------------------------
float CCODEC::DotProd(float *in1, float *in2, int len)
{
    int   i;
    float sum;

    sum = (float)0.0;
    for (i=0; i<len; i++)
        sum += in1[i]*in2[i];

    return(sum);
}

//---------------------------------------------------------------------------
void CCODEC::Calc_Exc_Rand(float curGain, float *PrevExc, float *DataExc,
                                      Word16 *nRandom, LINEDEF *Line)
{
    int     i, i_subfr, iblk;
    Word16  temp16;
    Word16  j;
    Word16  TabPos[2*NbPulsBlk], *ptr_TabPos;
    float   TabSign[2*NbPulsBlk], *ptr_TabSign;
    Word16  *ptr1;
    float   *curExc;
    float   x1, x2, ener_ltp, inter_exc, delta, b0, c;
    Word16  tmp[SubFrLen/Sgrid];
    Word16  offset[SubFrames];

    /*
     * generate LTP codes
     */
    Line->Olp[0] = random_number(21, nRandom) + 123;
    Line->Olp[1] = random_number(21, nRandom) + 123;
    for (i_subfr=0; i_subfr<SubFrames; i_subfr++) {  /* in [1, NbFilt] */
        Line->Sfs[i_subfr].AcGn = random_number(NbFilt, nRandom) + (Word16)1;
    }
    Line->Sfs[0].AcLg = 1;
    Line->Sfs[1].AcLg = 0;
    Line->Sfs[2].AcLg = 1;
    Line->Sfs[3].AcLg = 3;


    /*
     * Random innovation :
     * Selection of the grids, signs and pulse positions
     */

    /* Signs and Grids */
    ptr_TabSign = TabSign;
    ptr1 = offset;
    for (iblk=0; iblk<SubFrames/2; iblk++) {
        temp16  = random_number((Word16) (1 << (NbPulsBlk+2)), nRandom);
        *ptr1++ = (Word16) (temp16 & 0x0001);
        temp16  >>= 1;
        *ptr1++ = (Word16) (SubFrLen + (temp16 & 0x0001));
        for (i=0; i<NbPulsBlk; i++) {
            temp16 >>= 1;
            *ptr_TabSign++= (float) 2. * (float)(temp16 & 0x0001) - (float) 1.;
        }
    }

    /* Positions */
    ptr_TabPos  = TabPos;
    for (i_subfr=0; i_subfr<SubFrames; i_subfr++) {

        for (i=0; i<(SubFrLen/Sgrid); i++)
            tmp[i] = (Word16) i;
        temp16 = (SubFrLen/Sgrid);
        for (i=0; i<Nb_puls[i_subfr]; i++) {
            j = random_number(temp16, nRandom);
            *ptr_TabPos++ = (Word16) (2 * tmp[(int)j] + offset[i_subfr]);
            temp16--;
            tmp[(int)j] = tmp[(int)temp16];
        }
    }

    /*
     * Compute fixed codebook gains
     */

    ptr_TabPos = TabPos;
    ptr_TabSign = TabSign;
    curExc = DataExc;
    i_subfr = 0;
    for (iblk=0; iblk<SubFrames/2; iblk++) {

        /* decode LTP only */
        Decod_Acbk(curExc, &PrevExc[0], Line->Olp[iblk],
                    Line->Sfs[i_subfr].AcLg, Line->Sfs[i_subfr].AcGn);
        Decod_Acbk(&curExc[SubFrLen], &PrevExc[SubFrLen], Line->Olp[iblk],
            Line->Sfs[i_subfr+1].AcLg, Line->Sfs[i_subfr+1].AcGn);

        ener_ltp = DotProd(curExc, curExc, SubFrLenD);

        inter_exc = (float) 0.;
        for (i=0; i<NbPulsBlk; i++) {
            inter_exc += curExc[(int)ptr_TabPos[i]] * ptr_TabSign[i];
        }

        c = (ener_ltp - curGain * curGain * (float)SubFrLenD) * InvNbPulsBlk;

        /*
         * Solve EQ(X) = X**2 + 2 b0 X + c
         */

        b0 = inter_exc * InvNbPulsBlk;
        delta = b0 * b0 - c;

        /* Case delta <= 0 */
        if (delta <= (float) 0.) {
            x1 = - b0;
        }

        /* Case delta > 0 */
        else {
            delta = (float) sqrt(delta);
            x1 = - b0 + delta;
            x2 = b0 + delta;
            if (fabs(x2) < fabs(x1))
                x1 = - x2;
        }

        /* Update DataExc */
        if (x1 > Gexc_Max)
            x1 = Gexc_Max;
        if (x1 < -Gexc_Max)
            x1 = -Gexc_Max;

        for (i=0; i<NbPulsBlk; i++) {
            j = *ptr_TabPos++;
            curExc[(int)j] += (x1 * (*ptr_TabSign++));
        }

        for (i=0; i<SubFrLenD; i++) {
            if (curExc[i] > (float) 32766.5)
                curExc[i] = (float) 32767.0;
            else if (curExc[i] < (float) -32767.5)
                curExc[i] = (float) -32768.0;
        }

        /* update PrevExc */
        for (i=SubFrLenD; i<PitchMax; i++)
            PrevExc[i-SubFrLenD] = PrevExc[i];
        for (i=0; i<SubFrLenD; i++)
            PrevExc[i+PitchMax-SubFrLenD] = curExc[i];

        curExc += SubFrLenD;
        i_subfr += 2;

    } /* end of loop on LTP blocks */

    return;
}

//---------------------------------------------------------------------------

Word16 CCODEC::random_number(Word16 np1, Word16 *nRandom)
{
    Word16 temp;

    temp = (Word16) (Rand_lbc(nRandom) & 0x7FFF);
    temp = (Word16) (((Word32)temp * (Word32)np1) >> 15);
    return(temp);
}

//---------------------------------------------------------------------------

Word16 CCODEC::Qua_SidGain(float *Ener, Word16 nq)
{
    Word16  temp16, iseg, iseg_p1;
    Word32  j, j2, k, exp;
    float   temp, x, y, z;
    int     i;

    if (nq == 0) {
        /* Quantize energy saved for frame erasure case                */
        /* x = fact[0] * Ener[0] with fact[0] = 1/(2*SubFrLen)         */
        x = fact[0] * Ener[0];
    }

    else {

        /*
         * Compute weighted average of energies
         * x = fact[nq] x SUM(i=0->nq-1) Ener[i]
         * with fact[nq] =  fact_mul x fact_mul / nq x Frame
         */
        for (i=0, x=(float)0.; i<nq; i++)
            x += Ener[i];
        x *= fact[nq];
    }

    /* Quantize x */
    if (x >= bseg[2])
        return(63);

    /* Compute segment number iseg */
    if (x >= bseg[1]) {
        iseg = 2;
        exp = 4;
    }
    else {
        exp  = 3;
        if (x >= bseg[0])
            iseg = 1;
        else
            iseg = 0;
    }

    iseg_p1 = (Word16) (iseg + 1);
    j = 1 << exp;
    k = j >> 1;

    /* Binary search in segment iseg */
    for (i=0; i<exp; i++) {
        temp = base[iseg] + (float) (j << iseg_p1);
        y = temp * temp;
        if (x >= y)
            j += k;
        else
            j -= k;
        k = k >> 1;
    }

    temp = base[iseg] + (float) (j << iseg_p1);
    y =  (temp * temp) - x;
    if (y <= (float)0.0) {
        j2 = j + 1;
        temp = base[iseg] + (float) (j2 << iseg_p1);
        z = x - (temp * temp);
        if (y > z)
            temp16 = (Word16) ((iseg<<4) + j);
        else
            temp16 = (Word16) ((iseg<<4) + j2);
    }
    else {
        j2 = j - 1;
        temp = base[iseg] + (float) (j2 << iseg_p1);
        z = x - (temp * temp);
        if (y < z)
            temp16 = (Word16) ((iseg<<4) + j);
        else
            temp16 = (Word16) ((iseg<<4) + j2);
    }
    return(temp16);
}

//---------------------------------------------------------------------------

float CCODEC::Dec_SidGain(Word16 iGain)
{
    Word16 i, iseg;
    float  temp;

    iseg = (Word16) (iGain >> 4);
    if (iseg == 3)
        iseg = 2;
    i = (Word16) (iGain - (iseg << 4));
    temp = base[iseg] + (float) (i << (iseg + 1));
    return(temp);
}

//---------------------------------------------------------------------------

void  CCODEC::Init_Vad(void)
{
    int i ;

    VadStat.Hcnt = 3 ;
    VadStat.Vcnt = 0 ;
    VadStat.Penr = (float) 1024.0;
    VadStat.Nlev = (float) 1024.0;

    VadStat.Aen = 0;

    VadStat.Polp[0] = 1;
    VadStat.Polp[1] = 1;
    VadStat.Polp[2] = SubFrLen;
    VadStat.Polp[3] = SubFrLen;

    for (i=0; i < LpcOrder; i++)
        VadStat.NLpc[i] = (float)0.0;

}

//---------------------------------------------------------------------------

Flag CCODEC::Comp_Vad(float *Dpnt)
{
    int     i, j, bexp;

    float   Acc0, Frac, Thresh, Enr;
    float   Temp;
    Word32  Tm1, Tm2;
    Word16  Minp;

    Flag    VadState = 1 ;

    static  float  ScfTab[11] = {
        (float)  9170.0,
        (float)  9170.0,
        (float)  9170.0,
        (float)  9170.0,
        (float) 10289.0,
        (float) 11544.0,
        (float) 12953.0,
        (float) 14533.0,
        (float) 16306.0,
        (float) 18296.0,
        (float) 20529.0
    };

    if ( !UseVx )
        return VadState ;

    /* Find Minimum pitch period */
    Minp = (Word16) PitchMax ;
    for ( i = 0 ; i < 4 ; i ++ ) {
        if ( Minp > VadStat.Polp[i] )
            Minp = VadStat.Polp[i] ;
    }

    /* Check that all are multiplies of the minimum */
    Tm2 = 0 ;
    for ( i = 0 ; i < 4 ; i ++ ) {
        Tm1 = Minp ;
        for ( j = 0 ; j < 8 ; j ++ ) {
            if (abs((int)(Tm1 - VadStat.Polp[i])) <= 3)
                Tm2++ ;
            Tm1 += Minp;
        }
    }

    /* Update adaptation enable counter if not periodic and not sine */
    if ( (Tm2 == 4) || (CodStat.SinDet < 0) )
        VadStat.Aen += 2 ;
    else
        VadStat.Aen -- ;

    /* Clip it */
    if ( VadStat.Aen > 6 )
        VadStat.Aen = 6 ;
    if ( VadStat.Aen < 0 )
        VadStat.Aen = 0 ;

    /* Inverse filter the data */
    Enr = (float) 0.0;
    for ( i = SubFrLen ; i < Frame ; i ++ ) {
        Acc0 = Dpnt[i];
        for ( j = 0 ; j < LpcOrder ; j ++ )
            Acc0 -= Dpnt[i-j-1] * VadStat.NLpc[j];
        Enr += Acc0 * Acc0;
    }

    /*
     * Scale the rezidual energy.
     */
    Enr = (float)0.5 * (Enr / (float)180.0);

    /* Clip noise level in any case */
    if ( VadStat.Nlev > VadStat.Penr ) {
        VadStat.Nlev = (float)0.25 * VadStat.Nlev + (float)0.75 * VadStat.Penr;
    }

    /* Update the noise level, if adaptation is enabled */
    if ( !VadStat.Aen ) {
        VadStat.Nlev *= (float)33.0 / (float)32.0;
    }
    /* Decay Nlev by small amount */
    else {
        VadStat.Nlev *= (float)2047.0 / (float)2048.0;
    }

    /* Update previous energy */
    VadStat.Penr = Enr;

    /* CLip Noise Level */
    if (VadStat.Nlev < (float) 128.0)
        VadStat.Nlev = (float) 128.0;
    if (VadStat.Nlev > (float) 131071.0)
        VadStat.Nlev = (float) 131071.0;

    /* Compute the threshold */
    Frac = (float) frexp(VadStat.Nlev, &bexp);

    /* VadStat.Nlev = Frac x 2**bexp, where Frac = 0.1bbbbbb...., binary.
     * Isolate the 6 fractional bits 'b', Temp = 0.bbbbbb.
     */
    Temp = ((float)floor(Frac * (float)128.0) / (float)64.0) - (float)1.0;
    Temp = ((float)1.0 - Temp) * ScfTab[18 - bexp] + Temp * ScfTab[17 - bexp];
    Thresh = (Temp * VadStat.Nlev) / (float)4096.0;

    /* Compare with the threshold */
    if (Thresh > Enr)
        VadState = 0 ;

    /* Do the various counters */
    if ( VadState ) {
        VadStat.Vcnt ++ ;
        VadStat.Hcnt ++ ;
    }
    else {
        VadStat.Vcnt -- ;
        if ( VadStat.Vcnt < 0 )
            VadStat.Vcnt = 0 ;
    }

    if ( VadStat.Vcnt >= 2 ) {
        VadStat.Hcnt = 6 ;
        if (VadStat.Vcnt >= 3)
            VadStat.Vcnt = 3;
    }

    if ( VadStat.Hcnt ) {
        VadState = 1 ;
        if ( VadStat.Vcnt == 0 )
            VadStat.Hcnt -- ;
    }

    /* Update Periodicy detector */
    VadStat.Polp[0] = VadStat.Polp[2] ;
    VadStat.Polp[1] = VadStat.Polp[3] ;

    return VadState ;
}

//---------------------------------------------------------------------------
void CCODEC::Init_Encoding()
{
        Init_Coder();
}
//---------------------------------------------------------------------------
void CCODEC::Init_Decoding()
{

       Init_Decod();
       Init_Vad();
       Init_Dec_Cng();

}
//---------------------------------------------------------------------------
void CCODEC::Mem_Encoding(Word16 *Raw_Data, char *Encod_Data)
{
        WrkRate = Rate63;
        int i;

        for(i=0; i < Frame; i++)
        {
          DataBuff[i] = (FLOAT)*(Raw_Data +i);
        }

        Coder(DataBuff,Encod_Data);
}

//---------------------------------------------------------------------------
void CCODEC::Mem_Decoding(Word16 *Raw_Data, char *Encod_Data)
{
        int    i;
        Word16 Obuf[Frame];
        WrkRate = Rate63;

        Decod(RDataBuff,Encod_Data,(Word16) 0);

        for (i=0; i<Frame; i++)
        {

                if (*(RDataBuff+i) < (FLOAT)-32767.5)
                    Obuf[i] = -32768L;
                else if (*(RDataBuff+i) > (FLOAT)32766.5)
                        Obuf[i] = 32767;
                else
                {
                if (*(RDataBuff+i) < 0)
                        Obuf[i] = (Word16) (*(RDataBuff+i)-(FLOAT)0.5);
                else
                        Obuf[i] = (Word16) (*(RDataBuff+i)+(FLOAT)0.5);
                }


           *(Raw_Data+i) = (Word16)Obuf[i];
        }
}
//---------------------------------------------------------------------------
